# StaticArrayInterface.jl

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://docs.sciml.ai/StaticArrayInterface/stable/)
[![CI](https://github.com/JuliaArrays/StaticArrayInterface.jl/workflows/CI/badge.svg)](https://github.com/JuliaArrays/StaticArrayInterface.jl/actions?query=workflow%3ACI)
[![Build status](https://badge.buildkite.com/a2db252d92478e1d7196ee7454004efdfb6ab59496cbac91a2.svg?branch=master)](https://buildkite.com/julialang/StaticArrayInterface-dot-jl)
[![codecov](https://codecov.io/gh/JuliaArrays/StaticArrayInterface.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaArrays/StaticArrayInterface.jl)

The AbstractArray interface in Base Julia does not always enforce static guarantees.
For example, if the size of an array is known at compile time, many of the indexing
schemes are not specialized to make use of that size to build fully optimized code.
In most cases a user should rely on the compiler to deduce the static properties
and perform the optimization. However, some brave souls believe they can beat the
compiler, and this library is for them. 

Functions like `known_length` return values using [Static.jl](https://github.com/SciML/Static.jl)
which encode all of the information at the type level, which in turn forces the
computation to occur at compile time.

## Is This Library About StaticArrays?

No, not necessarily. StaticArrays.jl is one library about array types which have static compile
time information. However, there are many other array types with static compile time information.
The purpose of this library is to be able to write code generic to all of those libraries
which also keep this property of enforcing the computation is at compile time by using
the type space.

## Warning: Compile Times

Because this library enforces things be done at compile time by encoding everything
into types, using it will increase your compile times. You have been warned, now
proceed (with caution).

@test @inferred(StaticArrayInterface.static_size(sv5)) === (StaticInt(5),)
@test @inferred(StaticArrayInterface.static_size(v5)) === (5,)
@test @inferred(StaticArrayInterface.static_size(A)) === (3, 4, 5)
@test @inferred(StaticArrayInterface.static_size(Ap)) === (2, 5)
@test @inferred(StaticArrayInterface.static_size(A)) === size(A)
@test @inferred(StaticArrayInterface.static_size(Ap)) === size(Ap)
@test @inferred(StaticArrayInterface.static_size(R)) === (StaticInt(2),)
@test @inferred(StaticArrayInterface.static_size(Rnr)) === (StaticInt(4),)
@test @inferred(StaticArrayInterface.known_length(Rnr)) === 4
@test @inferred(StaticArrayInterface.static_size(A2)) === (4, 3, 5)
@test @inferred(StaticArrayInterface.static_size(A2r)) === (2, 3, 5)

@test @inferred(StaticArrayInterface.static_size(view(rand(4), reshape(1:4, 2, 2)))) == (2, 2)
@test @inferred(StaticArrayInterface.static_size(irev)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(iprod)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(iflat)) === (static(72),)
@test @inferred(StaticArrayInterface.static_size(igen)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(iacc)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(ienum)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(ipairs)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(izip)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(zip(S, A_trailingdim))) === (StaticInt(2), StaticInt(3), StaticInt(4), static(1))
@test @inferred(StaticArrayInterface.static_size(zip(A_trailingdim, S))) === (StaticInt(2), StaticInt(3), StaticInt(4), static(1))
@test @inferred(StaticArrayInterface.static_size(S)) === (StaticInt(2), StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(Sp)) === (2, 2, StaticInt(3))
@test @inferred(StaticArrayInterface.static_size(Sp2)) === (2, StaticInt(3), StaticInt(2))
@test @inferred(StaticArrayInterface.static_size(S)) == size(S)
@test @inferred(StaticArrayInterface.static_size(Sp)) == size(Sp)
@test @inferred(StaticArrayInterface.static_size(parent(Sp2))) === (static(4), static(3), static(2))
@test @inferred(StaticArrayInterface.static_size(Sp2)) == size(Sp2)
@test @inferred(StaticArrayInterface.static_size(Sp2, StaticInt(1))) === 2
@test @inferred(StaticArrayInterface.static_size(Sp2, StaticInt(2))) === StaticInt(3)
@test @inferred(StaticArrayInterface.static_size(Sp2, StaticInt(3))) === StaticInt(2)
@test @inferred(StaticArrayInterface.static_size(Wrapper(Sp2), StaticInt(3))) === StaticInt(2)
@test @inferred(StaticArrayInterface.static_size(Diagonal([1, 2]))) == size(Diagonal([1, 2]))
@test @inferred(StaticArrayInterface.static_size(Mp)) === (StaticInt(3), StaticInt(4))
@test @inferred(StaticArrayInterface.static_size(Mp2)) === (StaticInt(2), 2)
@test @inferred(StaticArrayInterface.static_size(Mp)) == size(Mp)
@test @inferred(StaticArrayInterface.static_size(Mp2)) == size(Mp2)

@test @inferred(StaticArrayInterface.known_size(1)) === ()
@test @inferred(StaticArrayInterface.known_size(view(rand(4), reshape(1:4, 2, 2)))) == (nothing, nothing)
@test @inferred(StaticArrayInterface.known_size(A)) === (nothing, nothing, nothing)
@test @inferred(StaticArrayInterface.known_size(Ap)) === (nothing, nothing)
@test @inferred(StaticArrayInterface.known_size(Wrapper(Ap))) === (nothing, nothing)
@test @inferred(StaticArrayInterface.known_size(R)) === (2,)
@test @inferred(StaticArrayInterface.known_size(Wrapper(R))) === (2,)
@test @inferred(StaticArrayInterface.known_size(Rnr)) === (4,)
@test @inferred(StaticArrayInterface.known_size(Rnr, static(1))) === 4
@test @inferred(StaticArrayInterface.known_size(Ar)) === (nothing, nothing, nothing,)
@test @inferred(StaticArrayInterface.known_size(Ar, static(1))) === nothing
@test @inferred(StaticArrayInterface.known_size(Ar, static(4))) === 1
@test @inferred(StaticArrayInterface.known_size(A2)) === (nothing, nothing, nothing)
@test @inferred(StaticArrayInterface.known_size(A2r)) === (nothing, nothing, nothing)

@test @inferred(StaticArrayInterface.known_size(irev)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(igen)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(iprod)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(iflat)) === (72,)
@test @inferred(StaticArrayInterface.known_size(iacc)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(ienum)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(izip)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(ipairs)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(zip(S, A_trailingdim))) === (2, 3, 4, 1)
@test @inferred(StaticArrayInterface.known_size(zip(A_trailingdim, S))) === (2, 3, 4, 1)
@test @inferred(StaticArrayInterface.known_length(Iterators.flatten(((x, y) for x in 0:1 for y in 'a':'c')))) === nothing

@test @inferred(StaticArrayInterface.known_size(S)) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(Wrapper(S))) === (2, 3, 4)
@test @inferred(StaticArrayInterface.known_size(Sp)) === (nothing, nothing, 3)
@test @inferred(StaticArrayInterface.known_size(Wrapper(Sp))) === (nothing, nothing, 3)
@test @inferred(StaticArrayInterface.known_size(Sp2)) === (nothing, 3, 2)
@test @inferred(StaticArrayInterface.known_size(Sp2, StaticInt(1))) === nothing
@test @inferred(StaticArrayInterface.known_size(Sp2, StaticInt(2))) === 3
@test @inferred(StaticArrayInterface.known_size(Sp2, StaticInt(3))) === 2
@test @inferred(StaticArrayInterface.known_size(Mp)) === (3, 4)
@test @inferred(StaticArrayInterface.known_size(Mp2)) === (2, nothing)

@testset "known_length" begin
    @test StaticArrayInterface.known_length(1:2) === nothing
    @test StaticArrayInterface.known_length((1,)) == 1
    @test StaticArrayInterface.known_length((a=1, b=2)) == 2
    @test StaticArrayInterface.known_length([]) === nothing
    @test StaticArrayInterface.known_length(CartesianIndex((1, 2, 3))) === 3
    @test @inferred(StaticArrayInterface.known_length(NDIndex((1, 2, 3)))) === 3

    itr = StaticInt(1):StaticInt(10)
    @inferred(StaticArrayInterface.known_length((i for i in itr))) == 10
end

@testset "is_lazy_conjugate" begin
    a = rand(ComplexF64, 2)
    @test @inferred(StaticArrayInterface.is_lazy_conjugate(a)) == false
    b = a'
    @test @inferred(StaticArrayInterface.is_lazy_conjugate(b)) == true
    c = transpose(b)
    @test @inferred(StaticArrayInterface.is_lazy_conjugate(c)) == true
    d = c'
    @test @inferred(StaticArrayInterface.is_lazy_conjugate(d)) == false
    e = permutedims(d)
    @test @inferred(StaticArrayInterface.is_lazy_conjugate(e)) == false
    @test @inferred(StaticArrayInterface.is_lazy_conjugate([1, 2, 3]')) == false # We don't care about conj on `<:Real`
end

using StaticArrayInterface
using Documenter

makedocs(;
    modules=[StaticArrayInterface],
    sitename="StaticArrayInterface.jl",
    pages=[
        "StaticArrayInterface.jl: Static Compile-Time Enforced Array Interface Functionality" => "index.md",
        "API" => "api.md"
    ]
)

deploydocs(;
    repo="github.com/JuliaArrays/StaticArrayInterface.jl"
)

using StaticArrayInterface
using LinearAlgebra
using StaticArrays
using Static
using Test

x = @SVector [1,2,3]
@test @inferred(StaticArrayInterface.device(typeof(x))) === StaticArrayInterface.CPUTuple()

x = @MVector [1,2,3]
@test @inferred(StaticArrayInterface.device(typeof(x))) === StaticArrayInterface.CPUPointer()

@test isone(StaticArrayInterface.known_first(typeof(StaticArrays.SOneTo(7))))
@test StaticArrayInterface.known_last(typeof(StaticArrays.SOneTo(7))) == 7
@test StaticArrayInterface.known_length(typeof(StaticArrays.SOneTo(7))) == 7

@test StaticArrayInterface.parent_type(SizedVector{1, Int, Vector{Int}}) <: Vector{Int}
@test StaticArrayInterface.known_length(@inferred(StaticArrayInterface.indices(SOneTo(7)))) == 7

x = view(SArray{Tuple{3,3,3}}(ones(3,3,3)), :, SOneTo(2), 2)
@test @inferred(StaticArrayInterface.known_length(x)) == 6
@test @inferred(StaticArrayInterface.known_length(x')) == 6

v = @SVector rand(8);
A = @MMatrix rand(7, 6);
T = SizedArray{Tuple{5,4,3}}(zeros(5,4,3));
@test @inferred(StaticArrayInterface.static_length(v)) === StaticInt(8)
@test @inferred(StaticArrayInterface.static_length(A)) === StaticInt(42)
@test @inferred(StaticArrayInterface.static_length(T)) === StaticInt(60)

Am = @MMatrix rand(2,10);
@test @inferred(StaticArrayInterface.static_strides(view(Am,1,:))) === (StaticInt(2),)

@test @inferred(StaticArrayInterface.contiguous_axis(@SArray(zeros(2,2,2)))) === Static.StaticInt(1)
@test @inferred(StaticArrayInterface.contiguous_axis_indicator(@SArray(zeros(2,2,2)))) == (true,false,false)
@test @inferred(StaticArrayInterface.contiguous_batch_size(@SArray(zeros(2,2,2)))) === Static.StaticInt(0)
@test @inferred(StaticArrayInterface.stride_rank(@SArray(zeros(2,2,2)))) == (1, 2, 3)
@test @inferred(StaticArrayInterface.is_column_major(@SArray(zeros(2,2,2)))) === True()
@test @inferred(StaticArrayInterface.dense_dims(@SArray(zeros(2,2,2)))) == (true,true,true)

known_first(::Type{<:OptionallyStaticUnitRange{StaticInt{F}}}) where {F} = F::Int
known_first(::Type{<:OptionallyStaticStepRange{StaticInt{F}}}) where {F} = F::Int

known_step(::Type{<:OptionallyStaticStepRange{<:Any,StaticInt{S}}}) where {S} = S::Int

known_last(::Type{<:OptionallyStaticUnitRange{<:Any,StaticInt{L}}}) where {L} = L::Int
known_last(::Type{<:OptionallyStaticStepRange{<:Any,<:Any,StaticInt{L}}}) where {L} = L::Int

"""
    indices(x, dim) -> AbstractUnitRange{Int}

Given an array `x`, this returns the indices along dimension `dim`.
"""
@inline indices(x, d) = indices(static_axes(x, d))

"""
    indices(x) -> AbstractUnitRange{Int}

Returns valid indices for the entire length of `x`.
"""
@inline function indices(x)
    inds = eachindex(x)
    if inds isa AbstractUnitRange && eltype(inds) <: Integer
        return Base.Slice(OptionallyStaticUnitRange(inds))
    else
        return inds
    end
end
@inline indices(x::AbstractUnitRange{<:Integer}) = Base.Slice(OptionallyStaticUnitRange(x))

"""
    indices(x::Tuple) -> AbstractUnitRange{Int}

Returns valid indices for the entire length of each array in `x`.
"""
@propagate_inbounds function indices(x::Tuple)
    inds = map(eachindex, x)
    return reduce_tup(static_promote, inds)
end

"""
    indices(x::Tuple, dim)  -> AbstractUnitRange{Int}

Returns valid indices for each array in `x` along dimension `dim`
"""
@propagate_inbounds function indices(x::Tuple, dim)
    inds = map(Base.Fix2(indices, dim), x)
    return reduce_tup(static_promote, inds)
end

"""
    indices(x::Tuple, dim::Tuple) -> AbstractUnitRange{Int}

Returns valid indices given a tuple of arrays `x` and tuple of dimesions for each
respective array (`dim`).
"""
@propagate_inbounds function indices(x::Tuple, dim::Tuple)
    inds = map(indices, x, dim)
    return reduce_tup(static_promote, inds)
end

"""
    indices(x, dim::Tuple) -> Tuple{Vararg{AbstractUnitRange{Int}}}

Returns valid indices for array `x` along each dimension specified in `dim`.
"""
@inline indices(x, dims::Tuple) = _indices(x, dims)
_indices(x, dims::Tuple) = (indices(x, first(dims)), _indices(x, tail(dims))...)
_indices(x, ::Tuple{}) = ()

@testset "offsets" begin
    @test @inferred(StaticArrayInterface.known_offsets(A)) === (1, 1, 1)
    @test @inferred(StaticArrayInterface.known_offsets(Ap)) === (1, 1)
    @test @inferred(StaticArrayInterface.known_offsets(Ar)) === (1, 1, 1)
    @test @inferred(StaticArrayInterface.known_offsets(Ar, static(1))) === 1
    @test @inferred(StaticArrayInterface.known_offsets(Ar, static(4))) === 1
    @test @inferred(StaticArrayInterface.known_offsets(A2)) === (1, 1, 1)
    @test @inferred(StaticArrayInterface.known_offsets(A2r)) === (1, 1, 1)
    @test @inferred(StaticArrayInterface.offsets(A)) === (StaticInt(1), StaticInt(1), StaticInt(1))
    @test @inferred(StaticArrayInterface.offsets(Ap)) === (StaticInt(1), StaticInt(1))
    @test @inferred(StaticArrayInterface.offsets(Ar)) === (StaticInt(1), StaticInt(1), StaticInt(1))
    @test @inferred(StaticArrayInterface.offsets(A2)) === (StaticInt(1), StaticInt(1), StaticInt(1))
    @test @inferred(StaticArrayInterface.offsets(A2r)) === (StaticInt(1), StaticInt(1), StaticInt(1))

    @test @inferred(StaticArrayInterface.offsets(S)) === (StaticInt(1), StaticInt(1), StaticInt(1))
    @test @inferred(StaticArrayInterface.offsets(Sp)) === (StaticInt(1), StaticInt(1), StaticInt(1))
    @test @inferred(StaticArrayInterface.offsets(Sp2)) === (StaticInt(1), StaticInt(1), StaticInt(1))

    @test @inferred(StaticArrayInterface.known_offsets(S)) === (1, 1, 1)
    @test @inferred(StaticArrayInterface.known_offsets(Sp)) === (1, 1, 1)
    @test @inferred(StaticArrayInterface.known_offsets(Sp2)) === (1, 1, 1)

    @test @inferred(StaticArrayInterface.known_offsets(R)) === (1,)
    @test @inferred(StaticArrayInterface.known_offsets(Rnr)) === (1,)
    @test @inferred(StaticArrayInterface.known_offsets(1:10)) === (1,)
end

@testset "strides" begin
    @test @inferred(StaticArrayInterface.static_strides(A)) === (StaticInt(1), 3, 12)
    @test @inferred(StaticArrayInterface.static_strides(Ap)) === (StaticInt(1), 12)
    @test @inferred(StaticArrayInterface.static_strides(A)) == strides(A)
    @test @inferred(StaticArrayInterface.static_strides(Ap)) == strides(Ap)
    @test @inferred(StaticArrayInterface.static_strides(Ar)) === (StaticInt{1}(), 6, 24)
    @test @inferred(StaticArrayInterface.static_strides(A2)) === (StaticInt(1), 4, 12)
    @test @inferred(StaticArrayInterface.static_strides(A2r)) === (StaticInt(1), 2, 6)

    @test @inferred(StaticArrayInterface.static_strides(S)) === (StaticInt(1), StaticInt(2), StaticInt(6))
    @test @inferred(StaticArrayInterface.static_strides(Sp)) === (StaticInt(6), StaticInt(1), StaticInt(2))
    @test @inferred(StaticArrayInterface.static_strides(Sp2)) === (StaticInt(6), StaticInt(2), StaticInt(1))
    @test @inferred(StaticArrayInterface.static_strides(view(Sp2, :, 1, 1)')) === (StaticInt(6), StaticInt(6))

    @test @inferred(StaticArrayInterface.static_stride(Sp2, StaticInt(1))) === StaticInt(6)
    @test @inferred(StaticArrayInterface.static_stride(Sp2, StaticInt(2))) === StaticInt(2)
    @test @inferred(StaticArrayInterface.static_stride(Sp2, StaticInt(3))) === StaticInt(1)
    @test @inferred(StaticArrayInterface.static_strides(Mp)) === (StaticInt(2), StaticInt(6))
    @test @inferred(StaticArrayInterface.static_strides(Mp2)) === (StaticInt(1), StaticInt(6))
    @test @inferred(StaticArrayInterface.static_strides(Mp)) == strides(Mp)
    @test @inferred(StaticArrayInterface.static_strides(Mp2)) == strides(Mp2)

    @test_throws MethodError StaticArrayInterface.static_strides(DummyZeros(3,4))

    @test @inferred(StaticArrayInterface.known_strides(A)) === (1, nothing, nothing)
    @test @inferred(StaticArrayInterface.known_strides(Ap)) === (1, nothing)
    @test @inferred(StaticArrayInterface.known_strides(Ar)) === (1, nothing, nothing)
    @test @inferred(StaticArrayInterface.known_strides(reshape(view(zeros(100), 1:60), (3,4,5)))) === (1, nothing, nothing)
    @test @inferred(StaticArrayInterface.known_strides(A2)) === (1, nothing, nothing)
    @test @inferred(StaticArrayInterface.known_strides(A2r)) === (1, nothing, nothing)

    @test @inferred(StaticArrayInterface.known_strides(S)) === (1, 2, 6)
    @test @inferred(StaticArrayInterface.known_strides(Sp)) === (6, 1, 2)
    @test @inferred(StaticArrayInterface.known_strides(Sp2)) === (6, 2, 1)
    @test @inferred(StaticArrayInterface.known_strides(Sp2, StaticInt(1))) === 6
    @test @inferred(StaticArrayInterface.known_strides(Sp2, StaticInt(2))) === 2
    @test @inferred(StaticArrayInterface.known_strides(Sp2, StaticInt(3))) === 1
    @test @inferred(StaticArrayInterface.known_strides(Sp2, StaticInt(4))) === StaticArrayInterface.known_length(Sp2)
    @test @inferred(StaticArrayInterface.known_strides(view(Sp2, :, 1, 1)')) === (6, 6)
end

@testset "Static-Dynamic Size, Strides, and Offsets" begin
    colors = [(R = rand(), G = rand(), B = rand()) for i ∈ 1:100];

    colormat = reinterpret(reshape, Float64, colors)
    @test @inferred(StaticArrayInterface.static_strides(colormat)) === (StaticInt(1), StaticInt(3))
    @test @inferred(StaticArrayInterface.dense_dims(colormat)) === (True(),True())
    @test @inferred(StaticArrayInterface.dense_dims(view(colormat,:,4))) === (True(),)
    @test @inferred(StaticArrayInterface.dense_dims(view(colormat,:,4:7))) === (True(),True())
    @test @inferred(StaticArrayInterface.dense_dims(view(colormat,2:3,:))) === (True(),False())

    Rr = reinterpret(reshape, Int32, R)
    @test @inferred(StaticArrayInterface.static_axes(Rr)) === (static(1):static(2), static(1):static(2))
    @test @inferred(StaticArrayInterface.known_size(Rr)) === (2, 2)

    Sr = Wrapper(reinterpret(reshape, Complex{Int64}, S))
    @test @inferred(StaticArrayInterface.static_axes(Sr)) == (static(1):static(3), static(1):static(4))
    @test @inferred(StaticArrayInterface.known_size(Sr)) === (3, 4)
    @test @inferred(StaticArrayInterface.static_strides(Sr)) === (static(1), static(3))
    Sr2 = reinterpret(reshape, Complex{Int64}, S);
    @test @inferred(StaticArrayInterface.dense_dims(Sr2)) === (True(),True())
    @test @inferred(StaticArrayInterface.dense_dims(view(Sr2,:,2))) === (True(),)
    @test @inferred(StaticArrayInterface.dense_dims(view(Sr2,:,2:3))) === (True(),True())
    @test @inferred(StaticArrayInterface.dense_dims(view(Sr2,2:3,:))) === (True(),False())

    Ar2c = reinterpret(reshape, Complex{Float64}, view(rand(2, 5, 7), :, 2:4, 3:5));
    @test @inferred(StaticArrayInterface.static_strides(Ar2c)) === (StaticInt(1), 5)
    Ar2c′ = reinterpret(reshape, Complex{Float64}, view(rand(4, 5, 7), Base.oneto(2), 2:4, 3:5));
    @test @inferred(StaticArrayInterface.static_strides(Ar2c′)) === (2, 10)
    Ar2c″ = reinterpret(reshape, Complex{Float64}, view(rand(3, 5, 7), Base.oneto(2), 2:4, 3:5));
    @test_throws ArgumentError StaticArrayInterface.static_strides(Ar2c″)
    Ar2c_static = reinterpret(reshape, Complex{Float64}, view(MArray(rand(2, 5, 7)), :, 2:4, 3:5));
    @test @inferred(StaticArrayInterface.static_strides(Ar2c_static)) === (StaticInt(1), StaticInt(5))

    Ac2r = reinterpret(reshape, Float64, view(rand(ComplexF64, 5, 7), 2:4, 3:6));
    @test @inferred(StaticArrayInterface.static_strides(Ac2r)) === (StaticInt(1), StaticInt(2), 10)
    Ac2r_static = reinterpret(reshape, Float64, view(MArray(rand(ComplexF64, 5, 7)), 2:4, 3:6));
    @test @inferred(StaticArrayInterface.static_strides(Ac2r_static)) === (StaticInt(1), StaticInt(2), StaticInt(10))

    Ac2t = reinterpret(reshape, Tuple{Float64,Float64}, view(rand(ComplexF64, 5, 7), 2:4, 3:6));
    @test @inferred(StaticArrayInterface.static_strides(Ac2t)) === (StaticInt(1), 5)
    Ac2t_static = reinterpret(reshape, Tuple{Float64,Float64}, view(MArray(rand(ComplexF64, 5, 7)), 2:4, 3:6));
    @test @inferred(StaticArrayInterface.static_strides(Ac2t_static)) === (StaticInt(1), StaticInt(5))

    a = rand(Float32, 100, 2);
    b = reinterpret(Float64, view(a,:,1));
    @test @inferred(StaticArrayInterface.contiguous_axis(a)) === StaticInt(1)
    @test @inferred(StaticArrayInterface.stride_rank(b)) === (StaticInt(1),)
end

@testset "Memory Layout" begin
    x = zeros(100);
    @test StaticArrayInterface.static_axes(Base.Broadcast.Broadcasted(+, (x, x'))) === (Base.OneTo(100), Base.OneTo(100))
    # R = reshape(view(x, 1:100), (10,10));
    # A = zeros(3,4,5);
    A = Wrapper(reshape(view(x, 1:60), (3,4,5)));
    B = A .== 0;
    D1 = view(A, 1:2:3, :, :);  # first dimension is discontiguous
    D2 = view(A, :, 2:2:4, :);  # first dimension is contiguous

    @test @inferred(StaticArrayInterface.defines_strides(x))
    @test @inferred(StaticArrayInterface.defines_strides(A))
    @test @inferred(StaticArrayInterface.defines_strides(D1))
    @test !@inferred(StaticArrayInterface.defines_strides(view(A, :, [1,2],1)))
    @test @inferred(StaticArrayInterface.defines_strides(DenseWrapper{Int,2,Matrix{Int}}))

    @test @inferred(StaticArrayInterface.device(A)) === StaticArrayInterface.CPUPointer()
    @test @inferred(StaticArrayInterface.device(B)) === StaticArrayInterface.CPUIndex()
    @test @inferred(StaticArrayInterface.device(-1:19)) === StaticArrayInterface.CPUIndex()
    @test @inferred(StaticArrayInterface.device((1,2,3))) === StaticArrayInterface.CPUTuple()
    @test @inferred(StaticArrayInterface.device(PermutedDimsArray(A,(3,1,2)))) === StaticArrayInterface.CPUPointer()
    @test @inferred(StaticArrayInterface.device(view(A, 1, :, 2:4))) === StaticArrayInterface.CPUPointer()
    @test @inferred(StaticArrayInterface.device(view(A, 1, :, 2:4)')) === StaticArrayInterface.CPUPointer()
    @test isnothing(StaticArrayInterface.device("Hello, world!"))
    @test @inferred(StaticArrayInterface.device(DenseWrapper{Int,2,Matrix{Int}})) === StaticArrayInterface.CPUPointer()
    #=
    @btime StaticArrayInterface.contiguous_axis($(reshape(view(zeros(100), 1:60), (3,4,5))))
      0.047 ns (0 allocations: 0 bytes)
    =#
    @test @inferred(StaticArrayInterface.contiguous_axis(A)) === Static.StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(B)) === Static.StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(-1:19)) === Static.StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(D1)) === Static.StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_axis(D2)) === Static.StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(PermutedDimsArray(A,(3,1,2)))) === Static.StaticInt(2)
    @test @inferred(StaticArrayInterface.contiguous_axis(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))) === Static.StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(transpose(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])))) === Static.StaticInt(2)
    @test @inferred(StaticArrayInterface.contiguous_axis(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) === Static.StaticInt(2)
    @test @inferred(StaticArrayInterface.contiguous_axis(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:]))) === Static.StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_axis(PermutedDimsArray(@view(A[2,:,:]),(2,1)))) === Static.StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_axis(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])')) === Static.StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_axis(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])')) === Static.StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis((3,4))) === StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(rand(4)')) === StaticInt(2)
    @test @inferred(StaticArrayInterface.contiguous_axis(view(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])', :, 1)')) === StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_axis(reshape(DummyZeros(3,4), (4, 3)))) === nothing
    @test @inferred(StaticArrayInterface.contiguous_axis(DummyZeros(3,4))) === nothing
    @test @inferred(StaticArrayInterface.contiguous_axis(PermutedDimsArray(DummyZeros(3,4), (2, 1)))) === nothing
    @test @inferred(StaticArrayInterface.contiguous_axis(view(DummyZeros(3,4), 1, :))) === nothing
    @test @inferred(StaticArrayInterface.contiguous_axis(view(DummyZeros(3,4), 1, :)')) === nothing


    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(A)) == (true,false,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(B)) == (true,false,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(-1:10)) == (true,)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(PermutedDimsArray(A,(3,1,2)))) == (false,true,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))) == (true,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])')) == (false,true)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) == (false,true,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:]))) == (false,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])')) == (false,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])')) == (true,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,[1,3,4]]))) == (false,true,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(DummyZeros(3,4))) === nothing

    @test @inferred(StaticArrayInterface.contiguous_batch_size(A)) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(B)) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(-1:18)) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(PermutedDimsArray(A,(3,1,2)))) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])')) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:]))) === Static.StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])')) === Static.StaticInt(-1)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])')) === Static.StaticInt(0)
    let u_base = randn(10, 10)
        u_view = view(u_base, 3, :)
        u_reshaped_view = reshape(u_view, 1, size(u_base, 2))
        @test @inferred(StaticArrayInterface.contiguous_batch_size(u_view)) === Static.StaticInt(-1)
        @test @inferred(StaticArrayInterface.contiguous_batch_size(u_reshaped_view)) === Static.StaticInt(-1)
    end

    @test @inferred(StaticArrayInterface.stride_rank(A)) == (1,2,3)
    @test @inferred(StaticArrayInterface.stride_rank(B)) == (1,2,3)
    @test @inferred(StaticArrayInterface.stride_rank(-4:4)) == (1,)
    @test @inferred(StaticArrayInterface.stride_rank(view(A,:,:,1))) === (static(1), static(2))
    @test @inferred(StaticArrayInterface.stride_rank(view(A,:,:,1))) === ((Static.StaticInt(1),Static.StaticInt(2)))
    @test @inferred(StaticArrayInterface.stride_rank(PermutedDimsArray(A,(3,1,2)))) == (3, 1, 2)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))) == (1, 2)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])')) == (2, 1)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) == (3, 1, 2)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:]))) == (3, 2)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])')) == (2, 3)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])')) == (1, 3)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[:,2,1])')) == (2, 1)
    @test @inferred(StaticArrayInterface.stride_rank(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,[1,3,4]]))) == (3, 1, 2)
    @test @inferred(StaticArrayInterface.stride_rank(DummyZeros(3,4)')) === nothing
    @test @inferred(StaticArrayInterface.stride_rank(PermutedDimsArray(DummyZeros(3,4), (2, 1)))) === nothing
    @test @inferred(StaticArrayInterface.stride_rank(view(DummyZeros(3,4), 1, :))) === nothing
    uA = reinterpret(reshape, UInt64, A)
    @test @inferred(StaticArrayInterface.stride_rank(uA)) === StaticArrayInterface.stride_rank(A)
    rA = reinterpret(reshape, NTuple{3,Float64}, A)
    @test @inferred(StaticArrayInterface.stride_rank(rA)) === (static(1), static(2))
    cA = copy(rA)
    rcA = reinterpret(reshape, Float64, cA)
    @test @inferred(StaticArrayInterface.stride_rank(rcA)) === StaticArrayInterface.stride_rank(A)

    #=
    @btime StaticArrayInterface.is_column_major($(PermutedDimsArray(A,(3,1,2))))
      0.047 ns (0 allocations: 0 bytes)
    @btime StaticArrayInterface.is_column_major($(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))))
      0.047 ns (0 allocations: 0 bytes)
    @btime StaticArrayInterface.is_column_major($(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])')))
      0.047 ns (0 allocations: 0 bytes)

      PermutedDimsArray(A,(3,1,2))[2:3,1:2,:])
      @view(PermutedDimsArray(reshape(view(zeros(100), 1:60), (3,4,5)), (3,1,2)), 2:3, 1:2, :)
    =#

    @test @inferred(StaticArrayInterface.is_column_major(A)) === True()
    @test @inferred(StaticArrayInterface.is_column_major(B)) === True()
    @test @inferred(StaticArrayInterface.is_column_major(-4:7)) === False()
    @test @inferred(StaticArrayInterface.is_column_major(PermutedDimsArray(A,(3,1,2)))) === False()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))) === True()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])')) === False()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) === False()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:]))) === False()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])')) === True()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])')) === True()
    @test @inferred(StaticArrayInterface.is_column_major(@view(PermutedDimsArray(A,(3,1,2))[:,2,1])')) === False()
    @test @inferred(StaticArrayInterface.is_column_major(2.3)) === False()

    @test @inferred(StaticArrayInterface.dense_dims(A)) == (true,true,true)
    @test @inferred(StaticArrayInterface.dense_dims(B)) == (true,true,true)
    @test @inferred(StaticArrayInterface.dense_dims(-3:9)) == (true,)
    @test @inferred(StaticArrayInterface.dense_dims(PermutedDimsArray(A,(3,1,2)))) == (true,true,true)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:]))) == (true,false)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2,1:2,:])')) == (false,true)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) == (false,true,false)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2:3,:,1:2]))) == (false,true,true)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:]))) == (false,false)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2:3,2,:])')) == (false,false)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])')) == (true,false)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2:3,:,[1,2]]))) == (false,true,false)
    @test @inferred(StaticArrayInterface.dense_dims(@view(PermutedDimsArray(A,(3,1,2))[2:3,[1,2,3],:]))) == (false,false,false)
    @test @inferred(StaticArrayInterface.dense_dims(reshape(view(randn(10, 10, 10), 3, :, :), 1, 100))) == (false, false)
    # TODO Currently Wrapper can't function the same as Array because Array can change
    # the dimensions on reshape. We should be rewrapping the result in `Wrapper` but we
    # first need to develop a standard method for reconstructing arrays
    @test @inferred(StaticArrayInterface.dense_dims(vec(parent(A)))) == (true,)
    @test @inferred(StaticArrayInterface.dense_dims(vec(parent(A))')) == (true,true)
    @test @inferred(StaticArrayInterface.dense_dims(DummyZeros(3,4))) === nothing
    @test @inferred(StaticArrayInterface.dense_dims(DummyZeros(3,4)')) === nothing
    @test @inferred(StaticArrayInterface.dense_dims(PermutedDimsArray(DummyZeros(3,4), (2, 1)))) === nothing
    @test @inferred(StaticArrayInterface.dense_dims(view(DummyZeros(3,4), :, 1))) === nothing
    @test @inferred(StaticArrayInterface.dense_dims(view(DummyZeros(3,4), :, 1)')) === nothing
    @test @inferred(StaticArrayInterface.is_dense(A)) === @inferred(StaticArrayInterface.is_dense(A)) === @inferred(StaticArrayInterface.is_dense(PermutedDimsArray(A,(3,1,2)))) === @inferred(StaticArrayInterface.is_dense(Array{Float64,0}(undef))) === True()
    @test @inferred(StaticArrayInterface.is_dense(@view(PermutedDimsArray(A,(3,1,2))[2:3,1:2,:]))) === @inferred(StaticArrayInterface.is_dense(@view(PermutedDimsArray(A,(3,1,2))[2:3,:,[1,2]]))) === @inferred(StaticArrayInterface.is_dense(@view(PermutedDimsArray(A,(3,1,2))[2:3,[1,2,3],:]))) === False()

    C = Array{Int8}(undef, 2,2,2,2);
    doubleperm = PermutedDimsArray(PermutedDimsArray(C,(4,2,3,1)), (4,2,1,3));
    @test collect(strides(C))[collect(StaticArrayInterface.stride_rank(doubleperm))] == collect(strides(doubleperm))

    C1 = reinterpret(reshape, Float64, PermutedDimsArray(Array{Complex{Float64}}(undef, 3,4,5), (2,1,3)));
    C2 = reinterpret(reshape, Complex{Float64}, PermutedDimsArray(view(A,1:2,:,:), (1,3,2)));
    C3 = reinterpret(reshape, Complex{Float64}, PermutedDimsArray(Wrapper(reshape(view(x, 1:24), (2,3,4))), (1,3,2)));

    @test @inferred(StaticArrayInterface.defines_strides(C1))
    @test @inferred(StaticArrayInterface.defines_strides(C2))
    @test @inferred(StaticArrayInterface.defines_strides(C3))

    @test @inferred(StaticArrayInterface.device(C1)) === StaticArrayInterface.CPUPointer()
    @test @inferred(StaticArrayInterface.device(C2)) === StaticArrayInterface.CPUPointer()
    @test @inferred(StaticArrayInterface.device(C3)) === StaticArrayInterface.CPUPointer()

    @test @inferred(StaticArrayInterface.contiguous_batch_size(C1)) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(C2)) === Static.StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_batch_size(C3)) === Static.StaticInt(0)

    @test @inferred(StaticArrayInterface.stride_rank(C1)) == (1,3,2,4)
    @test @inferred(StaticArrayInterface.stride_rank(C2)) == (2,1)
    @test @inferred(StaticArrayInterface.stride_rank(C3)) == (2,1)

    @test @inferred(StaticArrayInterface.contiguous_axis(C1)) === StaticInt(1)
    @test @inferred(StaticArrayInterface.contiguous_axis(C2)) === StaticInt(0)
    @test @inferred(StaticArrayInterface.contiguous_axis(C3)) === StaticInt(2)

    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(C1)) == (true,false,false,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(C2)) == (false,false)
    @test @inferred(StaticArrayInterface.contiguous_axis_indicator(C3)) == (false,true)

    @test @inferred(StaticArrayInterface.is_column_major(C1)) === False()
    @test @inferred(StaticArrayInterface.is_column_major(C2)) === False()
    @test @inferred(StaticArrayInterface.is_column_major(C3)) === False()

    @test @inferred(StaticArrayInterface.dense_dims(C1)) == (true,true,true,true)
    @test @inferred(StaticArrayInterface.dense_dims(C2)) == (false,false)
    @test @inferred(StaticArrayInterface.dense_dims(C3)) == (true,true)
end

@testset "Reinterpreted reshaped views" begin
    u_base = randn(1, 4, 4, 5);
    u_reinterpreted = reinterpret(Int8, view(u_base, 1:1, 1:4, 1:4, 1:5))
    u_vectors = reshape(reinterpret(NTuple{1, eltype(u_base)}, u_base),
                        Base.tail(size(u_base))...)
    u_view = view(u_vectors, 2, :, 3)
    u_view_reinterpreted = reinterpret(eltype(u_base), u_view)
    u_view_reshaped = reshape(u_view_reinterpreted, 1, length(u_view))
    # See https://github.com/JuliaArrays/StaticArrayInterface.jl/issues/163
    @test @inferred(StaticArrayInterface.static_strides(u_base)) === (StaticInt(1), 1, 4, 16)
    @test @inferred(StaticArrayInterface.static_strides(u_reinterpreted)) === (StaticInt(1), 8, 32, 128)
    @test @inferred(StaticArrayInterface.static_strides(u_vectors)) === (StaticInt(1), 4, 16)
    @test @inferred(StaticArrayInterface.static_strides(u_view)) === (4,)
    @test @inferred(StaticArrayInterface.static_strides(u_view_reinterpreted)) === (4,)
    @test @inferred(StaticArrayInterface.static_strides(u_view_reshaped)) === (4, 4)
    @test @inferred(StaticArrayInterface.static_axes(u_vectors)) isa StaticArrayInterface.axes_types(u_vectors)
end

@testset "Reshaped strides" begin
    a = randn(10, 10)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, :, 1:2:9), 2, 5, 5))) === (1, 2, 20)
    @test @inferred(StaticArrayInterface.static_strides(vec(view(a, 1, 1)))) === (static(1),)
    @test_throws ArgumentError StaticArrayInterface.static_strides(reshape(view(a, :, 1:2:9), 5, 5, 2))
    a = MArray(randn(10, 10))
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, 1:9, 1:10), 3, 3, 2, 5))) === (1, 3, 10, 20)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, static(1):static(9), 1:10), 3, 3, 2, 5))) === (static(1), 3, 10, 20)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, :, 1:2:9), 2, 5, 5))) === (static(1), 2, 20)
    a = randn(2, 5, 3)
    @test @inferred(StaticArrayInterface.static_strides(vec(view(a, :, 1:5, 1:3)))) === (1,)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, :, 1:5, 1:3), 5, 2, 3))) === (1,5,10)
    @test @inferred(StaticArrayInterface.static_strides(vec(view(a, static(1):static(2), 1:5, 1:3)))) === (static(1),)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, static(1):static(2), 1:5, 1:3), 5, 2, 3))) === (static(1),5,10)
    a = MArray(randn(3, 5, 3))
    @test @inferred(StaticArrayInterface.static_strides(vec(view(a, :, 1:5, 1:3)))) === (static(1),)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, static(1):static(3), static(1):static(4), 1:3), 2, 2, 3, 3))) === (static(1), 2, 4, 15)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, static(1):static(2), static(1):static(4), 1:3), 2, 2, 2, 3))) === (static(1), 3, 6, 15)
    @test @inferred(StaticArrayInterface.static_strides(reshape(view(a, static(1):static(2), static(1):static(1), 1:3), 2, 1, 3))) === (static(1), 2, 15)
end

@testset "Reshaped views" begin
    u_base = randn(10, 10)
    u_view = view(u_base, 3, :)
    u_reshaped_view1 = reshape(u_view, 1, :)
    u_reshaped_view2 = reshape(u_view, 2, :)

    @test @inferred(StaticArrayInterface.defines_strides(u_base))
    @test @inferred(StaticArrayInterface.defines_strides(u_view))
    @test @inferred(StaticArrayInterface.defines_strides(u_reshaped_view1))
    @test @inferred(StaticArrayInterface.defines_strides(u_reshaped_view2))

    # See https://github.com/JuliaArrays/StaticArrayInterface.jl/issues/160
    @test @inferred(StaticArrayInterface.static_strides(u_base)) == (StaticInt(1), 10)
    @test @inferred(StaticArrayInterface.static_strides(u_view)) == (10,)
    @test @inferred(StaticArrayInterface.static_strides(u_reshaped_view1)) == (10, 10)
    @test @inferred(StaticArrayInterface.static_strides(u_reshaped_view2)) == (10, 20)

    # See https://github.com/JuliaArrays/StaticArrayInterface.jl/issues/157
    @test @inferred(StaticArrayInterface.dense_dims(u_base)) == (True(), True())
    @test @inferred(StaticArrayInterface.dense_dims(u_view)) == (False(),)
    @test @inferred(StaticArrayInterface.dense_dims(u_reshaped_view1)) == (False(), False())
    @test @inferred(StaticArrayInterface.dense_dims(u_reshaped_view2)) == (False(), False())
end

s5 = static(1):static(5)
s4 = static(1):static(4)
s1 = static(1):static(1)
d5 = static(1):5
d4 = static(1):static(4)
d1 = static(1):static(1)

struct DummyBroadcast <: StaticArrayInterface.BroadcastAxis end

struct DummyAxis end

StaticArrayInterface.BroadcastAxis(::Type{DummyAxis}) = DummyBroadcast()

StaticArrayInterface.broadcast_axis(::DummyBroadcast, x, y) = y

@inferred(StaticArrayInterface.broadcast_axis(s1, s1)) === s1
@inferred(StaticArrayInterface.broadcast_axis(s5, s5)) === s5
@inferred(StaticArrayInterface.broadcast_axis(s5, s1)) === s5
@inferred(StaticArrayInterface.broadcast_axis(s1, s5)) === s5
@inferred(StaticArrayInterface.broadcast_axis(s5, d5)) === s5
@inferred(StaticArrayInterface.broadcast_axis(d5, s5)) === s5
@inferred(StaticArrayInterface.broadcast_axis(d5, d1)) === d5
@inferred(StaticArrayInterface.broadcast_axis(d1, d5)) === d5
@inferred(StaticArrayInterface.broadcast_axis(s1, d5)) === d5
@inferred(StaticArrayInterface.broadcast_axis(d5, s1)) === d5
@inferred(StaticArrayInterface.broadcast_axis(s5, DummyAxis())) === s5

@test_throws DimensionMismatch StaticArrayInterface.broadcast_axis(s5, s4)

struct BroadcastAxisDefault <: BroadcastAxis end

BroadcastAxis(x) = BroadcastAxis(typeof(x))
BroadcastAxis(::Type{T}) where {T} = BroadcastAxisDefault()

"""
    broadcast_axis(x, y)

Broadcast axis `x` and `y` into a common space. The resulting axis should be equal in length
to both `x` and `y` unless one has a length of `1`, in which case the longest axis will be
equal to the output.

```julia
julia> broadcast_axis(1:10, 1:10)

julia> broadcast_axis(1:10, 1)
1:10

```
"""
broadcast_axis(x, y) = broadcast_axis(BroadcastAxis(x), x, y)
# stagger default broadcasting in case y has something other than default
broadcast_axis(::BroadcastAxisDefault, x, y) = _broadcast_axis(BroadcastAxis(y), x, y)
function _broadcast_axis(::BroadcastAxisDefault, x, y)
    return One():_combine_length(static_length(x), static_length(y))
end
_broadcast_axis(s::BroadcastAxis, x, y) = broadcast_axis(s, x, y)

# we can use a similar trick as we do with `indices` where unequal sizes error and we just
# keep the static value. However, axes can be unequal if one of them is `1` so we have to
# fall back to dynamic values in those cases
_combine_length(x::StaticInt{X}, y::StaticInt{Y}) where {X,Y} = static(_combine_length(X, Y))
_combine_length(x::StaticInt{X}, ::Int) where {X} = x
_combine_length(x::StaticInt{1}, y::Int) = y
_combine_length(x::StaticInt{1}, y::StaticInt{1}) = y
_combine_length(x::Int, y::StaticInt{Y}) where {Y} = y
_combine_length(x::Int, y::StaticInt{1}) = x
@inline function _combine_length(x::Int, y::Int)
    if x === y
        return x
    elseif y === 1
        return x
    elseif x === 1
        return y
    else
        _dimerr(x, y)
    end
end

function _dimerr(@nospecialize(x), @nospecialize(y))
    throw(DimensionMismatch("axes could not be broadcast to a common size; " *
                            "got axes with lengths $(x) and $(y)"))
end

using StaticArrayInterface, Static, LinearAlgebra, Test

struct MArray{T,N,R} <: DenseArray{T,N}
    parent::Array{T,N}
    indices::LinearIndices{N,R}
end

MArray(A::Array) = MArray(A, LinearIndices(map(s -> static(1):static(s), size(A))))
Base.parent(x::MArray) = x.parent
Base.IndexStyle(::Type{<:MArray}) = IndexLinear()
StaticArrayInterface.static_axes(x::MArray) = StaticArrayInterface.static_axes(x.indices)
Base.axes(x::MArray) = StaticArrayInterface.static_axes(x)
StaticArrayInterface.axes_types(T::Type{<:MArray}) = T.parameters[3]
StaticArrayInterface.defines_strides(::Type{<:MArray}) = true
Base.strides(x::MArray) = strides(parent(x))
function Base.getindex(x::MArray, inds...)
    @boundscheck checkbounds(x, inds...)
    @inbounds parent(x)[inds...]
end

Base.size(x::MArray) = map(Int, StaticArrayInterface.static_size(x))
struct NamedDimsWrapper{D,T,N,P<:AbstractArray{T,N}} <: StaticArrayInterface.AbstractArray2{T,N}
    dimnames::D
    parent::P
    NamedDimsWrapper(d::D, p::P) where {D,P} = new{D,eltype(P),ndims(p),P}(d, p)
end
StaticArrayInterface.is_forwarding_wrapper(::Type{<:NamedDimsWrapper}) = true
Base.parent(x::NamedDimsWrapper) = getfield(x, :parent)
StaticArrayInterface.parent_type(::Type{T}) where {P,T<:NamedDimsWrapper{<:Any,<:Any,<:Any,P}} = P
StaticArrayInterface.dimnames(x::NamedDimsWrapper) = getfield(x, :dimnames)
function StaticArrayInterface.known_dimnames(::Type{T}) where {L,T<:NamedDimsWrapper{L}}
    Static.known(L)
end

# Dummy array type with undetermined contiguity properties
struct DummyZeros{T,N} <: AbstractArray{T,N}
    dims :: Dims{N}
    DummyZeros{T}(dims...) where {T} = new{T,length(dims)}(dims)
end
DummyZeros(dims...) = DummyZeros{Float64}(dims...)
Base.size(x::DummyZeros) = x.dims
Base.getindex(::DummyZeros{T}, inds...) where {T} = zero(T)

struct Wrapper{T,N,P<:AbstractArray{T,N}} <: StaticArrayInterface.AbstractArray2{T,N}
    parent::P
end
StaticArrayInterface.parent_type(::Type{<:Wrapper{T,N,P}}) where {T,N,P} = P
Base.parent(x::Wrapper) = x.parent
StaticArrayInterface.is_forwarding_wrapper(::Type{<:Wrapper}) = true

struct DenseWrapper{T,N,P<:AbstractArray{T,N}} <: DenseArray{T,N} end
StaticArrayInterface.parent_type(::Type{DenseWrapper{T,N,P}}) where {T,N,P} = P

@test isone(@inferred(StaticArrayInterface.known_first(typeof(static(1):2:10))))
@test isone(@inferred(StaticArrayInterface.known_last(typeof(static(-1):static(2):static(1)))))

# CartesianIndices
CI = CartesianIndices((static(1):static(2), static(1):static(2)))
@test @inferred(StaticArrayInterface.known_last(typeof(CI))) == CartesianIndex(2, 2)

@testset "length" begin
    @test @inferred(StaticArrayInterface.known_length(typeof(Static.OptionallyStaticStepRange(static(1), 2, 10)))) === nothing
    @test @inferred(StaticArrayInterface.known_length(typeof(Static.SOneTo{-10}()))) === 0
    @test @inferred(StaticArrayInterface.known_length(typeof(Static.OptionallyStaticStepRange(static(1), static(1), static(10))))) === 10
    @test @inferred(StaticArrayInterface.known_length(typeof(Static.OptionallyStaticStepRange(static(2), static(1), static(10))))) === 9
    @test @inferred(StaticArrayInterface.known_length(typeof(Static.OptionallyStaticStepRange(static(2), static(2), static(10))))) === 5
    @test @inferred(StaticArrayInterface.known_length(Int)) === 1
end

@testset "indices" begin
    A23 = ones(2,3);
    SA23 = MArray(A23);
    A32 = ones(3,2);
    SA32 = MArray(A32);

    @test @inferred(StaticArrayInterface.indices(A23, (static(1),static(2)))) === (Base.Slice(StaticInt(1):2), Base.Slice(StaticInt(1):3))
    @test @inferred(StaticArrayInterface.indices((A23, A32))) == 1:6
    @test @inferred(StaticArrayInterface.indices((SA23, A32))) == 1:6
    @test @inferred(StaticArrayInterface.indices((A23, SA32))) == 1:6
    @test @inferred(StaticArrayInterface.indices((SA23, SA32))) == 1:6
    @test @inferred(StaticArrayInterface.indices(A23)) == 1:6
    @test @inferred(StaticArrayInterface.indices(SA23)) == 1:6
    @test @inferred(StaticArrayInterface.indices(A23, 1)) == 1:2
    @test @inferred(StaticArrayInterface.indices(SA23, StaticInt(1))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((A23, A32), (1, 2))) == 1:2
    @test @inferred(StaticArrayInterface.indices((SA23, A32), (StaticInt(1), 2))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((A23, SA32), (1, StaticInt(2)))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((SA23, SA32), (StaticInt(1), StaticInt(2)))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((A23, A23), 1)) == 1:2
    @test @inferred(StaticArrayInterface.indices((SA23, SA23), StaticInt(1))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((SA23, A23), StaticInt(1))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((A23, SA23), StaticInt(1))) === Base.Slice(StaticInt(1):StaticInt(2))
    @test @inferred(StaticArrayInterface.indices((SA23, SA23), StaticInt(1))) === Base.Slice(StaticInt(1):StaticInt(2))

    @test_throws ErrorException StaticArrayInterface.indices((A23, ones(3, 3)), 1)
    @test_throws ErrorException StaticArrayInterface.indices((A23, ones(3, 3)), (1, 2))
    @test_throws ErrorException StaticArrayInterface.indices((SA23, ones(3, 3)), StaticInt(1))
    @test_throws ErrorException StaticArrayInterface.indices((SA23, ones(3, 3)), (StaticInt(1), 2))
    @test_throws ErrorException StaticArrayInterface.indices((SA23, SA23), (StaticInt(1), StaticInt(2)))

    @test size(similar(ones(2, 4), StaticArrayInterface.indices(ones(2, 4), 1), StaticArrayInterface.indices(ones(2, 4), 2))) == (2, 4)
    @test axes(StaticArrayInterface.indices(ones(2,2))) === (StaticInt(1):4,)
    @test axes(Base.Slice(StaticInt(2):4)) === (Base.IdentityUnitRange(StaticInt(2):4),)
    @test Base.axes1(StaticArrayInterface.indices(ones(2,2))) === StaticInt(1):4
    @test Base.axes1(Base.Slice(StaticInt(2):4)) === Base.IdentityUnitRange(StaticInt(2):4)

    x = vec(A23); y = vec(A32);
    @test StaticArrayInterface.indices((x',y'),StaticInt(1)) === Base.Slice(StaticInt(1):StaticInt(1))
    @test StaticArrayInterface.indices((x,y), StaticInt(2)) === Base.Slice(StaticInt(1):StaticInt(1))
end

@inline function StrideIndex{N,R,C}(a::A) where {N,R,C,A}
    return StrideIndex{N,R,C}(static_strides(a), offsets(a))
end
@inline function StrideIndex(a::A) where {A}
    return StrideIndex{ndims(A),known(stride_rank(A)),known(contiguous_axis(A))}(a)
end

## getindex
@propagate_inbounds Base.getindex(x::ArrayIndex, i::IntType, ii::IntType...) = x[NDIndex(i, ii...)]

@inline function Base.getindex(x::StrideIndex{N}, i::AbstractCartesianIndex) where {N}
    return _strides2int(offsets(x), static_strides(x), Tuple(i)) + static(1)
end

function _strides2int(o::O, s::S, i::I) where {O,S,I}
    N = known_length(S)
    sum(ntuple(x->(getfield(i, x) - getfield(o, x)) * getfield(s, x),N))    
end

@testset "known values" begin
    CI = CartesianIndices((2, 2))

    @test isnothing(@inferred(StaticArrayInterface.known_first(typeof(1:4))))
    @test isone(@inferred(StaticArrayInterface.known_first(Base.OneTo(4))))
    @test isone(@inferred(StaticArrayInterface.known_first(typeof(Base.OneTo(4)))))
    @test @inferred(StaticArrayInterface.known_first(typeof(CI))) == CartesianIndex(1, 1)
    @test @inferred(StaticArrayInterface.known_first(typeof(CI))) == CartesianIndex(1, 1)

    @test isnothing(@inferred(StaticArrayInterface.known_last(1:4)))
    @test isnothing(@inferred(StaticArrayInterface.known_last(typeof(1:4))))
    @test @inferred(StaticArrayInterface.known_last(typeof(CI))) === nothing

    @test isnothing(@inferred(StaticArrayInterface.known_step(typeof(1:0.2:4))))
    @test isone(@inferred(StaticArrayInterface.known_step(1:4)))
    @test isone(@inferred(StaticArrayInterface.known_step(typeof(1:4))))
    @test isone(@inferred(StaticArrayInterface.known_step(typeof(Base.Slice(1:4)))))
    @test isone(@inferred(StaticArrayInterface.known_step(typeof(view(1:4, 1:2)))))
end

"""
    axes_types(::Type{T}) -> Type{Tuple{Vararg{AbstractUnitRange{Int}}}}
    axes_types(::Type{T}, dim) -> Type{AbstractUnitRange{Int}}

Returns the type of each axis for the `T`, or the type of of the axis along dimension `dim`.
"""
@inline axes_types(x, dim) = axes_types(x, to_dims(x, dim))
@inline function axes_types(x, dim::StaticInt{D}) where {D}
    if D > ndims(x)
        return SOneTo{1}
    else
        return field_type(axes_types(x), dim)
    end
end
@inline function axes_types(x, dim::Int)
    if dim > ndims(x)
        return SOneTo{1}
    else
        return fieldtype(axes_types(x), dim)
    end
end
axes_types(x) = axes_types(typeof(x))
axes_types(::Type{T}) where {T<:Array} = NTuple{ndims(T),OneTo{Int}}
@inline function axes_types(::Type{T}) where {T}
    if is_forwarding_wrapper(T)
        return axes_types(parent_type(T))
    else
        return NTuple{ndims(T),OptionallyStaticUnitRange{One,Int}}
    end
end
axes_types(::Type{<:LinearIndices{N,R}}) where {N,R} = R
axes_types(::Type{<:CartesianIndices{N,R}}) where {N,R} = R
function axes_types(@nospecialize T::Type{<:VecAdjTrans})
    Tuple{SOneTo{1}, fieldtype(axes_types(parent_type(T)), 1)}
end
function axes_types(@nospecialize T::Type{<:MatAdjTrans})
    Ax = axes_types(parent_type(T))
    Tuple{fieldtype(Ax, 2), fieldtype(Ax, 1)}
end
function axes_types(::Type{T}) where {T<:PermutedDimsArray}
    eachop_tuple(field_type, to_parent_dims(T), axes_types(parent_type(T)))
end
axes_types(T::Type{<:Base.IdentityUnitRange}) = Tuple{T}
axes_types(::Type{<:Base.Slice{I}}) where {I} = Tuple{Base.IdentityUnitRange{I}}
axes_types(::Type{<:Base.Slice{I}}) where {I<:Base.IdentityUnitRange} = Tuple{I}
function axes_types(::Type{T}) where {T<:AbstractRange}
    if known_length(T) === nothing
        return Tuple{OneTo{Int}}
    else
        return Tuple{SOneTo{known_length(T)}}
    end
end
axes_types(::Type{T}) where {T<:ReshapedArray} = NTuple{ndims(T),OneTo{Int}}
function _sub_axis_type(::Type{PA}, ::Type{I}, dim::StaticInt{D}) where {I<:Tuple,PA,D}
    IT = field_type(I, dim)
    if IT <: Base.Slice{Base.OneTo{Int}}
        # this helps workaround slices over statically sized dimensions
        axes_types(field_type(PA, dim), static(1))
    else
        axes_types(IT, static(1))
    end
end
@inline function axes_types(@nospecialize T::Type{<:SubArray})
    return eachop_tuple(_sub_axis_type, to_parent_dims(T), axes_types(parent_type(T)), fieldtype(T, :indices))
end
function axes_types(::Type{T}) where {T<:ReinterpretArray}
    eachop_tuple(_non_reshaped_axis_type, ntuple(static, StaticInt(ndims(T))), T)
end
function _non_reshaped_axis_type(::Type{A}, d::StaticInt{D}) where {A,D}
    paxis = axes_types(parent_type(A), d)
    if D === 1
        if known_length(paxis) === nothing
            return paxis
        else
            return SOneTo{div(known_length(paxis) * sizeof(eltype(parent_type(A))), sizeof(eltype(A)))}
        end
    else
        return paxis
    end
end
function axes_types(::Type{A}) where {T,N,S,A<:Base.ReshapedReinterpretArray{T,N,S}}
    if sizeof(S) > sizeof(T)
        return merge_tuple_type(Tuple{SOneTo{div(sizeof(S), sizeof(T))}}, axes_types(parent_type(A)))
    elseif sizeof(S) < sizeof(T)
        P = parent_type(A)
        return eachop_tuple(field_type, tail(ntuple(static, StaticInt(ndims(P)))), axes_types(P))
    else
        return axes_types(parent_type(A))
    end
end


# FUTURE NOTE: we avoid  `SOneTo(1)` when `axis(A, dim::Int)``. This is inended to decreases
# breaking changes for this adopting this method to situations where they clearly benefit
# from the propagation of static axes. This creates the somewhat awkward situation of
# conditionally typed (but inferrable) axes. It also means we can't depend on constant
# propagation to preserve statically sized axes. This should probably be addressed before
# merging into Base Julia.
"""
    static_axes(A) -> Tuple{Vararg{AbstractUnitRange{Int}}}
    static_axes(A, dim) -> AbstractUnitRange{Int}

Returns the axis associated with each dimension of `A` or dimension `dim`.
`static_axes(::AbstractArray)` behaves nearly identical to `Base.axes` with the
exception of a handful of types replace `Base.OneTo{Int}` with `SOneTo`. For
example, the axis along the first dimension of `Transpose{T,<:AbstractVector{T}}` and
`Adjoint{T,<:AbstractVector{T}}` can be represented by `SOneTo(1)`. Similarly,
`Base.ReinterpretArray`'s first axis may be statically sized.
"""
@inline static_axes(A) = Base.axes(A)
static_axes(A::ReshapedArray) = Base.axes(A)
@inline function static_axes(x::Union{MatAdjTrans,PermutedDimsArray})
    map(GetIndex{false}(static_axes(parent(x))), to_parent_dims(x))
end
static_axes(A::VecAdjTrans) = (SOneTo{1}(), static_axes(parent(A), 1))

@inline static_axes(x::SubArray) = flatten_tuples(map(Base.Fix1(_sub_axes, x), sub_axes_map(typeof(x))))
@inline _sub_axes(x::SubArray, axis::SOneTo) = axis
_sub_axes(x::SubArray, ::StaticInt{index}) where {index} = static_axes(getfield(x.indices, index))

@inline static_axes(A, dim) = _axes(A, to_dims(A, dim))
@inline _axes(A, dim::Int) = dim > ndims(A) ? OneTo(1) : getfield(static_axes(A), dim)
@inline function _axes(A, ::StaticInt{dim}) where {dim}
    dim > ndims(A) ? SOneTo{1}() : getfield(static_axes(A), dim)
end
@inline function static_axes(A::Base.ReshapedReinterpretArray{T,N,S}) where {T,N,S}
    if sizeof(S) > sizeof(T)
        return (SOneTo(div(sizeof(S), sizeof(T))), static_axes(parent(A))...)
    elseif sizeof(S) < sizeof(T)
        return tail(static_axes(parent(A)))
    else
        return static_axes(parent(A))
    end
end
@inline function static_axes(A::Base.ReshapedReinterpretArray{T,N,S}, dim) where {T,N,S}
    d = to_dims(A, dim)
    if sizeof(S) > sizeof(T)
        if d == 1
            return SOneTo(div(sizeof(S), sizeof(T)))
        else
            return static_axes(parent(A), d - static(1))
        end
    elseif sizeof(S) < sizeof(T)
        return static_axes(parent(A), d - static(1))
    else
        return static_axes(parent(A), d)
    end
end

@inline Base.parent(x::LazyAxis{N,P}) where {N,P} = static_axes(getfield(x, :parent), static(N))
@inline Base.parent(x::LazyAxis{:,P}) where {P} = eachindex(IndexLinear(), getfield(x, :parent))

@inline parent_type(::Type{LazyAxis{N,P}}) where {N,P} = axes_types(P, static(N))
# TODO this approach to parent_type(::Type{LazyAxis{:}}) is a bit hacky. Something like
# LabelledArrays has a linear set of symbolic keys, which could be propagated through
# `to_indices` for key based indexing. However, there currently isn't a good way of handling
# that when the linear indices aren't linearly accessible through a child array (e.g, adjoint)
# For now we just make sure the linear elements are accurate.
parent_type(::Type{LazyAxis{:,P}}) where {P<:Array} = OneTo{Int}
@inline function parent_type(::Type{LazyAxis{:,P}}) where {P}
    if known_length(P) === nothing
        return OptionallyStaticUnitRange{StaticInt{1},Int}
    else
        return SOneTo{known_length(P)}
    end
end

Base.keys(x::LazyAxis) = keys(parent(x))

Base.IndexStyle(T::Type{<:LazyAxis}) = IndexStyle(parent_type(T))

function Static.OptionallyStaticUnitRange(x::LazyAxis)
    OptionallyStaticUnitRange(static_first(x), static_last(x))
end
can_change_size(@nospecialize T::Type{<:LazyAxis}) = can_change_size(fieldtype(T, :parent))

known_first(::Type{<:LazyAxis{N,P}}) where {N,P} = known_offsets(P, static(N))
known_first(::Type{<:LazyAxis{:,P}}) where {P} = 1
@inline function Base.first(x::LazyAxis{N})::Int where {N}
    if known_first(x) === nothing
        return Int(offsets(getfield(x, :parent), StaticInt(N)))
    else
        return Int(known_first(x))
    end
end
@inline Base.first(x::LazyAxis{:})::Int = Int(offset1(getfield(x, :parent)))
known_last(::Type{LazyAxis{N,P}}) where {N,P} = known_last(axes_types(P, static(N)))
known_last(::Type{LazyAxis{:,P}}) where {P} = known_length(P)
Base.last(x::LazyAxis) = _last(known_last(x), x)
_last(::Nothing, x::LazyAxis{:}) = lastindex(getfield(x, :parent))
_last(::Nothing, x::LazyAxis{N}) where {N} = lastindex(getfield(x, :parent), N)
_last(N::Int, x) = N

known_length(::Type{<:LazyAxis{:,P}}) where {P} = known_length(P)
known_length(::Type{<:LazyAxis{N,P}}) where {N,P} = known_size(P, static(N))
@inline Base.length(x::LazyAxis{:}) = Base.length(getfield(x, :parent))
@inline Base.length(x::LazyAxis{N}) where {N} = Base.size(getfield(x, :parent), N)

Base.axes(x::LazyAxis) = (Base.axes1(x),)
Base.axes1(x::LazyAxis) = x
Base.axes(x::Slice{<:LazyAxis}) = (Base.axes1(x),)
# assuming that lazy loaded params like dynamic length from `size(::Array, dim)` are going
# be used again later with `Slice{LazyAxis}`, we quickly load indices

Base.axes1(x::Slice{LazyAxis{N,A}}) where {N,A} = indices(getfield(x.indices, :parent), StaticInt(N))
Base.axes1(x::Slice{LazyAxis{:,A}}) where {A} = indices(getfield(x.indices, :parent))
Base.to_shape(x::LazyAxis) = Base.length(x)

@propagate_inbounds function Base.getindex(x::LazyAxis, i::IntType)
    @boundscheck checkindex(Bool, x, i) || throw(BoundsError(x, i))
    return Int(i)
end
@propagate_inbounds function Base.getindex(x::LazyAxis, s::StepRange{<:Integer})
    @boundscheck checkbounds(x, s)
    range(Int(first(x) + s.start-1), step=Int(step(s)), length=Int(static_length(s)))
end
@propagate_inbounds Base.getindex(x::LazyAxis, i::AbstractUnitRange{<:Integer}) = parent(x)[i]

Base.show(io::IO, x::LazyAxis{N}) where {N} = print(io, "LazyAxis{$N}($(parent(x))))")

"""
    lazy_axes(x)

Produces a tuple of axes where each axis is constructed lazily. If an axis of `x` is already
constructed or it is simply retrieved.
"""
@inline lazy_axes(x) = lazy_axes(x, ntuple(static, StaticInt(ndims(x))))
lazy_axes(x::Union{LinearIndices,CartesianIndices,AbstractRange}) = static_axes(x)
@inline function lazy_axes(x::PermutedDimsArray, ::StaticInt{N}) where {N}
    N <= ndims(x) ? lazy_axes(parent(x), getfield(to_parent_dims(x), N)) : SOneTo{1}()
end
lazy_axes(x::Union{Adjoint,Transpose}, ::StaticInt{1}) = lazy_axes(parent(x), StaticInt(2))
lazy_axes(x::Union{Adjoint,Transpose}, ::StaticInt{2}) = lazy_axes(parent(x), StaticInt(1))
lazy_axes(x::AbstractRange, ::StaticInt{1}) = Base.axes1(x)
lazy_axes(x, ::Colon) = LazyAxis{:}(x)
lazy_axes(x, ::StaticInt{dim}) where {dim} = ndims(x) < dim ? SOneTo{1}() : LazyAxis{dim}(x)
@inline lazy_axes(x, dims::Tuple) = map(Base.Fix1(lazy_axes, x), dims)

v = Array{Float64}(undef, 4)
m = Array{Float64}(undef, 4, 3)
@test @inferred(StaticArrayInterface.static_axes(v')) === (StaticInt(1):StaticInt(1),Base.OneTo(4))
@test @inferred(StaticArrayInterface.static_axes(m')) === (Base.OneTo(3),Base.OneTo(4))
@test StaticArrayInterface.static_axes(v', StaticInt(1)) === StaticInt(1):StaticInt(1)
@test StaticArrayInterface.static_axes(v, StaticInt(2)) === StaticInt(1):StaticInt(1)
@test StaticArrayInterface.axes_types(view(CartesianIndices(map(Base.Slice, (0:3, 3:5))), 0, :), 1) <: Base.IdentityUnitRange

@testset "LazyAxis" begin
    A = zeros(3,4,5);
    SA = MArray(zeros(3,4,5))
    DA = MArray(zeros(3,4,5), LinearIndices((Base.Slice(1:3), 1:4, 1:5)))
    lz1 = StaticArrayInterface.LazyAxis{1}(A)
    slz1 = StaticArrayInterface.LazyAxis{1}(SA)
    dlz1 = StaticArrayInterface.LazyAxis{1}(DA)
    lzc = StaticArrayInterface.LazyAxis{:}(A)
    slzc = StaticArrayInterface.LazyAxis{:}(SA)
    dlzc = StaticArrayInterface.LazyAxis{:}(DA)

    @test @inferred(first(lz1)) === @inferred(first(slz1)) === @inferred(first(dlz1))
    @test @inferred(first(lzc)) === @inferred(first(slzc)) === @inferred(first(dlzc))
    @test @inferred(last(lz1)) === @inferred(last(slz1)) === @inferred(last(dlz1))
    @test @inferred(last(lzc)) === @inferred(last(slzc)) === @inferred(last(dlzc))
    @test @inferred(length(lz1)) === @inferred(length(slz1)) === @inferred(length(dlz1))
    @test @inferred(length(lzc)) === @inferred(length(slzc)) === @inferred(length(dlzc))
    @test @inferred(Base.to_shape(lzc)) == length(slzc) == length(dlzc)
    @test @inferred(Base.checkindex(Bool, lzc, 1)) & @inferred(Base.checkindex(Bool, slzc, 1))
    @test axes(lzc)[1] == Base.axes1(lzc) == axes(Base.Slice(lzc))[1] == Base.axes1(Base.Slice(lzc))
    @test keys(axes(A, 1)) == @inferred(keys(lz1))

    @test @inferred(StaticArrayInterface.known_first(slzc)) === 1
    @test @inferred(StaticArrayInterface.known_length(slz1)) === 3

    @test @inferred(getindex(lz1, 2)) == 2
    @test @inferred(getindex(lz1, 1:2)) == 1:2
    @test @inferred(getindex(lz1, 1:1:3)) == 1:1:3

    @test @inferred(StaticArrayInterface.parent_type(StaticArrayInterface.LazyAxis{:}(A))) <: Base.OneTo{Int}
    @test @inferred(StaticArrayInterface.parent_type(StaticArrayInterface.LazyAxis{4}(SA))) <: Static.SOneTo{1}
    @test @inferred(StaticArrayInterface.parent_type(StaticArrayInterface.LazyAxis{:}(SA))) <: Static.SOneTo{60}
    @test @inferred(IndexStyle(SA)) isa IndexLinear
    @test @inferred(IndexStyle(DA)) isa IndexLinear
    @test StaticArrayInterface.can_change_size(StaticArrayInterface.LazyAxis{1,Vector{Any}})

    Aperm = PermutedDimsArray(A, (3,1,2))
    Aview = @view(Aperm[:,1:2,1])
    @test map(parent, @inferred(StaticArrayInterface.lazy_axes(Aperm))) === @inferred(StaticArrayInterface.static_axes(Aperm))
    @test map(parent, @inferred(StaticArrayInterface.lazy_axes(Aview))) === @inferred(StaticArrayInterface.static_axes(Aview))
    @test map(parent, @inferred(StaticArrayInterface.lazy_axes(Aview'))) === @inferred(StaticArrayInterface.static_axes(Aview'))
    @test map(parent, @inferred(StaticArrayInterface.lazy_axes((1:2)'))) === @inferred(StaticArrayInterface.static_axes((1:2)'))

    @test_throws DimensionMismatch StaticArrayInterface.LazyAxis{0}(A)
end

@testset "`axes(A, dim)`` with `dim > ndims(A)` (#224)" begin
    m = 2
    n = 3
    B = Array{Float64, 2}(undef, m, n)
    b = view(B, :, 1)

    @test @inferred(StaticArrayInterface.static_axes(B, 1)) == 1:m
    @test @inferred(StaticArrayInterface.static_axes(B, 2)) == 1:n
    @test @inferred(StaticArrayInterface.static_axes(B, 3)) == 1:1

    @test @inferred(StaticArrayInterface.static_axes(B, static(1))) == 1:m
    @test @inferred(StaticArrayInterface.static_axes(B, static(2))) == 1:n
    @test @inferred(StaticArrayInterface.static_axes(B, static(3))) == 1:1

    @test @inferred(StaticArrayInterface.static_axes(b, 1)) == 1:m
    @test @inferred(StaticArrayInterface.static_axes(b, 2)) == 1:1
    @test @inferred(StaticArrayInterface.static_axes(b, 3)) == 1:1

    @test @inferred(StaticArrayInterface.static_axes(b, static(1))) == 1:m
    @test @inferred(StaticArrayInterface.static_axes(b, static(2))) == 1:1
    @test @inferred(StaticArrayInterface.static_axes(b, static(3))) == 1:1

    # multidimensional subindices
    vx = view(rand(4), reshape(1:4, 2, 2))
    @test @inferred(axes(vx)) == (1:2, 1:2)
end

@testset "SubArray Adjoint Axis" begin
  N = 4; d = rand(N);

  @test @inferred(StaticArrayInterface.axes_types(typeof(view(d',:,1:2)))) ===
    Tuple{Static.OptionallyStaticUnitRange{StaticInt{1}, StaticInt{1}}, Base.OneTo{Int64}} ===
    typeof(@inferred(StaticArrayInterface.static_axes(view(d',:,1:2)))) ===
    typeof((StaticArrayInterface.static_axes(view(d',:,1:2),1),StaticArrayInterface.static_axes(view(d',:,1:2),2)))
end
if isdefined(Base, :ReshapedReinterpretArray)
  @testset "ReshapedReinterpretArray" begin
    a = rand(3, 5)
    ua = reinterpret(reshape, UInt64, a)
    @test StaticArrayInterface.static_axes(ua) === StaticArrayInterface.static_axes(a)
    @test StaticArrayInterface.static_axes(ua, 1) === StaticArrayInterface.static_axes(a, 1)
    @test @inferred(StaticArrayInterface.static_axes(ua)) isa StaticArrayInterface.axes_types(ua)
    u8a = reinterpret(reshape, UInt8, a)
    @test @inferred(StaticArrayInterface.static_axes(u8a)) isa StaticArrayInterface.axes_types(u8a)
    @test @inferred(StaticArrayInterface.static_axes(u8a, static(1))) isa StaticArrayInterface.axes_types(u8a, 1)
    @test @inferred(StaticArrayInterface.static_axes(u8a, static(2))) isa StaticArrayInterface.axes_types(u8a, 2)
    fa = reinterpret(reshape, Float64, copy(u8a))
    @inferred(StaticArrayInterface.static_axes(fa)) isa StaticArrayInterface.axes_types(fa)
  end
end

module StaticArrayInterfaceStaticArraysExt

using StaticArrayInterface
using StaticArrayInterface.Static
using Static: StaticInt

if isdefined(Base, :get_extension) 
    using StaticArrays
    using LinearAlgebra
else 
    using ..StaticArrays
    using ..LinearAlgebra
end

const CanonicalInt = Union{Int,StaticInt}

function Static.OptionallyStaticUnitRange(::StaticArrays.SOneTo{N}) where {N}
    Static.OptionallyStaticUnitRange(StaticInt(1), StaticInt(N))
end
StaticArrayInterface.known_first(::Type{<:StaticArrays.SOneTo}) = 1
StaticArrayInterface.known_last(::Type{StaticArrays.SOneTo{N}}) where {N} = N
StaticArrayInterface.known_length(::Type{StaticArrays.SOneTo{N}}) where {N} = N
StaticArrayInterface.known_length(::Type{StaticArrays.Length{L}}) where {L} = L
function StaticArrayInterface.known_length(::Type{A}) where {A<:StaticArrays.StaticArray}
    StaticArrayInterface.known_length(StaticArrays.Length(A))
end

@inline StaticArrayInterface.static_length(x::StaticArrays.StaticArray) = Static.maybe_static(StaticArrayInterface.known_length, Base.length, x)
StaticArrayInterface.device(::Type{<:StaticArrays.MArray}) = StaticArrayInterface.CPUPointer()
StaticArrayInterface.device(::Type{<:StaticArrays.SArray}) = StaticArrayInterface.CPUTuple()
StaticArrayInterface.contiguous_axis(::Type{<:StaticArrays.StaticArray}) = StaticInt{1}()
StaticArrayInterface.contiguous_batch_size(::Type{<:StaticArrays.StaticArray}) = StaticInt{0}()
function StaticArrayInterface.stride_rank(::Type{T}) where {N,T<:StaticArray{<:Any,<:Any,N}}
    ntuple(static, StaticInt(N))
end
function StaticArrayInterface.dense_dims(::Type{<:StaticArray{S,T,N}}) where {S,T,N}
    StaticArrayInterface._all_dense(Val(N))
end
StaticArrayInterface.defines_strides(::Type{<:StaticArrays.SArray}) = true
StaticArrayInterface.defines_strides(::Type{<:StaticArrays.MArray}) = true

@generated function StaticArrayInterface.axes_types(::Type{<:StaticArrays.StaticArray{S}}) where {S}
    Tuple{[StaticArrays.SOneTo{s} for s in S.parameters]...}
end
@generated function StaticArrayInterface.static_size(A::StaticArrays.StaticArray{S}) where {S}
    t = Expr(:tuple)
    Sp = S.parameters
    for n = 1:length(Sp)
        push!(t.args, Expr(:call, Expr(:curly, :StaticInt, Sp[n])))
    end
    return t
end
@generated function StaticArrayInterface.static_strides(A::StaticArrays.StaticArray{S}) where {S}
    t = Expr(:tuple, Expr(:call, Expr(:curly, :StaticInt, 1)))
    Sp = S.parameters
    x = 1
    for n = 1:(length(Sp)-1)
        push!(t.args, Expr(:call, Expr(:curly, :StaticInt, (x *= Sp[n]))))
    end
    return t
end
if StaticArrays.SizedArray{Tuple{8,8},Float64,2,2} isa UnionAll
    @inline StaticArrayInterface.static_strides(B::StaticArrays.SizedArray{S,T,M,N,A}) where {S,T,M,N,A<:SubArray} = StaticArrayInterface.static_strides(B.data)
    StaticArrayInterface.parent_type(::Type{<:StaticArrays.SizedArray{S,T,M,N,A}}) where {S,T,M,N,A} = A
else
    StaticArrayInterface.parent_type(::Type{<:StaticArrays.SizedArray{S,T,M,N}}) where {S,T,M,N} = Array{T,N}
end

end # module

using StaticArrayInterface
using OffsetArrays
using Static
using Test

A = zeros(3, 4, 5);
O = OffsetArray(A, 3, 7, 10);
Op = PermutedDimsArray(O,(3,1,2));
@test @inferred(StaticArrayInterface.offsets(O)) === (4, 8, 11)
@test @inferred(StaticArrayInterface.offsets(Op)) === (11, 4, 8)

@test @inferred(StaticArrayInterface.static_to_indices(O, (:, :, :))) == (4:6, 8:11, 11:15)
@test @inferred(StaticArrayInterface.static_to_indices(Op, (:, :, :))) == (11:15, 4:6, 8:11)

@test @inferred(StaticArrayInterface.offsets((1,2,3))) === (StaticInt(1),)
o = OffsetArray(vec(A), 8);
@test @inferred(StaticArrayInterface.offset1(o)) === 9

@test @inferred(StaticArrayInterface.device(OffsetArray(view(PermutedDimsArray(A, (3,1,2)), 1, :, 2:4)', 3, -173))) === StaticArrayInterface.CPUPointer()
@test @inferred(StaticArrayInterface.device(view(OffsetArray(A,2,3,-12), 4, :, -11:-9))) === StaticArrayInterface.CPUPointer()
@test @inferred(StaticArrayInterface.device(view(OffsetArray(A,2,3,-12), 3, :, [-11,-10,-9])')) === StaticArrayInterface.CPUIndex()

@test @inferred(StaticArrayInterface.indices(OffsetArray(view(PermutedDimsArray(A, (3,1,2)), 1, :, 2:4)', 3, -173),1)) === Base.Slice(Static.OptionallyStaticUnitRange(4,6))
@test @inferred(StaticArrayInterface.indices(OffsetArray(view(PermutedDimsArray(A, (3,1,2)), 1, :, 2:4)', 3, -173),2)) === Base.Slice(Static.OptionallyStaticUnitRange(-172,-170))

@test @inferred(StaticArrayInterface.device(OffsetArray(1:10))) === StaticArrayInterface.CPUIndex()
@test @inferred(StaticArrayInterface.device(OffsetArray(@view(reshape(1:8, 2,2,2)[1,1:2,:]),-3,4))) === StaticArrayInterface.CPUIndex()
@test @inferred(StaticArrayInterface.device(OffsetArray(zeros(2,2,2),8,-2,-5))) === StaticArrayInterface.CPUPointer()

offset_view = @view OffsetArrays.centered(zeros(eltype(A), 5, 5))[:, begin]; # SubArray of OffsetArray
@test @inferred(StaticArrayInterface.offsets(offset_view)) == (-2,)

B = OffsetArray(PermutedDimsArray(rand(2,3,4), (2,3,1)));
@test @inferred(StaticArrayInterface.StrideIndex(B)) === StaticArrayInterface.StrideIndex{3, (2, 3, 1), 3}((2, 6, static(1)), (1, 1, 1))

module StaticArrayInterface

@static if isdefined(Base, Symbol("@assume_effects"))
    using Base: @assume_effects
else
    macro assume_effects(args...)
        n = nfields(args)
        call = getfield(args, n)
        if n === 2 && getfield(args, 1) === QuoteNode(:total)
            return esc(:(Base.@pure $(call)))
        else
            return esc(call)
        end
    end
end

using PrecompileTools

@recompile_invalidations begin
    using ArrayInterface
    import ArrayInterface: allowed_getindex, allowed_setindex!, aos_to_soa, buffer,
                            parent_type, fast_matrix_colors, findstructralnz,
                            has_sparsestruct,
                            issingular, isstructured, matrix_colors, restructure,
                            lu_instance,
                            safevec, zeromatrix, undefmatrix, ColoringAlgorithm,
                            fast_scalar_indexing, parameterless_type,
                            is_forwarding_wrapper,
                                map_tuple_type, flatten_tuples, GetIndex, SetIndex!,
                            defines_strides, ndims_index, ndims_shape,
                            stride_preserving_index

    # ArrayIndex subtypes and methods
    import ArrayInterface: ArrayIndex, MatrixIndex, VectorIndex, BidiagonalIndex,
                            TridiagonalIndex
    # managing immutables
    import ArrayInterface: ismutable, can_change_size, can_setindex
    # constants
    import ArrayInterface: MatAdjTrans, VecAdjTrans, UpTri, LoTri
    # device pieces
    import ArrayInterface: AbstractDevice, AbstractCPU, CPUPointer, CPUTuple, CheckParent,
                            CPUIndex, GPU, can_avx, device

    using Static
    using Static: Zero, One, nstatic, eq, ne, gt, ge, lt, le, eachop, eachop_tuple,
                permute, invariant_permutation, field_type, reduce_tup, find_first_eq,
                OptionallyStaticUnitRange, OptionallyStaticStepRange, OptionallyStaticRange,
                IntType,
                SOneTo, SUnitRange

    using IfElse

    using Base.Cartesian
    using Base: @propagate_inbounds, tail, OneTo, LogicalIndex, Slice, ReinterpretArray,
                ReshapedArray, AbstractCartesianIndex

    using Base.Iterators: Pairs
    using LinearAlgebra

    import Compat
end

using SciMLPublic: @public
@public BroadcastAxis, LazyAxis, OptionallyStaticStepRange,
OptionallyStaticUnitRange, SOneTo, SUnitRange, StrideIndex
@public static_axes,
axes_types, broadcast_axis, deleteat, dense_dims, from_parent_dims, getindex, indices,
insert, static_length, lazy_axes, offset1, offsets, setindex!, static_size, static_strides,
to_axes, to_axis, to_dims, to_index, static_to_indices, to_parent_dims, unsafe_reconstruct
@public contiguous_axis, contiguous_axis_indicator, contiguous_batch_size, dimnames,
has_dimnames, has_parent, is_column_major, is_lazy_conjugate,
is_splat_index, known_dimnames, known_first, known_last, known_length,
known_offset1, known_offsets, known_size, known_step, known_strides

"""
    StrideIndex(x)
Subtype of `ArrayIndex` that transforms and index using stride layout information
derived from `x`.
"""
struct StrideIndex{N,R,C,S,O} <: ArrayIndex{N}
    strides::S
    offsets::O
    @inline function StrideIndex{N,R,C}(s::S, o::O) where {N,R,C,S,O}
        return new{N,R::NTuple{N,Int},C,S,O}(s, o)
    end
end

"""
    LazyAxis{N}(parent::AbstractArray)
A lazy representation of `axes(parent, N)`.
"""
struct LazyAxis{N,P} <: AbstractUnitRange{Int}
    parent::P

    function LazyAxis{N}(parent::P) where {N,P}
        N > 0 && return new{N::Int,P}(parent)
        throw_dim_error(parent, N)
    end
    @inline LazyAxis{:}(parent::P) where {P} = new{ifelse(ndims(P) === 1, 1, :),P}(parent)
end

function throw_dim_error(@nospecialize(x), @nospecialize(dim))
    throw(DimensionMismatch("$x does not have dimension corresponding to $dim"))
end

abstract type AbstractArray2{T, N} <: AbstractArray{T, N} end

"""
    BroadcastAxis
An abstract trait that is used to determine how axes are combined when calling `broadcast_axis`.
"""
abstract type BroadcastAxis end

@assume_effects :total function _find_first_true(isi::Tuple{Vararg{Union{Bool, Static.StaticBool}, N}}) where {N}
    for i in 1:N
        x = getfield(isi, i) 
        if (x isa Bool && x === true) || x isa Static.True
            return i
        end
    end
    return nothing
end

"""
    IndicesInfo{N}(inds::Tuple) -> IndicesInfo{N}(typeof(inds))
    IndicesInfo{N}(T::Type{<:Tuple}) -> IndicesInfo{N,pdims,cdims}()
    IndicesInfo(inds::Tuple) -> IndicesInfo(typeof(inds))
    IndicesInfo(T::Type{<:Tuple}) -> IndicesInfo{maximum(pdims),pdims,cdims}()


Maps a tuple of indices to `N` dimensions. The resulting `pdims` is a tuple where each
field in `inds` (or field type in `T`) corresponds to the parent dimensions accessed.
`cdims` similarly maps indices to the resulting child array produced after indexing with
`inds`. If `N` is not provided then it is assumed that all indices are represented by parent
dimensions and there are no trailing dimensions accessed. These may be accessed by through
`parentdims(info::IndicesInfo)` and `childdims(info::IndicesInfo)`. If `N` is not provided,
it is assumed that no indices are accessing trailing dimensions (which are represented as
`0` in `parentdims(info)[index_position]`).

The the fields and types of `IndicesInfo` should not be accessed directly.
Instead [`parentdims`](@ref), [`childdims`](@ref), [`ndims_index`](@ref), and
[`ndims_shape`](@ref) should be used to extract relevant information.

# Examples

```julia
julia> using StaticArrayInterface: IndicesInfo, parentdims, childdims, ndims_index, ndims_shape

julia> info = IndicesInfo{5}(typeof((:,[CartesianIndex(1,1),CartesianIndex(1,1)], 1, ones(Int, 2, 2), :, 1)));

julia> parentdims(info)  # the last two indices access trailing dimensions
(1, (2, 3), 4, 5, 0, 0)

julia> childdims(info)
(1, 2, 0, (3, 4), 5, 0)

julia> childdims(info)[3]  # index 3 accesses a parent dimension but is dropped in the child array
0

julia> ndims_index(info)
5

julia> ndims_shape(info)
5

julia> info = IndicesInfo(typeof((:,[CartesianIndex(1,1),CartesianIndex(1,1)], 1, ones(Int, 2, 2), :, 1)));

julia> parentdims(info)  # assumed no trailing dimensions
(1, (2, 3), 4, 5, 6, 7)

julia> ndims_index(info)  # assumed no trailing dimensions
7

```
"""
struct IndicesInfo{Np, pdims, cdims, Nc}
    function IndicesInfo{N}(@nospecialize(T::Type{<:Tuple})) where {N}
        SI = _find_first_true(map_tuple_type(is_splat_index, T))
        NI = map_tuple_type(ndims_index, T)
        NS = map_tuple_type(ndims_shape, T)
        if SI === nothing
            ndi = NI
            nds = NS
        else
            nsplat = N - sum(NI)
            if nsplat === 0
                ndi = NI
                nds = NS
            else
                splatmul = max(0, nsplat + 1)
                ndi = _map_splats(splatmul, SI, NI)
                nds = _map_splats(splatmul, SI, NS)
            end
        end
        if ndi === (1,) && N !== 1
            ns1 = getfield(nds, 1)
            new{N, (:,), (ns1 > 1 ? ntuple(identity, ns1) : ns1,), ns1}()
        else
            nds_cumsum = cumsum(nds)
            if sum(ndi) > N
                init_pdims = _accum_dims(cumsum(ndi), ndi)
                pdims = ntuple(nfields(init_pdims)) do i
                    dim_i = getfield(init_pdims, i)
                    if dim_i isa Tuple
                        ntuple(length(dim_i)) do j
                            dim_i_j = getfield(dim_i, j)
                            dim_i_j > N ? 0 : dim_i_j
                        end
                    else
                        dim_i > N ? 0 : dim_i
                    end
                end
                new{N, pdims, _accum_dims(nds_cumsum, nds), last(nds_cumsum)}()
            else
                new{N, _accum_dims(cumsum(ndi), ndi), _accum_dims(nds_cumsum, nds),
                    last(nds_cumsum)}()
            end
        end
    end
    IndicesInfo{N}(@nospecialize(t::Tuple)) where {N} = IndicesInfo{N}(typeof(t))
    function IndicesInfo(@nospecialize(T::Type{<:Tuple}))
        ndi = map_tuple_type(ndims_index, T)
        nds = map_tuple_type(ndims_shape, T)
        ndi_sum = cumsum(ndi)
        nds_sum = cumsum(nds)
        nf = nfields(ndi_sum)
        pdims = _accum_dims(ndi_sum, ndi)
        cdims = _accum_dims(nds_sum, nds)
        new{getfield(ndi_sum, nf), pdims, cdims, getfield(nds_sum, nf)}()
    end
    IndicesInfo(@nospecialize t::Tuple) = IndicesInfo(typeof(t))
    @inline function IndicesInfo(@nospecialize T::Type{<:SubArray})
        IndicesInfo{ndims(parent_type(T))}(fieldtype(T, :indices))
    end
    IndicesInfo(x::SubArray) = IndicesInfo{ndims(parent(x))}(typeof(x.indices))
end

@inline function _map_splats(nsplat::Int, splat_index::Int, dims::Tuple{Vararg{Union{Int,StaticInt}}})
    ntuple(length(dims)) do i
        i === splat_index ? (nsplat * getfield(dims, i)) : getfield(dims, i)
    end
end

@inline function _accum_dims(csdims::NTuple{N, Int}, nd::NTuple{N, Int}) where {N}
    ntuple(N) do i
        nd_i = getfield(nd, i)
        if nd_i === 0
            0
        elseif nd_i === 1
            getfield(csdims, i)
        else
            ntuple(Base.Fix1(+, getfield(csdims, i) - nd_i), nd_i)
        end
    end
end

function _lower_info(::IndicesInfo{Np, pdims, cdims, Nc}) where {Np, pdims, cdims, Nc}
    Np, pdims, cdims, Nc
end

ndims_index(@nospecialize(info::IndicesInfo)) = getfield(_lower_info(info), 1)
ndims_shape(@nospecialize(info::IndicesInfo)) = getfield(_lower_info(info), 4)

"""
    parentdims(::IndicesInfo) -> Tuple

Returns the parent dimension mapping from `IndicesInfo`.

See also: [`IndicesInfo`](@ref), [`childdims`](@ref)
"""
parentdims(@nospecialize info::IndicesInfo) = getfield(_lower_info(info), 2)

"""
    childdims(::IndicesInfo) -> Tuple

Returns the child dimension mapping from `IndicesInfo`.

See also: [`IndicesInfo`](@ref), [`parentdims`](@ref)
"""
childdims(@nospecialize info::IndicesInfo) = getfield(_lower_info(info), 3)

@generated function merge_tuple_type(::Type{X}, ::Type{Y}) where {X <: Tuple, Y <: Tuple}
    Tuple{X.parameters..., Y.parameters...}
end

Base.size(A::AbstractArray2) = map(Int, static_size(A))
Base.size(A::AbstractArray2, dim) = Int(static_size(A, dim))

function Base.axes(A::AbstractArray2)
    is_forwarding_wrapper(A) && return static_axes(parent(A))
    throw(ArgumentError("Subtypes of `AbstractArray2` must define an axes method"))
end
function Base.axes(A::AbstractArray2, dim::Union{Symbol, StaticSymbol})
    static_axes(A, to_dims(A, dim))
end

function Base.strides(A::AbstractArray2)
    defines_strides(A) && return map(Int, static_strides(A))
    throw(MethodError(Base.strides, (A,)))
end
Base.strides(A::AbstractArray2, dim) = Int(static_strides(A, dim))

function Base.IndexStyle(::Type{T}) where {T <: AbstractArray2}
    is_forwarding_wrapper(T) ? IndexStyle(parent_type(T)) : IndexCartesian()
end

function Base.length(A::AbstractArray2)
    len = known_length(A)
    if len === nothing
        return Int(prod(static_size(A)))
    else
        return Int(len)
    end
end

@propagate_inbounds Base.getindex(A::AbstractArray2, args...) = static_getindex(A, args...)
@propagate_inbounds Base.getindex(A::AbstractArray2; kwargs...) = static_getindex(A; kwargs...)

@propagate_inbounds function Base.setindex!(A::AbstractArray2, val, args...)
    return setindex!(A, val, args...)
end
@propagate_inbounds function Base.setindex!(A::AbstractArray2, val; kwargs...)
    return setindex!(A, val; kwargs...)
end

@inline static_first(x) = Static.maybe_static(known_first, first, x)
@inline static_last(x) = Static.maybe_static(known_last, last, x)
@inline static_step(x) = Static.maybe_static(known_step, step, x)

@inline function _to_cartesian(a, i::IntType)
    @inbounds(CartesianIndices(ntuple(dim -> indices(a, dim), Val(ndims(a))))[i])
end
@inline function _to_linear(a, i::Tuple{IntType, Vararg{IntType}})
    _strides2int(offsets(a), size_to_strides(static_size(a), static(1)), i) + static(1)
end

"""
    has_parent(::Type{T}) -> StaticBool

Returns `static(true)` if `parent_type(T)` a type unique to `T`.
"""
has_parent(x) = has_parent(typeof(x))
has_parent(::Type{T}) where {T} = _has_parent(parent_type(T), T)
_has_parent(::Type{T}, ::Type{T}) where {T} = False()
_has_parent(::Type{T1}, ::Type{T2}) where {T1, T2} = True()

"""
    is_lazy_conjugate(::AbstractArray) -> Bool

Determine if a given array will lazyily take complex conjugates, such as with `Adjoint`. This will work with
nested wrappers, so long as there is no type in the chain of wrappers such that `parent_type(T) == T`

Examples

    julia> a = transpose([1 + im, 1-im]')
    2×1 transpose(adjoint(::Vector{Complex{Int64}})) with eltype Complex{Int64}:
     1 - 1im
     1 + 1im

    julia> is_lazy_conjugate(a)
    True()

    julia> b = a'
    1×2 adjoint(transpose(adjoint(::Vector{Complex{Int64}}))) with eltype Complex{Int64}:
     1+1im  1-1im

    julia> is_lazy_conjugate(b)
    False()

"""
is_lazy_conjugate(::T) where {T <: AbstractArray} = _is_lazy_conjugate(T, False())
is_lazy_conjugate(::AbstractArray{<:Real}) = False()

function _is_lazy_conjugate(::Type{T}, isconj) where {T <: AbstractArray}
    Tp = parent_type(T)
    if T !== Tp
        _is_lazy_conjugate(Tp, isconj)
    else
        isconj
    end
end

function _is_lazy_conjugate(::Type{T}, isconj) where {T <: Adjoint}
    Tp = parent_type(T)
    if T !== Tp
        _is_lazy_conjugate(Tp, !isconj)
    else
        !isconj
    end
end

"""
    insert(collection, index, item)

Returns a new instance of `collection` with `item` inserted into at the given `index`.
"""
Base.@propagate_inbounds function insert(collection, index, item)
    @boundscheck checkbounds(collection, index)
    ret = similar(collection, static_length(collection) + 1)
    @inbounds for i in firstindex(ret):(index - 1)
        ret[i] = collection[i]
    end
    @inbounds ret[index] = item
    @inbounds for i in (index + 1):lastindex(ret)
        ret[i] = collection[i - 1]
    end
    return ret
end

function insert(x::Tuple{Vararg{Any, N}}, index, item) where {N}
    @boundscheck if !checkindex(Bool, StaticInt{1}():StaticInt{N}(), index)
        throw(BoundsError(x, index))
    end
    return unsafe_insert(x, Int(index), item)
end

@inline function unsafe_insert(x::Tuple, i::Int, item)
    if i === 1
        return (item, x...)
    else
        return (first(x), unsafe_insert(tail(x), i - 1, item)...)
    end
end

"""
    deleteat(collection, index)

Returns a new instance of `collection` with the item at the given `index` removed.
"""
Base.@propagate_inbounds function deleteat(collection::AbstractVector, index)
    @boundscheck if !checkindex(Bool, eachindex(collection), index)
        throw(BoundsError(collection, index))
    end
    return unsafe_deleteat(collection, index)
end
Base.@propagate_inbounds function deleteat(collection::Tuple{Vararg{Any, N}},
                                           index) where {N}
    @boundscheck if !checkindex(Bool, StaticInt{1}():StaticInt{N}(), index)
        throw(BoundsError(collection, index))
    end
    return unsafe_deleteat(collection, index)
end

function unsafe_deleteat(src::AbstractVector, index)
    dst = similar(src, static_length(src) - 1)
    @inbounds for i in indices(dst)
        if i < index
            dst[i] = src[i]
        else
            dst[i] = src[i + 1]
        end
    end
    return dst
end

@inline function unsafe_deleteat(src::AbstractVector, inds::AbstractVector)
    dst = similar(src, static_length(src) - static_length(inds))
    dst_index = firstindex(dst)
    @inbounds for src_index in indices(src)
        if !in(src_index, inds)
            dst[dst_index] = src[src_index]
            dst_index += one(dst_index)
        end
    end
    return dst
end

@inline function unsafe_deleteat(src::Tuple, inds::AbstractVector)
    dst = Vector{eltype(src)}(undef, static_length(src) - static_length(inds))
    dst_index = firstindex(dst)
    @inbounds for src_index in static(1):static_length(src)
        if !in(src_index, inds)
            dst[dst_index] = src[src_index]
            dst_index += one(dst_index)
        end
    end
    return Tuple(dst)
end

@inline unsafe_deleteat(x::Tuple{T}, i) where {T} = ()
@inline unsafe_deleteat(x::Tuple{T1, T2}, i) where {T1, T2} = isone(i) ? (x[2],) : (x[1],)
@inline function unsafe_deleteat(x::Tuple, i)
    if i === one(i)
        return tail(x)
    elseif i == static_length(x)
        return Base.front(x)
    else
        return (first(x), unsafe_deleteat(tail(x), i - one(i))...)
    end
end

include("array_index.jl")
include("ranges.jl")
include("axes.jl")
include("size.jl")
include("dimensions.jl")
include("indexing.jl")
include("stridelayout.jl")
include("broadcast.jl")

## Precompilation

@setup_workload begin
    # Putting some things in `setup` can reduce the size of the
    # precompile file and potentially make loading faster.
    arrays = [rand(4), Base.oneto(5)]
    @compile_workload begin for x in arrays
        known_first(x)
        known_step(x)
        known_last(x)
    end end
end

end

"""
    known_offsets(::Type{T}) -> Tuple
    known_offsets(::Type{T}, dim) -> Union{Int,Nothing}

Returns a tuple of offset values known at compile time. If the offset of a given axis is
not known at compile time `nothing` is returned its position.
"""
known_offsets(x, dim) = known_offsets(typeof(x), dim)
known_offsets(::Type{T}, dim) where {T} = known_offsets(T, to_dims(T, dim))
known_offsets(@nospecialize T::Type{<:Number}) = ()  # Int has no dimensions
@inline function known_offsets(@nospecialize T::Type{<:SubArray})
    flatten_tuples(map_tuple_type(known_offsets, fieldtype(T, :indices)))
end
function known_offsets(::Type{T}, dim::IntType) where {T}
    if ndims(T) < dim
        return 1
    else
        return known_offsets(T)[dim]
    end
end

known_offsets(x) = known_offsets(typeof(x))
function known_offsets(::Type{T}) where {T}
    eachop(_known_offsets, ntuple(static, StaticInt(ndims(T))), axes_types(T))
end
_known_offsets(::Type{T}, dim::StaticInt) where {T} = known_first(field_type(T, dim))
known_offsets(::Type{<:StrideIndex{N,R,C,S,O}}) where {N,R,C,S,O} = known(O)

"""
    offsets(A) -> Tuple
    offsets(A, dim) -> Union{Int,StaticInt}

Returns offsets of indices with respect to 0. If values are known at compile time,
it should return them as `Static` numbers.
For example, if `A isa Base.Matrix`, `offsets(A) === (StaticInt(1), StaticInt(1))`.
"""
@inline offsets(x, i) = static_first(indices(x, i))
offsets(::Tuple) = (One(),)
offsets(x::StrideIndex) = getfield(x, :offsets)
@inline offsets(x::SubArray) = flatten_tuples(map(offsets, x.indices))
offsets(x) = eachop(_offsets, ntuple(static, StaticInt(ndims(x))), x)
function _offsets(x::X, dim::StaticInt{D}) where {X,D}
    start = known_first(axes_types(X, dim))
    if start === nothing
        return first(static_axes(x, dim))
    else
        return static(start)
    end
end
# we can't generate an axis for `StrideIndex` so this is performed manually here
@inline offsets(x::StrideIndex, dim::Int) = getfield(offsets(x), dim)
@inline offsets(x::StrideIndex, ::StaticInt{dim}) where {dim} = getfield(offsets(x), dim)

"""
    known_offset1(::Type{T}) -> Union{Int,Nothing}

Returns the linear offset of array `x` if known at compile time.
"""
@inline known_offset1(x) = known_offset1(typeof(x))
@inline function known_offset1(::Type{T}) where {T}
    if ndims(T) === 0
        return 1
    else
        return known_offsets(T, 1)
    end
end

"""
    offset1(x) -> Union{Int,StaticInt}

Returns the offset of the linear indices for `x`.
"""
@inline function offset1(x::X) where {X}
    o1 = known_offset1(X)
    if o1 === nothing
        if ndims(X) === 0
            return 1
        else
            return offsets(x, 1)
        end
    else
        return static(o1)
    end
end

"""
    contiguous_axis(::Type{T}) -> StaticInt{N}

Returns the axis of an array of type `T` containing contiguous data.
If no axis is contiguous, it returns a `StaticInt{-1}`.
If unknown, it returns `nothing`.
"""
contiguous_axis(x) = contiguous_axis(typeof(x))
contiguous_axis(::Type{<:StrideIndex{N,R,C}}) where {N,R,C} = static(C)
contiguous_axis(::Type{<:StrideIndex{N,R,nothing}}) where {N,R} = nothing
function contiguous_axis(::Type{T}) where {T}
    is_forwarding_wrapper(T) ? contiguous_axis(parent_type(T)) : nothing
end
contiguous_axis(@nospecialize T::Type{<:DenseArray}) = One()
contiguous_axis(::Type{<:BitArray}) = One()
contiguous_axis(@nospecialize T::Type{<:AbstractRange}) = One()
contiguous_axis(@nospecialize T::Type{<:Tuple}) = One()
function contiguous_axis(@nospecialize T::Type{<:VecAdjTrans})
    c = contiguous_axis(parent_type(T))
    if c === nothing
        return nothing
    elseif c === One()
        return StaticInt{2}()
    else
        return -One()
    end
end
function contiguous_axis(@nospecialize T::Type{<:MatAdjTrans})
    c = contiguous_axis(parent_type(T))
    if c === nothing
        return nothing
    elseif isone(-c)
        return c
    else
        return StaticInt(3) - c
    end
end
function contiguous_axis(@nospecialize T::Type{<:PermutedDimsArray})
    c = contiguous_axis(parent_type(T))
    if c === nothing
        return nothing
    elseif isone(-c)
        return c
    else
        return from_parent_dims(T)[c]
    end
end
function contiguous_axis(::Type{<:Base.ReshapedArray{T, N, A, Tuple{}}}) where {T, N, A}
    c = contiguous_axis(A)
    if c !== nothing && isone(-c)
        return StaticInt(-1)
    elseif dynamic(is_column_major(A) & is_dense(A))
        return StaticInt(1)
    else
        return nothing
    end
end
# we're actually looking at the original vector indices before transpose/adjoint
function contiguous_axis(::Type{<:Base.ReshapedArray{T, 1, A, Tuple{}}}) where {T, A <: VecAdjTrans}
    contiguous_axis(parent_type(A))
end
@inline function contiguous_axis(@nospecialize T::Type{<:SubArray})
    c = contiguous_axis(parent_type(T))
    if c === nothing
        return nothing
    elseif c == -1
        return c
    else
        I = field_type(fieldtype(T, :indices), c)
        if I <: AbstractUnitRange
            return from_parent_dims(T)[c]  # FIXME get rid of from_parent_dims
        elseif I <: AbstractArray || I <: IntType
            return StaticInt(-1)
        else
            return nothing
        end
    end
end

function contiguous_axis(::Type{R}) where {T,N,S,A<:Array{S},R<:ReinterpretArray{T,N,S,A}}
    if isbitstype(S)
        return One()
    else
        return nothing
    end
end

"""
    contiguous_axis_indicator(::Type{T}) -> Tuple{Vararg{StaticBool}}

Returns a tuple boolean `Val`s indicating whether that axis is contiguous.
"""
function contiguous_axis_indicator(::Type{A}) where {D,A<:AbstractArray{<:Any,D}}
    return contiguous_axis_indicator(contiguous_axis(A), Val(D))
end
contiguous_axis_indicator(::A) where {A<:AbstractArray} = contiguous_axis_indicator(A)
contiguous_axis_indicator(::Nothing, ::Val) = nothing
function contiguous_axis_indicator(c::StaticInt{N}, dim::Val{D}) where {N,D}
    map(eq(c), ntuple(static, dim))
end

function rank_to_sortperm(R::Tuple{Vararg{StaticInt,N}}) where {N}
    sp = ntuple(zero, Val{N}())
    r = ntuple(n -> sum(R[n] .≥ R), Val{N}())
    @inbounds for n = 1:N
        sp = Base.setindex(sp, n, r[n])
    end
    return sp
end

stride_rank(::Type{<:StrideIndex{N,R}}) where {N,R} = static(R)
stride_rank(x) = stride_rank(typeof(x))
function stride_rank(::Type{T}) where {T}
    is_forwarding_wrapper(T) ? stride_rank(parent_type(T)) : nothing
end
stride_rank(::Type{BitArray{N}}) where {N} = ntuple(static, StaticInt(N))
stride_rank(@nospecialize T::Type{<:DenseArray}) = ntuple(static, StaticInt(ndims(T)))
stride_rank(@nospecialize T::Type{<:AbstractRange}) = (One(),)
stride_rank(@nospecialize T::Type{<:Tuple}) = (One(),)
stride_rank(@nospecialize T::Type{<:VecAdjTrans}) = (StaticInt(2), StaticInt(1))
@inline function stride_rank(@nospecialize T::Type{<:Union{MatAdjTrans,PermutedDimsArray}})
    rank = stride_rank(parent_type(T))
    if rank === nothing
        return nothing
    else
        return map(GetIndex{false}(rank), to_parent_dims(T))
    end
 end

function stride_rank(@nospecialize T::Type{<:SubArray})
    rank = stride_rank(parent_type(T))
    if rank === nothing
        return nothing
    else
        return map(GetIndex{false}(rank), to_parent_dims(T))
    end
end

stride_rank(x, i) = stride_rank(x)[i]
function stride_rank(::Type{R}) where {T,N,S,A<:Array{S},R<:Base.ReinterpretArray{T,N,S,A}}
    return ntuple(static, StaticInt(N))
end
@inline function stride_rank(::Type{A}) where {NB,NA,B<:AbstractArray{<:Any,NB},A<:Base.ReinterpretArray{<:Any,NA,<:Any,B,true}}
    NA == NB ? stride_rank(B) : _stride_rank_reinterpret(stride_rank(B), gt(StaticInt{NB}(), StaticInt{NA}()))
end
@inline function stride_rank(::Type{A}) where {N,B<:AbstractArray{<:Any,N},A<:Base.ReinterpretArray{<:Any,N,<:Any,B,false}}
    stride_rank(B)
end

@inline _stride_rank_reinterpret(sr, ::False) = (One(), map(Base.Fix2(+, One()), sr)...)
@inline _stride_rank_reinterpret(sr::Tuple{One,Vararg}, ::True) = map(Base.Fix2(-, One()), tail(sr))
function contiguous_axis(::Type{R}) where {T,N,S,B<:AbstractArray{S,N},R<:ReinterpretArray{T,N,S,B,false}}
    contiguous_axis(B)
end
# if the leading dim's `stride_rank` is not one, then that means the individual elements are split across an axis, which ArrayInterface
# doesn't currently have a means of representing.
@inline function contiguous_axis(::Type{A}) where {NB,NA,B<:AbstractArray{<:Any,NB},A<:Base.ReinterpretArray{<:Any,NA,<:Any,B,true}}
    _reinterpret_contiguous_axis(stride_rank(B), dense_dims(B), contiguous_axis(B), gt(StaticInt{NB}(), StaticInt{NA}()))
end
@inline _reinterpret_contiguous_axis(::Any, ::Any, ::Any, ::False) = One()
@inline _reinterpret_contiguous_axis(::Any, ::Any, ::Any, ::True) = Zero()
@generated function _reinterpret_contiguous_axis(t::Tuple{One,Vararg{StaticInt,N}}, d::Tuple{True,Vararg{StaticBool,N}}, ::One, ::True) where {N}
    for n in 1:N
        if t.parameters[n+1].parameters[1] === 2
            if d.parameters[n+1] === True
                return :(StaticInt{$n}())
            else
                return :(Zero())
            end
        end
    end
    :(Zero())
end

function stride_rank(::Type{Base.ReshapedArray{T, N, P, Tuple{Vararg{Base.SignedMultiplicativeInverse{Int},M}}}}) where {T,N,P,M}
    _reshaped_striderank(is_column_major(P), Val{N}(), Val{M}())
end
function stride_rank(::Type{Base.ReshapedArray{T, 1, A, Tuple{}}}) where {T, A}
    IfElse.ifelse(is_column_major(A) & is_dense(A), (static(1),), nothing)
end
function stride_rank(::Type{Base.ReshapedArray{T, 1, LinearAlgebra.Adjoint{T, A}, Tuple{}}}) where {T, A <: AbstractVector{T}}
    IfElse.ifelse(is_dense(A), (static(1),), nothing)
end
function stride_rank(::Type{Base.ReshapedArray{T, 1, LinearAlgebra.Transpose{T, A}, Tuple{}}}) where {T, A <: AbstractVector{T}}
    IfElse.ifelse(is_dense(A), (static(1),), nothing)
end

_reshaped_striderank(::True, ::Val{N}, ::Val{0}) where {N} = ntuple(static, StaticInt(N))
_reshaped_striderank(_, __, ___) = nothing

"""
    contiguous_batch_size(::Type{T}) -> StaticInt{N}

Returns the Base.size of contiguous batches if `!isone(stride_rank(T, contiguous_axis(T)))`.
If `isone(stride_rank(T, contiguous_axis(T)))`, then it will return `StaticInt{0}()`.
If `contiguous_axis(T) == -1`, it will return `StaticInt{-1}()`.
If unknown, it will return `nothing`.
"""
contiguous_batch_size(x) = contiguous_batch_size(typeof(x))
contiguous_batch_size(::Type{T}) where {T} = _contiguous_batch_size(contiguous_axis(T), stride_rank(T))
_contiguous_batch_size(_, __) = nothing
function _contiguous_batch_size(::StaticInt{D}, ::R) where {D,R<:Tuple}
    if R.parameters[D].parameters[1] === 1
        return Zero()
    else
        return nothing
    end
end
_contiguous_batch_size(::StaticInt{-1}, ::R) where {R<:Tuple} = -One()

contiguous_batch_size(::Type{Array{T,N}}) where {T,N} = Zero()
contiguous_batch_size(::Type{BitArray{N}}) where {N} = Zero()
contiguous_batch_size(@nospecialize T::Type{<:AbstractRange}) = Zero()
contiguous_batch_size(@nospecialize T::Type{<:Tuple}) = Zero()
@inline function contiguous_batch_size(@nospecialize T::Type{<:Union{PermutedDimsArray,Transpose,Adjoint}})
    contiguous_batch_size(parent_type(T))
end
function contiguous_batch_size(::Type{S}) where {N,NP,T,A<:AbstractArray{T,NP},I,S<:SubArray{T,N,A,I}}
    return _contiguous_batch_size(S, contiguous_batch_size(A), contiguous_axis(A))
end
_contiguous_batch_size(::Any, ::Any, ::Any) = nothing
function _contiguous_batch_size(::Type{<:SubArray{T,N,A,I}}, b::StaticInt{B}, c::StaticInt{C}) where {T,N,A,I,B,C}
    if I.parameters[C] <: AbstractUnitRange
        return b
    else
        return -One()
    end
end
contiguous_batch_size(::Type{<:Base.ReinterpretArray{T,N,S,A}}) where {T,N,S,A} = Zero()

"""
    is_column_major(A) -> StaticBool

Returns `True()` if elements of `A` are stored in column major order. Otherwise returns `False()`.
"""
is_column_major(A) = is_column_major(stride_rank(A), contiguous_batch_size(A))
is_column_major(sr::Nothing, cbs) = False()
is_column_major(sr::R, cbs) where {R} = _is_column_major(sr, cbs)
is_column_major(::AbstractRange) = False()

# cbs > 0
_is_column_major(sr::R, cbs::StaticInt) where {R} = False()
# cbs <= 0
_is_column_major(sr::R, cbs::Union{StaticInt{0},StaticInt{-1}}) where {R} = is_increasing(sr)
function is_increasing(perm::Tuple{StaticInt{X},StaticInt{Y},Vararg}) where {X, Y}
    X <= Y ? is_increasing(tail(perm)) : False()
end
is_increasing(::Tuple{StaticInt{X},StaticInt{Y}}) where {X, Y} = X <= Y ? True() : False()
is_increasing(::Tuple{StaticInt{X}}) where {X} = True()
is_increasing(::Tuple{}) = True()

"""
    dense_dims(::Type{<:AbstractArray{N}}) -> Tuple{Vararg{StaticBool,N}}

Returns a tuple of indicators for whether each axis is dense.
An axis `i` of array `A` is dense if `stride(A, i) * Base.size(A, i) == stride(A, j)`
where `stride_rank(A)[i] + 1 == stride_rank(A)[j]`.
"""
dense_dims(x) = dense_dims(typeof(x))
function dense_dims(::Type{T}) where {T}
    is_forwarding_wrapper(T) ? dense_dims(parent_type(T)) : nothing
end
_all_dense(::Val{N}) where {N} = ntuple(_ -> True(), Val{N}())

function dense_dims(@nospecialize T::Type{<:DenseArray})
    ntuple(Compat.Returns(True()), StaticInt(ndims(T)))
end
dense_dims(::Type{BitArray{N}}) where {N} = ntuple(Compat.Returns(True()), StaticInt(N))
dense_dims(@nospecialize T::Type{<:AbstractRange}) = (True(),)
dense_dims(@nospecialize T::Type{<:Tuple}) = (True(),)
function dense_dims(@nospecialize T::Type{<:VecAdjTrans})
    dense = dense_dims(parent_type(T))
    if dense === nothing
        return nothing
    else
        return (True(), first(dense))
    end
end
@inline function dense_dims(@nospecialize T::Type{<:Union{MatAdjTrans,PermutedDimsArray}})
    dense = dense_dims(parent_type(T))
    if dense === nothing
        return nothing
    else
        return map(GetIndex{false}(dense), to_parent_dims(T))
    end
end

@inline function dense_dims(@nospecialize T::Type{<:Base.ReshapedReinterpretArray})
    ddb = dense_dims(parent_type(T))
    IfElse.ifelse(Static.le(StaticInt(ndims(parent_type(T))), StaticInt(ndims(T))), (True(), ddb...), Base.tail(ddb))
end
@inline dense_dims(@nospecialize T::Type{<:Base.NonReshapedReinterpretArray}) = dense_dims(parent_type(T))

@inline function dense_dims(@nospecialize T::Type{<:SubArray})
    dd = dense_dims(parent_type(T))
    if dd === nothing
        return nothing
    else
        return _dense_dims(T, dd, Val(stride_rank(parent_type(T))))
    end
end

@generated function _dense_dims(
    ::Type{S},
    ::D,
    ::Val{R},
) where {D,R,N,NP,T,A<:AbstractArray{T,NP},I,S<:SubArray{T,N,A,I}}
    still_dense = true
    sp = rank_to_sortperm(R)
    densev = Vector{Bool}(undef, NP)
    for np = 1:NP
        spₙ = sp[np]
        if still_dense
            still_dense = D.parameters[spₙ] <: True
        end
        densev[spₙ] = still_dense
        # a dim not being complete makes later dims not dense
        still_dense &= (I.parameters[spₙ] <: Base.Slice)::Bool
    end
    dense_tup = Expr(:tuple)
    for np = 1:NP
        Iₙₚ = I.parameters[np]
        if Iₙₚ <: AbstractUnitRange
            if densev[np]
                push!(dense_tup.args, :(True()))
            else
                push!(dense_tup.args, :(False()))
            end
        elseif Iₙₚ <: AbstractVector
            push!(dense_tup.args, :(False()))
        end
    end
    # If n != N, then an axis was indexed by something other than an integer or `AbstractUnitRange`, so we return `nothing`.
    if static_length(dense_tup.args) === N
        return dense_tup
    else
        return nothing
    end
end

function dense_dims(@nospecialize T::Type{<:Base.ReshapedArray})
    d = dense_dims(parent_type(T))
    if d === nothing
        return nothing
    elseif all(Bool, d)
        return ntuple(Compat.Returns(True()), StaticInt(ndims(T)))
    else
        return ntuple(Compat.Returns(False()), StaticInt(ndims(T)))
    end
end

is_dense(A) = all(Bool, dense_dims(A)) ? True() : False()

"""
    known_strides(::Type{T}) -> Tuple
    known_strides(::Type{T}, dim) -> Union{Int,Nothing}

Returns the strides of array `A` known at compile time. Any strides that are not known at
compile time are represented by `nothing`.
"""
known_strides(x, dim) = known_strides(typeof(x), dim)
known_strides(::Type{T}, dim) where {T} = known_strides(T, to_dims(T, dim))
function known_strides(::Type{T}, dim::IntType) where {T}
    # see https://github.com/JuliaLang/julia/blob/6468dcb04ea2947f43a11f556da9a5588de512a0/base/reinterpretarray.jl#L148
    if ndims(T) < dim
        return known_length(T)
    else
        return known_strides(T)[dim]
    end
end
known_strides(::Type{<:StrideIndex{N,R,C,S,O}}) where {N,R,C,S,O} = known(S)

known_strides(x) = known_strides(typeof(x))
known_strides(::Type{T}) where {T<:Vector} = (1,)
@inline function known_strides(::Type{T}) where {T<:VecAdjTrans}
    strd = first(known_strides(parent_type(T)))
    return (strd, strd)
end
@inline function known_strides(@nospecialize T::Type{<:Union{MatAdjTrans,PermutedDimsArray}})
    map(GetIndex{false}(known_strides(parent_type(T))), to_parent_dims(T))
end
@inline function known_strides(::Type{T}) where {T<:SubArray}
    map(GetIndex{false}(known_strides(parent_type(T))), to_parent_dims(T))
end
function known_strides(::Type{T}) where {T}
    if ndims(T) === 1
        return (1,)
    else
        return size_to_strides(known_size(T), 1)
    end
end

"""
    static_strides(A) -> Tuple{Vararg{Union{Int,StaticInt}}}
    static_strides(A, dim) -> Union{Int,StaticInt}

Returns the strides of array `A`. If any strides are known at compile time,
these should be returned as `Static` numbers. For example:
```julia
julia> A = rand(3,4);

julia> static_strides(A)
(static(1), 3)
```

Additionally, the behavior differs from `Base.strides` for adjoint vectors:

```julia
julia> x = rand(5);

julia> static_strides(x')
(static(1), static(1))
```

This is to support the pattern of using just the first stride for linear indexing, `x[i]`,
while still producing correct behavior when using valid cartesian indices, such as `x[1,i]`.
```
"""
static_strides(A::StrideIndex) = getfield(A, :strides)
@inline static_strides(A::Vector{<:Any}) = (StaticInt(1),)
@inline static_strides(A::Array{<:Any,N}) where {N} = (StaticInt(1), Base.tail(Base.strides(A))...)
@inline function static_strides(x::X) where {X}
    if is_forwarding_wrapper(X)
        return static_strides(parent(x))
    elseif defines_strides(X)
        return size_to_strides(static_size(x), One())
    else
        return Base.strides(x)
    end
end

_is_column_dense(::A) where {A<:AbstractArray} =
    defines_strides(A) &&
    (ndims(A) == 0 || Bool(is_dense(A)) && Bool(is_column_major(A)))

# Fixes the example of https://github.com/JuliaArrays/jl/issues/160
function static_strides(A::ReshapedArray)
    if _is_column_dense(parent(A))
        return size_to_strides(static_size(A), One())
    else
        pst = static_strides(parent(A))
        psz = static_size(parent(A))
        # Try dimension merging in order (starting from dim1).
        # `sz1` and `st1` are the `size`/`stride` of dim1 after dimension merging.
        # `n` indicates the last merged dimension.
        # note: `st1` should be static if possible
        sz1, st1, n = merge_adjacent_dim(psz, pst)
        n == ndims(A.parent) && return size_to_strides(static_size(A), st1)
        return _reshaped_strides(static_size(A), One(), sz1, st1, n, Dims(psz), Dims(pst))
    end
end

@inline function _reshaped_strides(::Dims{0}, reshaped, msz::Int, _, ::Int, ::Dims, ::Dims)
    reshaped == msz && return ()
    throw(ArgumentError("Input is not strided."))
end
function _reshaped_strides(asz::Dims, reshaped, msz::Int, mst, n::Int, apsz::Dims, apst::Dims)
    st = reshaped * mst
    reshaped = reshaped * asz[1]
    if static_length(asz) > 1 && reshaped == msz && asz[2] != 1
        msz, mst′, n = merge_adjacent_dim(apsz, apst, n + 1)
        reshaped = 1
    else
        mst′ = Int(mst)
    end
    sts = _reshaped_strides(tail(asz), reshaped, msz, mst′, n, apsz, apst)
    return (st, sts...)
end

merge_adjacent_dim(::Tuple{}, ::Tuple{}) = 1, One(), 0
merge_adjacent_dim(szs::Tuple{Any}, sts::Tuple{Any}) = Int(szs[1]), sts[1], 1
function merge_adjacent_dim(szs::Tuple, sts::Tuple)
    if szs[1] isa One # Just ignore dimension with size 1
        sz, st, n = merge_adjacent_dim(tail(szs), tail(sts))
        return sz, st, n + 1
    elseif szs[2] isa One # Just ignore dimension with size 1
        sz, st, n = merge_adjacent_dim((szs[1], tail(tail(szs))...), (sts[1], tail(tail(sts))...))
        return sz, st, n + 1
    elseif (szs[1], szs[2], sts[1], sts[2]) isa NTuple{4,StaticInt} # the check could be done during compiling.
        if sts[2] == sts[1] * szs[1]
            szs′ = (szs[1] * szs[2], tail(tail(szs))...)
            sts′ = (sts[1], tail(tail(sts))...)
            sz, st, n = merge_adjacent_dim(szs′, sts′)
            return sz, st, n + 1
        else
            return Int(szs[1]), sts[1], 1
        end
    else # the check can't be done during compiling.
        sz, st, n = merge_adjacent_dim(Dims(szs), Dims(sts), 1)
        if (szs[1], sts[1]) isa NTuple{2,StaticInt} && szs[1] != 1
            # But the 1st stride might still be static.
            return sz, sts[1], n
        else
            return sz, st, n
        end
    end
end

function merge_adjacent_dim(psz::Dims{N}, pst::Dims{N}, n::Int) where {N}
    sz, st = psz[n], pst[n]
    while n < N
        szₙ, stₙ = psz[n+1], pst[n+1]
        if sz == 1
            sz, st = szₙ, stₙ
        elseif stₙ == st * sz
            sz *= szₙ
        elseif szₙ != 1
            break
        end
        n += 1
    end
    return sz, st, n
end

# `static_strides` for `Base.ReinterpretArray`
function static_strides(A::Base.ReinterpretArray{T,<:Any,S,<:AbstractArray{S},IsReshaped}) where {T,S,IsReshaped}
    _is_column_dense(parent(A)) && return size_to_strides(static_size(A), One())
    stp = static_strides(parent(A))
    ET, ES = static(sizeof(T)), static(sizeof(S))
    ET === ES && return stp
    IsReshaped && ET < ES && return (One(), _reinterp_strides(stp, ET, ES)...)
    first(stp) == 1 || throw(ArgumentError("Parent must be contiguous in the 1st dimension!"))
    if IsReshaped
        # The wrapper tell us `A`'s parent has static size in dim1.
        # We can make the next stride static if the following dim is still dense.
        sr = stride_rank(parent(A))
        dd = dense_dims(parent(A))
        stp′ = _new_static(stp, sr, dd, ET ÷ ES)
        return _reinterp_strides(tail(stp′), ET, ES)
    else
        return (One(), _reinterp_strides(tail(stp), ET, ES)...)
    end
end
_new_static(P,_,_,_) = P # This should never be called, just in case.
@generated function _new_static(p::P, ::SR, ::DD, ::StaticInt{S}) where {S,N,P<:NTuple{N,Union{Int,StaticInt}},SR<:NTuple{N,StaticInt},DD<:NTuple{N,StaticBool}}
    sr = fieldtypes(SR)
    j = findfirst(T -> T() == sr[1]()+1, sr)
    if !isnothing(j) && !(fieldtype(P, j) <: StaticInt) && fieldtype(DD, j) === True
        return :(tuple($((i == j ? :(static($S)) : :(p[$i]) for i in 1:N)...)))
    else
        return :(p)
    end
end
@inline function _reinterp_strides(stp::Tuple, els::StaticInt, elp::StaticInt)
    if elp % els == 0
        N = elp ÷ els
        return map(Base.Fix2(*, N), stp)
    else
        return map(stp) do i
            d, r = divrem(elp * i, els)
            iszero(r) || throw(ArgumentError("Parent's strides could not be exactly divided!"))
            d
        end
    end
end

static_strides(@nospecialize x::AbstractRange) = (One(),)
function static_strides(x::VecAdjTrans)
    st = first(static_strides(parent(x)))
    return (st, st)
end
@inline function static_strides(x::Union{MatAdjTrans,PermutedDimsArray})
    map(GetIndex{false}(static_strides(parent(x))), to_parent_dims(x))
end

getmul(x::Tuple, y::Tuple, ::StaticInt{i}) where {i} = getfield(x, i) * getfield(y, i)
function static_strides(A::SubArray)
    eachop(getmul, to_parent_dims(typeof(A)), map(maybe_static_step, A.indices), static_strides(parent(A)))
end

maybe_static_step(x::AbstractRange) = static_step(x)
maybe_static_step(_) = nothing

@generated function size_to_strides(sz::S, init) where {N,S<:Tuple{Vararg{Any,N}}}
    out = Expr(:block, Expr(:meta, :inline))
    t = Expr(:tuple, :init)
    prev = :init
    i = 1
    while i <= (N - 1)
        if S.parameters[i] <: Nothing || (i > 1 &&  t.args[i - 1] === :nothing)
            push!(t.args, :nothing)
        else
            next = Symbol(:val_, i)
            push!(out.args, :($next = $prev * getfield(sz, $i)))
            push!(t.args, next)
            prev = next
        end
        i += 1
    end
    push!(out.args, t)
    return out
end

static_strides(a, dim) = static_strides(a, to_dims(a, dim))
function static_strides(a::A, dim::IntType) where {A}
    if is_forwarding_wrapper(A)
        return static_strides(parent(a), dim)
    else
        return Base.stride(a, Int(dim))
    end
end

@inline static_stride(A::AbstractArray, ::StaticInt{N}) where {N} = static_strides(A)[N]
@inline static_stride(A::AbstractArray, ::Val{N}) where {N} = static_strides(A)[N]
static_stride(A, i) = Base.stride(A, i) # for type stability

using SafeTestsets, Pkg

const GROUP = get(ENV, "GROUP", "All")

@time begin
    if GROUP == "All" || GROUP == "Core"
        include("setup.jl")
        include("known_values.jl")
        include("array_index.jl")
        include("axes.jl")
        include("broadcast.jl")
        include("dimensions.jl")
        include("indexing.jl")
        include("ranges.jl")
        include("size.jl")
        include("stridelayout.jl")
        include("misc.jl")
        @time @safetestset "StaticArrays" begin include("staticarrays.jl") end
        @time @safetestset "OffsetArrays" begin include("offsetarrays.jl") end
    end
end

A = zeros(3, 4, 5);
A[:] = 1:60
Ap = @view(PermutedDimsArray(A,(3,1,2))[:,1:2,1])';

ap_index = StaticArrayInterface.StrideIndex(Ap)
for x_i in axes(Ap, 1)
    for y_i in axes(Ap, 2)
        @test ap_index[x_i, y_i] == ap_index[x_i, y_i]
    end
end
@test @inferred(StaticArrayInterface.known_offsets(ap_index)) === StaticArrayInterface.known_offsets(Ap)
@test @inferred(StaticArrayInterface.known_offset1(ap_index)) === StaticArrayInterface.known_offset1(Ap)
@test @inferred(StaticArrayInterface.offsets(ap_index, 1)) === StaticArrayInterface.offset1(Ap)
@test @inferred(StaticArrayInterface.offsets(ap_index, static(1))) === StaticArrayInterface.offset1(Ap)
@test @inferred(StaticArrayInterface.known_strides(ap_index)) === StaticArrayInterface.known_strides(Ap)
@test @inferred(StaticArrayInterface.contiguous_axis(ap_index)) == 1
@test @inferred(StaticArrayInterface.contiguous_axis(StaticArrayInterface.StrideIndex{2,(1,2),nothing,NTuple{2,Int},NTuple{2,Int}})) === nothing
@test @inferred(StaticArrayInterface.stride_rank(ap_index)) == (1, 3)

let v = Float64.(1:10)', v2 = transpose(parent(v))
  sv = @view(v[1:5])'
  sv2 = @view(v2[1:5])'
  @test @inferred(StaticArrayInterface.StrideIndex(sv)) === @inferred(StaticArrayInterface.StrideIndex(sv2)) === StaticArrayInterface.StrideIndex{2, (2, 1), 2}((StaticInt(1), StaticInt(1)), (StaticInt(1), StaticInt(1)))
  @test @inferred(StaticArrayInterface.stride_rank(parent(sv))) === @inferred(StaticArrayInterface.stride_rank(parent(sv2))) === (StaticInt(1),)
end


@testset "IndicesInfo" begin

  struct SplatFirst end

  import StaticArrayInterface: IndicesInfo

  StaticArrayInterface.is_splat_index(::Type{SplatFirst}) = true

  @test @inferred(IndicesInfo(SubArray{Float64, 2, Vector{Float64}, Tuple{Base.ReshapedArray{Int64, 2, UnitRange{Int64}, Tuple{}}}, true})) isa
      IndicesInfo{1,(1,),((1,2),)}

  @test @inferred(IndicesInfo{1}((Tuple{Vector{Int}}))) isa IndicesInfo{1, (1,), (1,)}

  @test @inferred(IndicesInfo{2}(Tuple{Vector{Int}})) isa IndicesInfo{2, (:,), (1,)}

  @test @inferred(IndicesInfo{1}(Tuple{SplatFirst})) isa IndicesInfo{1, (1,), (1,)}

  @test @inferred(IndicesInfo{2}(Tuple{SplatFirst})) isa IndicesInfo{2, ((1,2),), ((1, 2),)}

  @test @inferred(IndicesInfo{5}(typeof((:,[CartesianIndex(1,1),CartesianIndex(1,1)], 1, ones(Int, 2, 2), :, 1)))) isa
      IndicesInfo{5, (1, (2, 3), 4, 5, 0, 0), (1, 2, 0, (3, 4), 5, 0)}

  @test @inferred(IndicesInfo{10}(Tuple{Vararg{Int,10}})) isa
      IndicesInfo{10, (1, 2, 3, 4, 5, 6, 7, 8, 9, 10), (0, 0, 0, 0, 0, 0, 0, 0, 0, 0)}

  @test @inferred(IndicesInfo{10}(typeof((1, CartesianIndex(2, 1), 2, CartesianIndex(1, 2), 1, CartesianIndex(2, 1), 2)))) isa
      IndicesInfo{10, (1, (2, 3), 4, (5, 6), 7, (8, 9), 10), (0, 0, 0, 0, 0, 0, 0)}

  @test @inferred(IndicesInfo{10}(typeof((fill(true, 4, 4), 2, fill(true, 4, 4), 2, 1, fill(true, 4, 4), 1)))) isa
      IndicesInfo{10, ((1, 2), 3, (4, 5), 6, 7, (8, 9), 10), (1, 0, 2, 0, 0, 3, 0)}

  @test @inferred(IndicesInfo{10}(typeof((1, SplatFirst(), 2, SplatFirst(), CartesianIndex(1, 1))))) isa
      IndicesInfo{10, (1, (2, 3, 4, 5, 6), 7, 8, (9, 10)), (0, (1, 2, 3, 4, 5), 0, 6, 0)}
end

###
### define wrapper with StaticArrayInterface.dimnames
###

@testset "order_named_inds" begin
    n1 = (static(:x),)
    n2 = (n1..., static(:y))
    n3 = (n2..., static(:z))
    @test @inferred(StaticArrayInterface.find_all_dimnames(n1, (), (), :)) == ()
    @test @inferred(StaticArrayInterface.find_all_dimnames(n1, (static(:x),), (2,), :)) == (2,)
    @test @inferred(StaticArrayInterface.find_all_dimnames(n2, (static(:x),), (2,), :)) == (2, :)
    @test @inferred(StaticArrayInterface.find_all_dimnames(n2, (static(:y),), (2,), :)) == (:, 2)
    @test @inferred(StaticArrayInterface.find_all_dimnames(n2, (static(:y), static(:x)), (20, 30), :)) == (30, 20)
    @test @inferred(StaticArrayInterface.find_all_dimnames(n2, (static(:x), static(:y)), (30, 20), :)) == (30, 20)
    @test @inferred(StaticArrayInterface.find_all_dimnames(n3, (static(:x), static(:y)), (30, 20), :)) == (30, 20, :)

    @test_throws ErrorException StaticArrayInterface.find_all_dimnames(n2, (static(:x), static(:y), static(:z)), (30, 20, 40), :)
end

@testset "StaticArrayInterface.dimnames" begin
    d = (static(:x), static(:y))
    x = NamedDimsWrapper(d, ones(Int64, 2, 2))
    y = NamedDimsWrapper((static(:x),), ones(2))
    z = NamedDimsWrapper((:x, static(:y)), ones(2))
    r1 = reinterpret(Int8, x)
    r2 = reinterpret(reshape, Int8, x)
    r3 = reinterpret(reshape, Complex{Int}, x)
    r4 = reinterpret(reshape, Float64, x)
    w = Wrapper(x)
    dnums = ntuple(+, length(d))
    @test @inferred(StaticArrayInterface.has_dimnames(x)) == true
    @test @inferred(StaticArrayInterface.has_dimnames(z)) == true
    @test @inferred(StaticArrayInterface.has_dimnames(ones(2, 2))) == false
    @test @inferred(StaticArrayInterface.has_dimnames(Array{Int,2})) == false
    @test @inferred(StaticArrayInterface.has_dimnames(typeof(x))) == true
    @test @inferred(StaticArrayInterface.has_dimnames(typeof(view(x, :, 1, :)))) == true
    @test @inferred(StaticArrayInterface.dimnames(x)) === d
    @test @inferred(StaticArrayInterface.dimnames(w)) === d
    @test @inferred(StaticArrayInterface.dimnames(r1)) === d
    @test @inferred(StaticArrayInterface.dimnames(r2)) === (static(:_), d...)
    @test @inferred(StaticArrayInterface.dimnames(r3)) === Base.tail(d)
    @test @inferred(StaticArrayInterface.dimnames(r4)) === d
    @test @inferred(StaticArrayInterface.StaticArrayInterface.dimnames(z)) === (:x, static(:y))
    @test @inferred(StaticArrayInterface.dimnames(parent(x))) === (static(:_), static(:_))
    @test @inferred(StaticArrayInterface.dimnames(reshape(x, (1, 4)))) === d
    @test @inferred(StaticArrayInterface.dimnames(reshape(x, :))) === (static(:_),)
    @test @inferred(StaticArrayInterface.dimnames(x')) === reverse(d)
    @test @inferred(StaticArrayInterface.dimnames(y')) === (static(:_), static(:x))
    @test @inferred(StaticArrayInterface.dimnames(PermutedDimsArray(x, (2, 1)))) === reverse(d)
    @test @inferred(StaticArrayInterface.dimnames(PermutedDimsArray(x', (2, 1)))) === d
    @test @inferred(StaticArrayInterface.dimnames(view(x, :, 1))) === (static(:x),)
    @test @inferred(StaticArrayInterface.dimnames(view(x, :, 1)')) === (static(:_), static(:x))
    @test @inferred(StaticArrayInterface.dimnames(view(x, :, :, :))) === (static(:x), static(:y), static(:_))
    @test @inferred(StaticArrayInterface.dimnames(view(x, :, 1, :))) === (static(:x), static(:_))
    # multidmensional indices
    @test @inferred(StaticArrayInterface.dimnames(view(x, ones(Int, 2, 2), 1))) === (static(:_), static(:_))
    @test @inferred(StaticArrayInterface.dimnames(view(x, [CartesianIndex(1,1), CartesianIndex(1,1)]))) === (static(:_),)

    @test @inferred(StaticArrayInterface.dimnames(x, Static.One())) === static(:x)
    @test @inferred(StaticArrayInterface.dimnames(parent(x), Static.One())) === static(:_)
    @test @inferred(StaticArrayInterface.known_dimnames(Iterators.flatten(1:10))) === (:_,)
    @test @inferred(StaticArrayInterface.known_dimnames(Iterators.flatten(1:10), static(1))) === :_
    # multidmensional indices
    @test @inferred(StaticArrayInterface.known_dimnames(view(x, ones(Int, 2, 2), 1))) === (:_, :_)
    @test @inferred(StaticArrayInterface.known_dimnames(view(x, [CartesianIndex(1,1), CartesianIndex(1,1)]))) === (:_,)

    @test @inferred(StaticArrayInterface.known_dimnames(z)) === (nothing, :y)
    @test @inferred(StaticArrayInterface.known_dimnames(reshape(x, (1, 4)))) === (:x, :y)
    @test @inferred(StaticArrayInterface.known_dimnames(r1)) === (:x, :y)
    @test @inferred(StaticArrayInterface.known_dimnames(r2)) === (:_, :x, :y)
    @test @inferred(StaticArrayInterface.known_dimnames(r3)) === (:y,)
    @test @inferred(StaticArrayInterface.known_dimnames(r4)) === (:x, :y)
    @test @inferred(StaticArrayInterface.known_dimnames(w)) === (:x, :y)
    @test @inferred(StaticArrayInterface.known_dimnames(reshape(x, :))) === (:_,)
    @test @inferred(StaticArrayInterface.known_dimnames(view(x, :, 1)')) === (:_, :x)
end

@testset "to_dims" begin
    x = NamedDimsWrapper(static((:x, :y)), ones(2, 2))
    y = NamedDimsWrapper(static((:x, :y, :a, :b, :c, :d)), ones(6))

    @test @inferred(StaticArrayInterface.to_dims(x, :)) == Colon()
    @test @inferred(StaticArrayInterface.to_dims(x, 1)) == 1
    @testset "small case" begin
        @test @inferred(StaticArrayInterface.to_dims(x, (:x, :y))) == (1, 2)
        @test @inferred(StaticArrayInterface.to_dims(x, (:y, :x))) == (2, 1)
        @test @inferred(StaticArrayInterface.to_dims(x, :x)) == 1
        @test @inferred(StaticArrayInterface.to_dims(x, :y)) == 2
        @test_throws DimensionMismatch StaticArrayInterface.to_dims(x, static(:z))  # not found
        @test_throws DimensionMismatch StaticArrayInterface.to_dims(x, :z)  # not found
    end

    @testset "large case" begin
        @test @inferred(StaticArrayInterface.to_dims(y, :x)) == 1
        @test @inferred(StaticArrayInterface.to_dims(y, :a)) == 3
        @test @inferred(StaticArrayInterface.to_dims(y, :d)) == 6
        @test_throws DimensionMismatch StaticArrayInterface.to_dims(y, :z) # not found
    end
end

@testset "methods accepting StaticArrayInterface.dimnames" begin
    d = (static(:x), static(:y))
    x = NamedDimsWrapper(d, ones(2, 2))
    y = NamedDimsWrapper((static(:x),), ones(2))
    @test @inferred(size(x, first(d))) == size(parent(x), 1)
    @test @inferred(StaticArrayInterface.static_axes(y')) == (static(1):static(1), Base.OneTo(2))
    @test @inferred(axes(x, first(d))) == axes(parent(x), 1)
    @test strides(x, :x) == StaticArrayInterface.static_strides(parent(x))[1]
    @test @inferred(StaticArrayInterface.axes_types(x, static(:x))) <: Base.OneTo{Int}
    @test StaticArrayInterface.axes_types(x, :x) <: Base.OneTo{Int}
    @test @inferred(StaticArrayInterface.axes_types(LinearIndices{2,NTuple{2,Base.OneTo{Int}}})) <: NTuple{2,Base.OneTo{Int}}
    CI = CartesianIndices{2,Tuple{Base.OneTo{Int},UnitRange{Int}}}
    @test @inferred(StaticArrayInterface.axes_types(CI, static(1))) <: Base.OneTo{Int}

    x[x=1] = [2, 3]
    @test @inferred(getindex(x, x=1)) == [2, 3]
    y = NamedDimsWrapper((:x, static(:y)), ones(2, 2))
    # FIXME this doesn't correctly infer the output because it can't infer
    @test getindex(y, x=1) == [1, 1]
end

_init_dimsmap(x) = _init_dimsmap(IndicesInfo(x))
function _init_dimsmap(@nospecialize info::IndicesInfo)
    pdims = parentdims(info)
    cdims = childdims(info)
    ntuple(i -> static(getfield(pdims, i)), static_length(pdims)),
    ntuple(i -> static(getfield(cdims, i)), static_length(pdims))
end

"""
    to_parent_dims(::Type{T}) -> Tuple{Vararg{Union{StaticInt,Tuple{Vararg{StaticInt}}}}}

Returns the mapping from child dimensions to parent dimensions.

!!! Warning
    This method is still experimental and may change without notice.

"""
to_parent_dims(@nospecialize x) = to_parent_dims(typeof(x))
@inline function to_parent_dims(@nospecialize T::Type{<:SubArray})
    to_parent_dims(IndicesInfo{ndims(parent_type(T))}(fieldtype(T, :indices)))
end
to_parent_dims(info::IndicesInfo) = flatten_tuples(map(_to_pdim, map_indices_info(info)))
_to_pdim(::Tuple{StaticInt,Any,StaticInt{0}}) = ()
_to_pdim(x::Tuple{StaticInt,Any,StaticInt{cdim}}) where {cdim} = getfield(x, 2)
_to_pdim(x::Tuple{StaticInt,Any,Tuple}) = (ntuple(Compat.Returns(getfield(x, 2)), static_length(getfield(x, 3))),)
to_parent_dims(@nospecialize T::Type{<:MatAdjTrans}) = (StaticInt(2), StaticInt(1))
to_parent_dims(@nospecialize T::Type{<:PermutedDimsArray}) = getfield(_permdims(T), 1)

function _permdims(::Type{<:PermutedDimsArray{<:Any,<:Any,I1,I2}}) where {I1,I2}
    (map(static, I1), map(static, I2))
end

# Base will sometimes demote statically known slices in `SubArray` to `OneTo{Int}` so we
# provide the parent mapping to check for static size info
@inline function sub_axes_map(@nospecialize(T::Type{<:SubArray}))
    map(Base.Fix1(_sub_axis_map, T), map_indices_info(IndicesInfo(T)))
end
function _sub_axis_map(@nospecialize(T::Type{<:SubArray}), x::Tuple{StaticInt{index},Any,Any}) where {index}
    if fieldtype(fieldtype(T, :indices), index) <: Base.Slice{OneTo{Int}}
        sz = known_size(parent_type(T), getfield(x, 2))
        return sz === nothing ? StaticInt(index) : StaticInt(1):StaticInt(sz)
    else
        return StaticInt(index)
    end
end

function map_indices_info(@nospecialize info::IndicesInfo)
    pdims = parentdims(info)
    cdims = childdims(info)
    ntuple(i -> (static(i), static(getfield(pdims, i)), static(getfield(cdims, i))), static_length(pdims))
end
function sub_dimnames_map(dnames::Tuple, imap::Tuple)
    flatten_tuples(map(Base.Fix1(_to_dimname, dnames), imap))
end
@inline function _to_dimname(dnames::Tuple, x::Tuple{StaticInt,PD,CD}) where {PD,CD}
    if CD <: StaticInt{0}
        return ()
    elseif CD <: Tuple
        return ntuple(Compat.Returns(static(:_)), StaticInt(known_length(CD)))
    elseif PD <: StaticInt{0} || PD <: Tuple
        return static(:_)
    else
        return getfield(dnames, known(PD))
    end
end

"""
    from_parent_dims(::Type{T}) -> Tuple{Vararg{Union{StaticInt,Tuple{Vararg{StaticInt}}}}}

Returns the mapping from parent dimensions to child dimensions.

!!! Warning
    This method is still experimental and may change without notice.

"""
from_parent_dims(@nospecialize x) = from_parent_dims(typeof(x))
from_parent_dims(@nospecialize T::Type{<:PermutedDimsArray}) = getfield(_permdims(T), 2)
from_parent_dims(@nospecialize T::Type{<:MatAdjTrans}) = (StaticInt(2), StaticInt(1))
@inline function from_parent_dims(@nospecialize T::Type{<:SubArray})
    from_parent_dims(IndicesInfo{ndims(parent_type(T))}(fieldtype(T, :indices)))
end
# TODO do I need to flatten_tuples here?
function from_parent_dims(@nospecialize(info::IndicesInfo))
    pdims = parentdims(info)
    cdims = childdims(info)
    ntuple(static_length(cdims)) do i
        pdim_i = getfield(pdims, i)
        cdim_i = static(getfield(cdims, i))
        pdim_i isa Int ? cdim_i : ntuple(Compat.Returns(cdim_i), static_length(pdim_i))
    end
end

"""
    has_dimnames(::Type{T}) -> Bool

Returns `true` if `x` has on or more named dimensions. If all dimensions correspond
to `:_`, then `false` is returned.
"""
@inline has_dimnames(x) = static(known_dimnames(x) !== ntuple(Compat.Returns(:_), Val(ndims(x))))

"""
    known_dimnames(::Type{T}) -> Tuple{Vararg{Union{Symbol,Nothing}}}
    known_dimnames(::Type{T}, dim::Union{Int,StaticInt}) -> Union{Symbol,Nothing}

Return the names of the dimensions for `x`. `:_` is used to indicate a dimension does not
have a name.
"""
@inline known_dimnames(x, dim) = _known_dimname(known_dimnames(x), IntType(dim))
known_dimnames(x) = known_dimnames(typeof(x))
function known_dimnames(@nospecialize T::Type{<:VecAdjTrans})
    (:_, getfield(known_dimnames(parent_type(T)), 1))
end
function known_dimnames(@nospecialize T::Type{<:Union{MatAdjTrans,PermutedDimsArray}})
    map(GetIndex{false}(known_dimnames(parent_type(T))), to_parent_dims(T))
end

function known_dimnames(@nospecialize T::Type{<:SubArray})
    dynamic(sub_dimnames_map(known_dimnames(parent_type(T)), map_indices_info(IndicesInfo(T))))
end

function known_dimnames(::Type{<:ReinterpretArray{T,N,S,A,IsReshaped}}) where {T,N,S,A,IsReshaped}
    pnames = known_dimnames(A)
    if IsReshaped
        if sizeof(S) === sizeof(T)
            return pnames
        elseif sizeof(S) > sizeof(T)
            return (:_, pnames...)
        else
            return tail(pnames)
        end
    else
        return pnames
    end
end

@inline function known_dimnames(@nospecialize T::Type{<:Base.ReshapedArray})
    if ndims(T) === ndims(parent_type(T))
        return known_dimnames(parent_type(T))
    elseif ndims(T) > ndims(parent_type(T))
        return flatten_tuples((known_dimnames(parent_type(T)), ntuple(Compat.Returns(:_), StaticInt(ndims(T) - ndims(parent_type(T))))))
    else
        return ntuple(Compat.Returns(:_), StaticInt(ndims(T)))
    end
end
@inline function known_dimnames(::Type{T}) where {T}
    if is_forwarding_wrapper(T)
        return known_dimnames(parent_type(T))
    else
        return _unknown_dimnames(Base.IteratorSize(T))
    end
end

_unknown_dimnames(::Base.HasShape{N}) where {N} = ntuple(Compat.Returns(:_), StaticInt(N))
_unknown_dimnames(::Any) = (:_,)

@inline function _known_dimname(x::Tuple{Vararg{Any,N}}, dim::IntType) where {N}
    # we cannot have `@boundscheck`, else this will depend on bounds checking being enabled
    (dim > N || dim < 1) && return :_
    return @inbounds(x[dim])
end
@inline _inbounds_known_dimname(x, dim) = @inbounds(_known_dimname(x, dim))

"""
    dimnames(x) -> Tuple{Vararg{Union{Symbol,StaticSymbol}}}
    dimnames(x, dim::Union{Int,StaticInt}) -> Union{Symbol,StaticSymbol}

Return the names of the dimensions for `x`. `:_` is used to indicate a dimension does not
have a name.
"""
@inline dimnames(x, dim) = _dimname(dimnames(x), IntType(dim))
@inline function dimnames(x::Union{PermutedDimsArray,MatAdjTrans})
    map(GetIndex{false}(dimnames(parent(x))), to_parent_dims(x))
end

function dimnames(x::SubArray)
    sub_dimnames_map(dimnames(parent(x)), map_indices_info(IndicesInfo(typeof(x))))
end

dimnames(x::VecAdjTrans) = (static(:_), getfield(dimnames(parent(x)), 1))
@inline function dimnames(x::ReinterpretArray{T,N,S,A,IsReshaped}) where {T,N,S,A,IsReshaped}
    pnames = dimnames(parent(x))
    if IsReshaped
        if sizeof(S) === sizeof(T)
            return pnames
        elseif sizeof(S) > sizeof(T)
            return flatten_tuples((static(:_), pnames))
        else
            return tail(pnames)
        end
    else
        return pnames
    end
end
@inline function dimnames(x::Base.ReshapedArray)
    p = parent(x)
    if ndims(x) === ndims(p)
        return dimnames(p)
    elseif ndims(x) > ndims(p)
        return flatten_tuples((dimnames(p), ntuple(Compat.Returns(static(:_)), StaticInt(ndims(x) - ndims(p)))))
    else
        return ntuple(Compat.Returns(static(:_)), StaticInt(ndims(x)))
    end
end
@inline function dimnames(x::X) where {X}
    if is_forwarding_wrapper(X)
        return dimnames(parent(x))
    else
        return ntuple(Compat.Returns(static(:_)), StaticInt(ndims(x)))
    end
end
@inline function _dimname(x::Tuple{Vararg{Any,N}}, dim::IntType) where {N}
    # we cannot have `@boundscheck`, else this will depend on bounds checking being enabled
    # for calls such as `dimnames(view(x, :, 1, :))`
    (dim > N || dim < 1) && return static(:_)
    return @inbounds(x[dim])
end
@inline _inbounds_dimname(x, dim) = @inbounds(_dimname(x, dim))

"""
    to_dims(x, dim) -> Union{Int,StaticInt}

This returns the dimension(s) of `x` corresponding to `dim`.
"""
to_dims(x, dim::Colon) = dim
to_dims(x, @nospecialize(dim::IntType)) = dim
to_dims(x, dim::Integer) = Int(dim)
to_dims(x, dim::Union{StaticSymbol,Symbol}) = _to_dim(dimnames(x), dim)
function to_dims(x, dims::Tuple{Vararg{Any,N}}) where {N}
    eachop(_to_dims, ntuple(static, StaticInt(N)), dimnames(x), dims)
end
@inline _to_dims(x::Tuple, d::Tuple, n::StaticInt{N}) where {N} = _to_dim(x, getfield(d, N))
@inline function _to_dim(x::Tuple, d::Union{Symbol,StaticSymbol})
    i = find_first_eq(d, x)
    i === nothing && throw(DimensionMismatch("dimension name $(d) not found"))
    return i
end

#=
    order_named_inds(names, namedtuple)
    order_named_inds(names, subnames, inds)

Returns the tuple of index values for an array with `names`, when indexed by keywords.
Any dimensions not fixed are given as `:`, to make a slice.
An error is thrown if any keywords are used which do not occur in `nda`'s names.


1. parse into static dimnension names and key words.
2. find each dimnames in key words
3. if nothing is found use Colon()
4. if (ndims - ncolon) === nkwargs then all were found, else error
=#
@generated function find_all_dimnames(x::Tuple{Vararg{Any,ND}}, nd::Tuple{Vararg{Any,NI}}, inds::Tuple, default) where {ND,NI}
    if NI === 0
        return :(())
    else
        out = Expr(:block, Expr(:(=), :names_found, 0))
        t = Expr(:tuple)
        for i in 1:ND
            index_i = Symbol(:index_, i)
            val_i = Symbol(:val_, i)
            push!(t.args, val_i)
            push!(out.args, quote
                $index_i = find_first_eq(getfield(x, $i), nd)
                if $index_i === nothing
                    $val_i = default
                else
                    $val_i = @inbounds(inds[$index_i])
                    names_found += 1
                end
            end)
        end
        return quote
            $out
            @boundscheck names_found === $NI || error("Not all keywords matched dimension names.")
            return $t
        end
    end
end

"""
    static_to_indices(A, I::Tuple) -> Tuple

Converts the tuple of indexing arguments, `I`, into an appropriate form for indexing into `A`.
Typically, each index should be an `Int`, `StaticInt`, a collection with values of `Int`, or a collection with values of `CartesianIndex`
This is accomplished in three steps after the initial call to `static_to_indices`:

# Extended help

This implementation differs from that of `Base.to_indices` in the following ways:

*  `static_to_indices(A, I)` never results in recursive processing of `I` through
  `static_to_indices(A, static_axes(A), I)`. This is avoided through the use of an internal `@generated`
  method that aligns calls of `static_to_indices` and `to_index` based on the return values of
  `ndims_index`. This is beneficial because the compiler currently does not optimize away
  the increased time spent recursing through
    each additional argument that needs converting. For example:
    ```julia
    julia> x = rand(4,4,4,4,4,4,4,4,4,4);

    julia> inds1 = (1, 2, 1, 2, 1, 2, 1, 2, 1, 2);

    julia> inds2 = (1, CartesianIndex(1, 2), 1, CartesianIndex(1, 2), 1, CartesianIndex(1, 2), 1);

    julia> inds3 = (fill(true, 4, 4), 2, fill(true, 4, 4), 2, 1, fill(true, 4, 4), 1);

    julia> @btime Base.to_indices(\$x, \$inds2)
    1.105 μs (12 allocations: 672 bytes)
    (1, 1, 2, 1, 1, 2, 1, 1, 2, 1)

    julia> @btime static_to_indices(\$x, \$inds2)
    0.041 ns (0 allocations: 0 bytes)
    (1, 1, 2, 1, 1, 2, 1, 1, 2, 1)

    julia> @btime Base.to_indices(\$x, \$inds3);
    340.629 ns (14 allocations: 768 bytes)

    julia> @btime static_to_indices(\$x, \$inds3);
    11.614 ns (0 allocations: 0 bytes)

    ```
* Recursing through `static_to_indices(A, axes, I::Tuple{I1,Vararg{Any}})` is intended to provide
  context for processing `I1`. However, this doesn't tell use how many dimensions are
  consumed by what is in `Vararg{Any}`. Using `ndims_index` to directly align the axes of
  `A` with each value in `I` ensures that a `CartesiaIndex{3}` at the tail of `I` isn't
  incorrectly assumed to only consume one dimension.
* `Base.to_indices` may fail to infer the returned type. This is the case for `inds2` and
  `inds3` in the first bullet on Julia 1.6.4.
* Specializing by dispatch through method definitions like this:
  `static_to_indices(::ArrayType, ::Tuple{AxisType,Vararg{Any}}, ::Tuple{::IndexType,Vararg{Any}})`
  require an excessive number of hand written methods to avoid ambiguities. Furthermore, if
  `AxisType` is wrapping another axis that should have unique behavior, then unique parametric
  types need to also be explicitly defined.
* `to_index(static_axes(A, dim), index)` is called, as opposed to `Base.to_index(A, index)`. The
  `IndexStyle` of the resulting axis is used to allow indirect dispatch on nested axis types
  within `to_index`.
"""
static_to_indices(A, ::Tuple{}) = ()
@inline function static_to_indices(a::A, inds::I) where {A,I}
    flatten_tuples(map(IndexedMappedArray(a), inds, getfield(_init_dimsmap(IndicesInfo{ndims(A)}(I)), 1)))
end

struct IndexedMappedArray{A}
    a::A
end
@inline (ima::IndexedMappedArray{A})(idx::I, ::StaticInt{0}) where {A,I} = to_index(StaticInt(1):StaticInt(1), idx)
@inline (ima::IndexedMappedArray{A})(idx::I, ::Colon) where {A,I} = to_index(lazy_axes(ima.a, :), idx)
@inline (ima::IndexedMappedArray{A})(idx::I, d::StaticInt{D}) where {A,I,D} = to_index(lazy_axes(ima.a, d), idx)
@inline function (ima::IndexedMappedArray{A})(idx::AbstractArray{Bool}, dims::Tuple) where {A}
    if (last(dims) == ndims(A)) && (IndexStyle(A) isa IndexLinear)
        # Match Base.to_indices behavior for trailing boolean arrays.
        # Julia >= 1.12 uses LogicalIndex(idx) which gives CartesianIndex{N} for N-D booleans.
        # Julia < 1.12 uses LogicalIndex{Int}(idx) which gives linear indices.
        @static if VERSION >= v"1.12-"
            return LogicalIndex(idx)
        else
            return LogicalIndex{Int}(idx)
        end
    else
        return LogicalIndex(idx)
    end
end
@inline (ima::IndexedMappedArray{A})(idx::CartesianIndex, ::Tuple) where {A} = getfield(idx, 1)
@inline function (ima::IndexedMappedArray{A})(idx::I, dims::Tuple) where {A,I}
    to_index(CartesianIndices(lazy_axes(ima.a, dims)), idx)
end

"""
    to_index([::IndexStyle, ]axis, arg) -> index

Convert the argument `arg` that was originally passed to `static_getindex` for the
dimension corresponding to `axis` into a form for native indexing (`Int`, Vector{Int}, etc.).

`to_index` supports passing a function as an index. This function-index is
transformed into a proper index.

```julia
julia> using ArrayInterface, Static

julia> to_index(static(1):static(10), 5)
5

julia> to_index(static(1):static(10), <(5))
static(1):4

julia> to_index(static(1):static(10), <=(5))
static(1):5

julia> to_index(static(1):static(10), >(5))
6:static(10)

julia> to_index(static(1):static(10), >=(5))
5:static(10)

```

Use of a function-index helps ensure that indices are inbounds

```julia
julia> to_index(static(1):static(10), <(12))
static(1):10

julia> to_index(static(1):static(10), >(-1))
1:static(10)
```

New axis types with unique behavior should use an `IndexStyle` trait:
```julia
to_index(axis::MyAxisType, arg) = to_index(IndexStyle(axis), axis, arg)
to_index(::MyIndexStyle, axis, arg) = ...
```

"""
to_index(x, i::Slice) = i
to_index(x, ::Colon) = indices(x)
to_index(::LinearIndices{0,Tuple{}}, ::Colon) = Slice(static(1):static(1))
to_index(::CartesianIndices{0,Tuple{}}, ::Colon) = Slice(static(1):static(1))
# logical indexing
to_index(x, i::AbstractArray{Bool}) = LogicalIndex(i)
to_index(::LinearIndices, i::AbstractArray{Bool}) = LogicalIndex{Int}(i)
# cartesian indexing
@inline to_index(x, i::CartesianIndices{0}) = i
@inline to_index(x, i::CartesianIndices) = getfield(i, :indices)
@inline to_index(x, i::CartesianIndex) = getfield(i, 1)
@inline to_index(x, i::NDIndex) = getfield(i, 1)
@inline to_index(x, i::AbstractArray{<:AbstractCartesianIndex}) = i
@inline function to_index(x, i::Base.Fix2{<:Union{typeof(<),typeof(isless)},<:Union{Base.BitInteger,StaticInt}})
    static_first(x):min(_sub1(IntType(i.x)), static_last(x))
end
@inline function to_index(x, i::Base.Fix2{typeof(<=),<:Union{Base.BitInteger,StaticInt}})
    static_first(x):min(IntType(i.x), static_last(x))
end
@inline function to_index(x, i::Base.Fix2{typeof(>=),<:Union{Base.BitInteger,StaticInt}})
    max(IntType(i.x), static_first(x)):static_last(x)
end
@inline function to_index(x, i::Base.Fix2{typeof(>),<:Union{Base.BitInteger,StaticInt}})
    max(_add1(IntType(i.x)), static_first(x)):static_last(x)
end
# integer indexing
to_index(x, i::AbstractArray{<:Integer}) = i
to_index(x, @nospecialize(i::StaticInt)) = i
to_index(x, i::Integer) = Int(i)
@inline to_index(x, i) = to_index(IndexStyle(x), x, i)
function to_index(S::IndexStyle, x, i)
    throw(ArgumentError(
        "invalid index: $S does not support indices of type $(typeof(i)) for instances of type $(typeof(x))."
    ))
end

"""
    unsafe_reconstruct(A, data; kwargs...)

Reconstruct `A` given the values in `data`. New methods using `unsafe_reconstruct`
should only dispatch on `A`.
"""
function unsafe_reconstruct(axis::OneTo, data; kwargs...)
    if axis === data
        return axis
    else
        return OneTo(data)
    end
end
function unsafe_reconstruct(axis::UnitRange, data; kwargs...)
    if axis === data
        return axis
    else
        return UnitRange(first(data), last(data))
    end
end
function unsafe_reconstruct(axis::OptionallyStaticUnitRange, data; kwargs...)
    if axis === data
        return axis
    else
        return OptionallyStaticUnitRange(static_first(data), static_last(data))
    end
end
function unsafe_reconstruct(A::AbstractUnitRange, data; kwargs...)
    return static_first(data):static_last(data)
end

"""
    to_axes(A, inds) -> Tuple

Construct new axes given the corresponding `inds` constructed after
`to_indices(A, args) -> inds`. This method iterates through each pair of axes and
indices calling [`to_axis`](@ref).
"""
@inline function to_axes(A, inds::Tuple)
    if ndims(A) === 1
        return (to_axis(static_axes(A, 1), first(inds)),)
    elseif Base.length(inds) === 1
        return (to_axis(eachindex(IndexLinear(), A), first(inds)),)
    else
        return to_axes(A, static_axes(A), inds)
    end
end
# drop this dimension
to_axes(A, a::Tuple, i::Tuple{<:IntType,Vararg{Any}}) = to_axes(A, _maybe_tail(a), tail(i))
to_axes(A, a::Tuple, i::Tuple{I,Vararg{Any}}) where {I} = _to_axes(StaticInt(ndims_index(I)), A, a, i)
function _to_axes(::StaticInt{1}, A, axs::Tuple, inds::Tuple)
    return (to_axis(_maybe_first(axs), first(inds)), to_axes(A, _maybe_tail(axs), tail(inds))...)
end
@propagate_inbounds function _to_axes(::StaticInt{N}, A, axs::Tuple, inds::Tuple) where {N}
    axes_front, axes_tail = Base.IteratorsMD.split(axs, Val(N))
    if IndexStyle(A) === IndexLinear()
        axis = to_axis(LinearIndices(axes_front), getfield(inds, 1))
    else
        axis = to_axis(CartesianIndices(axes_front), getfield(inds, 1))
    end
    return (axis, to_axes(A, axes_tail, tail(inds))...)
end
to_axes(A, ::Tuple{Ax,Vararg{Any}}, ::Tuple{}) where {Ax} = ()
to_axes(A, ::Tuple{}, ::Tuple{}) = ()

_maybe_first(::Tuple{}) = static(1):static(1)
_maybe_first(t::Tuple) = first(t)
_maybe_tail(::Tuple{}) = ()
_maybe_tail(t::Tuple) = tail(t)

"""
    to_axis(old_axis, index) -> new_axis

Construct an `new_axis` for a newly constructed array that corresponds to the
previously executed `to_index(old_axis, arg) -> index`. `to_axis` assumes that
`index` has already been confirmed to be in bounds. The underlying indices of
`new_axis` begins at one and extends the length of `index` (i.e., one-based indexing).
"""
@inline function to_axis(axis, inds)
    if !can_change_size(axis) &&
       (known_length(inds) !== nothing && known_length(axis) === known_length(inds))
        return axis
    else
        return to_axis(IndexStyle(axis), axis, inds)
    end
end

# don't need to check size b/c slice means it's the entire axis
@inline function to_axis(axis, inds::Slice)
    if can_change_size(axis)
        return copy(axis)
    else
        return axis
    end
end
to_axis(S::IndexLinear, axis, inds) = StaticInt(1):static_length(inds)

"""
    static_getindex(A, args...)

Retrieve the value(s) stored at the given key or index within a collection. Creating
another instance of `static_getindex` should only be done by overloading `A`.
Changing indexing based on a given argument from `args` should be done through,
[`to_index`](@ref), or [`to_axis`](@ref).
"""
function static_getindex(A, args...)
    inds = static_to_indices(A, args)
    @boundscheck checkbounds(A, inds...)
    unsafe_getindex(A, inds...)
end
@propagate_inbounds function static_getindex(A; kwargs...)
    inds = static_to_indices(A, find_all_dimnames(dimnames(A), static(keys(kwargs)), Tuple(values(kwargs)), :))
    @boundscheck checkbounds(A, inds...)
    unsafe_getindex(A, inds...)
end
@propagate_inbounds static_getindex(x::Tuple, i::Int) = getfield(x, i)
@propagate_inbounds static_getindex(x::Tuple, ::StaticInt{i}) where {i} = getfield(x, i)

## unsafe_getindex ##
function unsafe_getindex(a::A) where {A}
    is_forwarding_wrapper(A) || throw(MethodError(unsafe_getindex, (A,)))
    unsafe_getindex(parent(a))
end

# TODO Need to manage index transformations between nested layers of arrays
function unsafe_getindex(a::A, i::IntType) where {A}
    if IndexStyle(A) === IndexLinear()
        is_forwarding_wrapper(A) || throw(MethodError(unsafe_getindex, (A, i)))
        return unsafe_getindex(parent(a), i)
    else
        return unsafe_getindex(a, _to_cartesian(a, i)...)
    end
end
function unsafe_getindex(a::A, i::IntType, ii::Vararg{IntType}) where {A}
    if IndexStyle(A) === IndexLinear()
        return unsafe_getindex(a, _to_linear(a, (i, ii...)))
    else
        is_forwarding_wrapper(A) || throw(MethodError(unsafe_getindex, (A, i)))
        return unsafe_getindex(parent(a), i, ii...)
    end
end

unsafe_getindex(a, i::Vararg{Any}) = unsafe_get_collection(a, i)

unsafe_getindex(A::Array) = Base.arrayref(false, A, 1)
unsafe_getindex(A::Array, i::IntType) = Base.arrayref(false, A, Int(i))
@inline function unsafe_getindex(A::Array, i::IntType, ii::Vararg{IntType})
    unsafe_getindex(A, _to_linear(A, (i, ii...)))
end

unsafe_getindex(A::LinearIndices, i::IntType) = Int(i)
unsafe_getindex(A::CartesianIndices{N}, ii::Vararg{IntType,N}) where {N} = CartesianIndex(ii...)
unsafe_getindex(A::CartesianIndices, ii::Vararg{IntType}) =
    unsafe_getindex(A, Base.front(ii)...)
unsafe_getindex(A::CartesianIndices, i::IntType) = @inbounds(A[i])

unsafe_getindex(A::ReshapedArray, i::IntType) = @inbounds(parent(A)[i])
function unsafe_getindex(A::ReshapedArray, i::IntType, ii::Vararg{IntType})
    @inbounds(parent(A)[_to_linear(A, (i, ii...))])
end

unsafe_getindex(A::SubArray, i::IntType) = @inbounds(A[i])
unsafe_getindex(A::SubArray, i::IntType, ii::Vararg{IntType}) = @inbounds(A[i, ii...])

# This is based on Base._unsafe_getindex from https://github.com/JuliaLang/julia/blob/c5ede45829bf8eb09f2145bfd6f089459d77b2b1/base/multidimensional.jl#L755.
#=
    unsafe_get_collection(A, inds)

Returns a collection of `A` given `inds`. `inds` is assumed to have been bounds-checked.
=#
function unsafe_get_collection(A, inds)
    axs = to_axes(A, inds)
    dest = similar(A, axs)
    if map(static_length, static_axes(dest)) == map(static_length, axs)
        Base._unsafe_getindex!(dest, A, inds...)
    else
        Base.throw_checksize_error(dest, axs)
    end
    return dest
end
_ints2range(x::IntType) = x:x
_ints2range(x::AbstractRange) = x
# apply _ints2range to front N elements
_ints2range_front(::Val{N}, ind, inds...) where {N} =
    (_ints2range(ind), _ints2range_front(Val(N - 1), inds...)...)
_ints2range_front(::Val{0}, ind, inds...) = ()
_ints2range_front(::Val{0}) = ()
# get output shape with given indices
_output_shape(::IntType, inds...) = _output_shape(inds...)
_output_shape(ind::AbstractRange, inds...) = (Base.length(ind), _output_shape(inds...)...)
_output_shape(::IntType) = ()
_output_shape(x::AbstractRange) = (Base.length(x),)
@inline function unsafe_get_collection(A::CartesianIndices{N}, inds) where {N}
    if (Base.length(inds) === 1 && N > 1) || stride_preserving_index(typeof(inds)) === False()
        return Base._getindex(IndexStyle(A), A, inds...)
    else
        return reshape(
            CartesianIndices(_ints2range_front(Val(N), inds...)),
            _output_shape(inds...)
        )
    end
end
_known_first_isone(ind) = known_first(ind) !== nothing && isone(known_first(ind))
@inline function unsafe_get_collection(A::LinearIndices{N}, inds) where {N}
    if Base.length(inds) === 1 && ndims_index(typeof(first(inds))) === 1
        return @inbounds(eachindex(A)[first(inds)])
    elseif stride_preserving_index(typeof(inds)) === True() &&
            reduce_tup(&, map(_known_first_isone, inds))
        # create a LinearIndices when first(ind) != 1 is imposable
        return reshape(
            LinearIndices(_ints2range_front(Val(N), inds...)),
            _output_shape(inds...)
        )
    else
        return Base._getindex(IndexStyle(A), A, inds...)
    end
end

"""
    setindex!(A, args...)

Store the given values at the given key or index within a collection.
"""
@propagate_inbounds function setindex!(A, val, args...)
    can_setindex(A) || error("Instance of type $(typeof(A)) are not mutable and cannot change elements after construction.")
    inds = static_to_indices(A, args)
    @boundscheck checkbounds(A, inds...)
    unsafe_setindex!(A, val, inds...)
end
@propagate_inbounds function setindex!(A, val; kwargs...)
    can_setindex(A) || error("Instance of type $(typeof(A)) are not mutable and cannot change elements after construction.")
    inds = static_to_indices(A, find_all_dimnames(dimnames(A), static(keys(kwargs)), Tuple(values(kwargs)), :))
    @boundscheck checkbounds(A, inds...)
    unsafe_setindex!(A, val, inds...)
end

## unsafe_setindex! ##
function unsafe_setindex!(a::A, v) where {A}
    is_forwarding_wrapper(A) || throw(MethodError(unsafe_setindex!, (A, v)))
    return unsafe_setindex!(parent(a), v)
end
# TODO Need to manage index transformations between nested layers of arrays
function unsafe_setindex!(a::A, v, i::IntType) where {A}
    if IndexStyle(A) === IndexLinear()
        is_forwarding_wrapper(A) || throw(MethodError(unsafe_setindex!, (A, v, i)))
        return unsafe_setindex!(parent(a), v, i)
    else
        return unsafe_setindex!(a, v, _to_cartesian(a, i)...)
    end
end
function unsafe_setindex!(a::A, v, i::IntType, ii::Vararg{IntType}) where {A}
    if IndexStyle(A) === IndexLinear()
        return unsafe_setindex!(a, v, _to_linear(a, (i, ii...)))
    else
        is_forwarding_wrapper(A) || throw(MethodError(unsafe_setindex!, (A, v, i, ii...)))
        return unsafe_setindex!(parent(a), v, i, ii...)
    end
end

function unsafe_setindex!(A::Array{T}, v) where {T}
    Base.arrayset(false, A, convert(T, v)::T, 1)
end
function unsafe_setindex!(A::Array{T}, v, i::IntType) where {T}
    return Base.arrayset(false, A, convert(T, v)::T, Int(i))
end

unsafe_setindex!(a, v, i::Vararg{Any}) = unsafe_set_collection!(a, v, i)

# This is based on Base._unsafe_setindex!.
#=
    unsafe_set_collection!(A, val, inds)

Sets `inds` of `A` to `val`. `inds` is assumed to have been bounds-checked.
=#
unsafe_set_collection!(A, v, i) = Base._unsafe_setindex!(IndexStyle(A), A, v, i...)

## Index Information

"""
    known_first(::Type{T}) -> Union{Int,Nothing}

If `first` of an instance of type `T` is known at compile time, return it.
Otherwise, return `nothing`.

```julia
julia> known_first(typeof(1:4))
nothing

julia> known_first(typeof(Base.OneTo(4)))
1
```
"""
known_first(x) = known_first(typeof(x))
known_first(T::Type) = is_forwarding_wrapper(T) ? known_first(parent_type(T)) : nothing
known_first(::Type{<:Base.OneTo}) = 1
known_first(@nospecialize T::Type{<:LinearIndices}) = 1
known_first(@nospecialize T::Type{<:Base.IdentityUnitRange}) = known_first(parent_type(T))
function known_first(::Type{<:CartesianIndices{N, R}}) where {N, R}
    _cartesian_index(ntuple(i -> known_first(R.parameters[i]), Val(N)))
end

_cartesian_index(i::Tuple{Vararg{Int}}) = CartesianIndex(i)
_cartesian_index(::Any) = nothing

"""
    known_last(::Type{T}) -> Union{Int,Nothing}

If `last` of an instance of type `T` is known at compile time, return it.
Otherwise, return `nothing`.

```julia
julia> known_last(typeof(1:4))
nothing

julia> known_first(typeof(static(1):static(4)))
4

```
"""
known_last(x) = known_last(typeof(x))
known_last(T::Type) = is_forwarding_wrapper(T) ? known_last(parent_type(T)) : nothing
function known_last(::Type{<:CartesianIndices{N, R}}) where {N, R}
    _cartesian_index(ntuple(i -> known_last(R.parameters[i]), Val(N)))
end

"""
    known_step(::Type{T}) -> Union{Int,Nothing}

If `step` of an instance of type `T` is known at compile time, return it.
Otherwise, return `nothing`.

```julia
julia> known_step(typeof(1:2:8))
nothing

julia> known_step(typeof(1:4))
1

```
"""
known_step(x) = known_step(typeof(x))
known_step(T::Type) = is_forwarding_wrapper(T) ? known_step(parent_type(T)) : nothing
known_step(@nospecialize T::Type{<:AbstractUnitRange}) = 1

"""
    is_splat_index(::Type{T}) -> Bool

Returns `static(true)` if `T` is a type that splats across multiple dimensions.
"""
is_splat_index(T::Type) = false
is_splat_index(@nospecialize(x)) = is_splat_index(typeof(x))

_add1(@nospecialize x) = x + oneunit(x)
_sub1(@nospecialize x) = x - oneunit(x)

@testset "to_index" begin
    axis = 1:3
    @test @inferred(StaticArrayInterface.to_index(axis, 1)) === 1
    @test @inferred(StaticArrayInterface.to_index(axis, static(1))) === static(1)
    @test @inferred(StaticArrayInterface.to_index(axis, CartesianIndex(1))) === (1,)
    @test @inferred(StaticArrayInterface.to_index(axis, 1:2)) === 1:2
    @test @inferred(StaticArrayInterface.to_index(axis, CartesianIndices((1:2,)))) == (1:2,)
    @test @inferred(StaticArrayInterface.to_index(axis, CartesianIndices((2:3,)))) == (2:3,)
    @test @inferred(StaticArrayInterface.to_index(axis, [1, 2])) == [1, 2]
    @test @inferred(StaticArrayInterface.to_index(axis, [true, false, false])) == [1]
    index = @inferred(StaticArrayInterface.to_index(axis, :))
    @test @inferred(StaticArrayInterface.to_index(axis, index)) == index == StaticArrayInterface.indices(axis)

    x = LinearIndices((static(0):static(3), static(3):static(5), static(-2):static(0)))
    @test_throws ArgumentError StaticArrayInterface.to_index(axis, error)
end

@testset "unsafe_reconstruct" begin
    one_to = Base.OneTo(10)
    opt_ur = StaticInt(1):10
    ur = 1:10
    @test @inferred(StaticArrayInterface.unsafe_reconstruct(one_to, opt_ur)) === one_to
    @test @inferred(StaticArrayInterface.unsafe_reconstruct(one_to, one_to)) === one_to

    @test @inferred(StaticArrayInterface.unsafe_reconstruct(opt_ur, opt_ur)) === opt_ur
    @test @inferred(StaticArrayInterface.unsafe_reconstruct(opt_ur, one_to)) === opt_ur

    @test @inferred(StaticArrayInterface.unsafe_reconstruct(ur, ur)) === ur
    @test @inferred(StaticArrayInterface.unsafe_reconstruct(ur, one_to)) === ur
end

@testset "to_indices" begin
    a = ones(2, 2, 1)
    v = ones(2)

    @testset "linear indexing" begin
        @test @inferred(StaticArrayInterface.static_to_indices(a, (1,))) == (1,)
        @test @inferred(StaticArrayInterface.static_to_indices(a, (1:2,))) == (1:2,)

        @testset "Linear indexing doesn't ruin vector indexing" begin
            @test @inferred(StaticArrayInterface.static_to_indices(v, (1:2,))) == (1:2,)
            @test @inferred(StaticArrayInterface.static_to_indices(v, (1,))) == (1,)
        end
    end

    #@test @inferred(StaticArrayInterface.static_to_indices(a, (CartesianIndices(()),))) == (CartesianIndices(()),)
    inds = @inferred(StaticArrayInterface.static_to_indices(a, (:,)))
    @test @inferred(StaticArrayInterface.static_to_indices(a, inds)) == inds == (StaticArrayInterface.indices(a),)
    @test @inferred(StaticArrayInterface.static_to_indices(ones(2, 2, 2), ([true, true], CartesianIndex(1, 1)))) == ([1, 2], 1, 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, 1))) == (1, 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, CartesianIndex(1)))) == (1, 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, false))) == (1, 0)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, 1:2))) == (1, 1:2)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1:2, 1))) == (1:2, 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, :))) == (1, Base.Slice(1:2))
    @test @inferred(StaticArrayInterface.static_to_indices(a, (:, 1))) == (Base.Slice(1:2), 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, ([true, true], :))) == (Base.LogicalIndex(Bool[1, 1]), Base.Slice(1:2))
    @test @inferred(StaticArrayInterface.static_to_indices(a, (CartesianIndices((1,)), 1))) == (1:1, 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, 1, 1))) == (1, 1, 1)
    @test @inferred(StaticArrayInterface.static_to_indices(a, (1, fill(true, 2, 2)))) == Base.to_indices(a, (1, fill(true, 2, 2)))
    inds = @inferred(StaticArrayInterface.static_to_indices(a, (fill(true, 2, 2, 1),)))
    # Conversion to LogicalIndex doesn't change
    @test @inferred(StaticArrayInterface.static_to_indices(a, inds)) == inds
    @test @inferred(StaticArrayInterface.static_to_indices(a, (fill(true, 2, 1), 1))) == Base.to_indices(a, (fill(true, 2, 1), 1))
    @test @inferred(StaticArrayInterface.static_to_indices(a, (fill(true, 2), 1, 1))) == Base.to_indices(a, (fill(true, 2), 1, 1))
    @test @inferred(StaticArrayInterface.static_to_indices(a, ([CartesianIndex(1, 1, 1), CartesianIndex(1, 2, 1)],))) == (CartesianIndex{3}[CartesianIndex(1, 1, 1), CartesianIndex(1, 2, 1)],)
    @test @inferred(StaticArrayInterface.static_to_indices(a, ([CartesianIndex(1, 1), CartesianIndex(1, 2)], 1:1))) == (CartesianIndex{2}[CartesianIndex(1, 1), CartesianIndex(1, 2)], 1:1)
    @test @inferred(first(StaticArrayInterface.static_to_indices(a, (fill(true, 2, 2, 1),)))) isa Base.LogicalIndex
end

@testset "splat indexing" begin
    struct SplatFirst end

    StaticArrayInterface.to_index(x, ::SplatFirst) = map(first, axes(x))
    StaticArrayInterface.is_splat_index(::Type{SplatFirst}) = true
    x = rand(4, 4, 4, 4, 4, 4, 4, 4, 4, 4);
    i = (1, SplatFirst(), 2, SplatFirst(), CartesianIndex(1, 1))

    @test @inferred(StaticArrayInterface.static_to_indices(x, i)) == (1, 1, 1, 1, 1, 1, 2, 1, 1, 1)
end

@testset "to_axes" begin
    A = ones(3, 3)
    axis = StaticInt(1):StaticInt(3)
    inds = StaticInt(1):StaticInt(2)
    multi_inds = [CartesianIndex(1, 1), CartesianIndex(1, 2)]

    @test @inferred(StaticArrayInterface.to_axes(A, (axis, axis), (inds, inds))) === (inds, inds)
    # vector indexing
    @test @inferred(StaticArrayInterface.to_axes(ones(3), (axis,), (inds,))) === (inds,)
    # linear indexing
    @test @inferred(StaticArrayInterface.to_axes(A, (axis, axis), (inds,))) === (inds,)
    # multidim arg
    @test @inferred(StaticArrayInterface.to_axes(A, (axis, axis), (multi_inds,))) === (static(1):2,)

    @test StaticArrayInterface.to_axis(axis, axis) === axis
    @test StaticArrayInterface.to_axis(axis, StaticArrayInterface.indices(axis)) === axis

    @test @inferred(StaticArrayInterface.to_axes(A, (), (inds,))) === (inds,)
end

@testset  "getindex with additional inds" begin
    A = reshape(1:12, (3, 4))
    subA = view(A, :, :)
    LA = LinearIndices(A)
    CA = CartesianIndices(A)
    @test @inferred(StaticArrayInterface.static_getindex(A, 1, 1, 1)) == 1
    @test @inferred(StaticArrayInterface.static_getindex(A, 1, 1, :)) == [1]
    @test @inferred(StaticArrayInterface.static_getindex(A, 1, 1, 1:1)) == [1]
    @test @inferred(StaticArrayInterface.static_getindex(A, 1, 1, :, :)) == ones(1, 1)
    @test @inferred(StaticArrayInterface.static_getindex(A, :, 1, 1)) == 1:3
    @test @inferred(StaticArrayInterface.static_getindex(A, 2:3, 1, 1)) == 2:3
    @test @inferred(StaticArrayInterface.static_getindex(A, static(1):2, 1, 1)) == 1:2
    @test @inferred(StaticArrayInterface.static_getindex(A, :, 1, :)) == reshape(1:3, 3, 1)
    @test @inferred(StaticArrayInterface.static_getindex(subA, 1, 1, 1)) == 1
    @test @inferred(StaticArrayInterface.static_getindex(subA, 1, 1, :)) == [1]
    @test @inferred(StaticArrayInterface.static_getindex(subA, 1, 1, 1:1)) == [1]
    @test @inferred(StaticArrayInterface.static_getindex(subA, 1, 1, :, :)) == ones(1, 1)
    @test @inferred(StaticArrayInterface.static_getindex(subA, :, 1, 1)) == 1:3
    @test @inferred(StaticArrayInterface.static_getindex(subA, 2:3, 1, 1)) == 2:3
    @test @inferred(StaticArrayInterface.static_getindex(subA, static(1):2, 1, 1)) == 1:2
    @test @inferred(StaticArrayInterface.static_getindex(subA, :, 1, :)) == reshape(1:3, 3, 1)
    @test @inferred(StaticArrayInterface.static_getindex(LA, 1, 1, 1)) == 1
    @test @inferred(StaticArrayInterface.static_getindex(LA, 1, 1, :)) == [1]
    @test @inferred(StaticArrayInterface.static_getindex(LA, 1, 1, 1:1)) == [1]
    @test @inferred(StaticArrayInterface.static_getindex(LA, 1, 1, :, :)) == ones(1, 1)
    @test @inferred(StaticArrayInterface.static_getindex(LA, :, 1, 1)) == 1:3
    @test @inferred(StaticArrayInterface.static_getindex(LA, 2:3, 1, 1)) == 2:3
    @test @inferred(StaticArrayInterface.static_getindex(LA, static(1):2, 1, 1)) == 1:2
    @test @inferred(StaticArrayInterface.static_getindex(LA, :, 1, :)) == reshape(1:3, 3, 1)
    @test @inferred(StaticArrayInterface.static_getindex(CA, 1, 1, 1)) == CartesianIndex(1, 1)
    @test @inferred(StaticArrayInterface.static_getindex(CA, 1, 1, :)) == [CartesianIndex(1, 1)]
    @test @inferred(StaticArrayInterface.static_getindex(CA, 1, 1, 1:1)) == [CartesianIndex(1, 1)]
    @test @inferred(StaticArrayInterface.static_getindex(CA, 1, 1, :, :)) == fill(CartesianIndex(1, 1), 1, 1)
    @test @inferred(StaticArrayInterface.static_getindex(CA, :, 1, 1)) ==
        reshape(CartesianIndex(1, 1):CartesianIndex(3, 1), 3)
    @test @inferred(StaticArrayInterface.static_getindex(CA, 2:3, 1, 1)) ==
        reshape(CartesianIndex(2, 1):CartesianIndex(3, 1), 2)
    @test @inferred(StaticArrayInterface.static_getindex(CA, static(1):2, 1, 1)) ==
        reshape(CartesianIndex(1, 1):CartesianIndex(2, 1), 2)
    @test @inferred(StaticArrayInterface.static_getindex(CA, :, 1, :)) ==
        reshape(CartesianIndex(1, 1):CartesianIndex(3, 1), 3, 1)
end

@testset "0-dimensional" begin
    x = Array{Int,0}(undef)
    StaticArrayInterface.setindex!(x, 1)
    @test @inferred(StaticArrayInterface.static_getindex(x)) == 1
end

@testset "1-dimensional" begin
    for i = 1:3
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((3,)), i)) == i
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices((3,)), i)) == CartesianIndex(i,)
    end
    @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((3,)), 2, 1)) == 2
    @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((3,)), [1])) == [1]
    # !!NOTE!! this is different than Base.getindex(::LinearIndices, ::AbstractUnitRange)
    # which returns a UnitRange. Instead we try to preserve axes if at all possible so the
    # values are the same but it's still wrapped in LinearIndices struct
    @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((3,)), 1:2)) == 1:2
    @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((3,)), 1:2:3)) === 1:2:3
    @test_throws BoundsError StaticArrayInterface.static_getindex(LinearIndices((3,)), 2:4)
    @test_throws BoundsError StaticArrayInterface.static_getindex(CartesianIndices((3,)), 2, 2)
    #   ambiguity btw cartesian indexing and linear indexing in 1d when
    #   indices may be nontraditional
    # TODO should this be implemented in ArrayInterface with vectorization?
    #@test_throws ArgumentError Base._sub2ind((1:3,), 2)
    #@test_throws ArgumentError Base._ind2sub((1:3,), 2)
    x = Array{Int,2}(undef, (2, 2))
    StaticArrayInterface.unsafe_setindex!(x, 1, 2, 2)
    @test StaticArrayInterface.unsafe_getindex(x, 2, 2) === 1

    # FIXME @test_throws MethodError StaticArrayInterface.unsafe_set_element!(x, 1, (:x, :x))
    # FIXME @test_throws MethodError StaticArrayInterface.unsafe_get_element(x, (:x, :x))
end

@testset "2-dimensional" begin
    k = 0
    cartesian = CartesianIndices((4, 3))
    linear = LinearIndices(cartesian)
    for j = 1:3, i = 1:4
        k += 1
        @test @inferred(StaticArrayInterface.static_getindex(linear, i, j)) == StaticArrayInterface.static_getindex(linear, k) == k
        @test @inferred(StaticArrayInterface.static_getindex(cartesian, k)) == CartesianIndex(i, j)
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices(map(Base.Slice, (0:3, 3:5))), i - 1, j + 2)) == k
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices(map(Base.Slice, (0:3, 3:5))), k)) == CartesianIndex(i - 1, j + 2)
    end

    x = LinearIndices(map(Base.Slice, (static(0):static(3), static(3):static(5), static(-2):static(0))))
    
    if VERSION >= v"1.7"
        @test @inferred(StaticArrayInterface.static_getindex(x, 0, 3, -2)) === 1
    else
        @test StaticArrayInterface.static_getindex(x, 0, 3, -2) === 1
    end
    
    @test @inferred(StaticArrayInterface.static_getindex(x, static(0), static(3), static(-2))) === 1

    @test @inferred(StaticArrayInterface.static_getindex(linear, linear)) == linear
    @test @inferred(StaticArrayInterface.static_getindex(linear, vec(linear))) == vec(linear)
    @test @inferred(StaticArrayInterface.static_getindex(linear, cartesian)) == linear
    @test @inferred(StaticArrayInterface.static_getindex(linear, vec(cartesian))) == vec(linear)
    @test @inferred(StaticArrayInterface.static_getindex(cartesian, linear)) == cartesian
    @test @inferred(StaticArrayInterface.static_getindex(cartesian, vec(linear))) == vec(cartesian)
    @test @inferred(StaticArrayInterface.static_getindex(cartesian, cartesian)) == cartesian
    @test @inferred(StaticArrayInterface.static_getindex(cartesian, vec(cartesian))) == vec(cartesian)
    @test @inferred(StaticArrayInterface.static_getindex(linear, 2:3)) === 2:3
    @test @inferred(StaticArrayInterface.static_getindex(linear, 3:-1:1)) === 3:-1:1
    @test @inferred(StaticArrayInterface.static_getindex(linear, >(1), <(3))) == linear[(begin+1):end, 1:(end-1)]
    @test @inferred(StaticArrayInterface.static_getindex(linear, >=(1), <=(3))) == linear[begin:end, 1:end]
    @test_throws BoundsError StaticArrayInterface.static_getindex(linear, 4:13)
end

@testset "3-dimensional" begin
    l = 0
    for k = 1:2, j = 1:3, i = 1:4
        l += 1
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((4, 3, 2)), i, j, k)) == l
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((4, 3, 2)), l)) == l
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices((4, 3, 2)), i, j, k)) == CartesianIndex(i, j, k)
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices((4, 3, 2)), l)) == CartesianIndex(i, j, k)
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((1:4, 1:3, 1:2)), i, j, k)) == l
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices((1:4, 1:3, 1:2)), l)) == l
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices((1:4, 1:3, 1:2)), i, j, k)) == CartesianIndex(i, j, k)
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices((1:4, 1:3, 1:2)), l)) == CartesianIndex(i, j, k)
    end

    l = 0
    for k = -101:-100, j = 3:5, i = 0:3
        l += 1
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices(map(Base.Slice, (0:3, 3:5, -101:-100))), i, j, k)) == l
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices(map(Base.Slice, (0:3, 3:5, -101:-100))), l)) == l
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices(map(Base.Slice, (0:3, 3:5, -101:-100))), i, j, k)) == CartesianIndex(i, j, k)
        @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices(map(Base.Slice, (0:3, 3:5, -101:-100))), l)) == CartesianIndex(i, j, k)
    end

    local A = reshape(Vector(1:9), (3, 3))
    @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices(size(A)), 6)) == CartesianIndex(3, 2)
    @test @inferred(StaticArrayInterface.static_getindex(LinearIndices(size(A)), 3, 2)) == 6
    @test @inferred(StaticArrayInterface.static_getindex(CartesianIndices(A), 6)) == CartesianIndex(3, 2)
    @test @inferred(StaticArrayInterface.static_getindex(LinearIndices(A), 3, 2)) == 6
    for i in 1:length(A)
        @test @inferred(StaticArrayInterface.static_getindex(LinearIndices(A), StaticArrayInterface.static_getindex(CartesianIndices(A), i))) == i
    end
end

A = zeros(3, 4, 5);
A[:] = 1:60
Ap = @view(PermutedDimsArray(A, (3, 1, 2))[:, 1:2, 1])';
S = MArray(zeros(2, 3, 4))
A_trailingdim = zeros(2, 3, 4, 1)
Sp = @view(PermutedDimsArray(S, (3, 1, 2))[2:3, 1:2, :]);

Sp2 = @view(PermutedDimsArray(S, (3, 2, 1))[2:3, :, :]);

Mp = @view(PermutedDimsArray(S, (3, 1, 2))[:, 2, :])';
Mp2 = @view(PermutedDimsArray(S, (3, 1, 2))[2:3, :, 2])';

D = @view(A[:, 2:2:4, :]);
R = StaticInt(1):StaticInt(2);
Rnr = reinterpret(Int32, R);
Ar = reinterpret(Float32, A);
A2 = zeros(4, 3, 5)
A2r = reinterpret(ComplexF64, A2)

irev = Iterators.reverse(S)
igen = Iterators.map(identity, S)
iacc = Iterators.accumulate(+, S)
iprod = Iterators.product(axes(S)...)
iflat = Iterators.flatten(iprod)
ienum = enumerate(S)
ipairs = pairs(S)
izip = zip(S, S)

sv5 = MArray(zeros(5));
v5 = Vector{Float64}(undef, 5);

module StaticArrayInterfaceOffsetArraysExt

using StaticArrayInterface
using StaticArrayInterface.Static

if isdefined(Base, :get_extension) 
    using OffsetArrays
else 
    using ..OffsetArrays
end

relative_offsets(r::OffsetArrays.IdOffsetRange) = (getfield(r, :offset),)
relative_offsets(A::OffsetArrays.OffsetArray) = getfield(A, :offsets)
function relative_offsets(A::OffsetArrays.OffsetArray, ::StaticInt{dim}) where {dim}
    if dim > ndims(A)
        return static(0)
    else
        return getfield(relative_offsets(A), dim)
    end
end
function relative_offsets(A::OffsetArrays.OffsetArray, dim::Int)
    if dim > ndims(A)
        return 0
    else
        return getfield(relative_offsets(A), dim)
    end
end
StaticArrayInterface.parent_type(::Type{<:OffsetArrays.OffsetArray{T,N,A}}) where {T,N,A} = A
function _offset_axis_type(::Type{T}, dim::StaticInt{D}) where {T,D}
    OffsetArrays.IdOffsetRange{Int,StaticArrayInterface.axes_types(T, dim)}
end
function StaticArrayInterface.axes_types(::Type{T}) where {T<:OffsetArrays.OffsetArray}
    Static.eachop_tuple(
        _offset_axis_type,
        ntuple(static, StaticInt(ndims(T))),
        StaticArrayInterface.parent_type(T)
    )
end
StaticArrayInterface.static_strides(A::OffsetArray) = StaticArrayInterface.static_strides(parent(A))
function StaticArrayInterface.known_offsets(::Type{A}) where {A<:OffsetArrays.OffsetArray}
    ntuple(identity -> nothing, Val(ndims(A)))
end
function StaticArrayInterface.offsets(A::OffsetArrays.OffsetArray)
    map(+, StaticArrayInterface.offsets(parent(A)), relative_offsets(A))
end
@inline function StaticArrayInterface.offsets(A::OffsetArrays.OffsetArray, dim)
    d = StaticArrayInterface.to_dims(A, dim)
    StaticArrayInterface.offsets(parent(A), d) + relative_offsets(A, d)
end
@inline function StaticArrayInterface.static_axes(A::OffsetArrays.OffsetArray)
    map(OffsetArrays.IdOffsetRange, StaticArrayInterface.static_axes(parent(A)), relative_offsets(A))
end
@inline function StaticArrayInterface.static_axes(A::OffsetArrays.OffsetArray, dim)
    d = StaticArrayInterface.to_dims(A, dim)
    OffsetArrays.IdOffsetRange(StaticArrayInterface.static_axes(parent(A), d), relative_offsets(A, d))
end
function StaticArrayInterface.stride_rank(T::Type{<:OffsetArray})
  StaticArrayInterface.stride_rank(StaticArrayInterface.parent_type(T))
end
function StaticArrayInterface.dense_dims(T::Type{<:OffsetArray})
    StaticArrayInterface.dense_dims(StaticArrayInterface.parent_type(T))
end
function StaticArrayInterface.contiguous_axis(T::Type{<:OffsetArray})
  StaticArrayInterface.contiguous_axis(StaticArrayInterface.parent_type(T))
end

end # module

"""
    static_size(A) -> Tuple
    static_size(A, dim) -> Union{Int,StaticInt}

Returns the size of each dimension of `A` or along dimension `dim` of `A`. If the size of
any axes are known at compile time, these should be returned as `Static` numbers. Otherwise,
`static_size(A)` is identical to `Base.size(A)`

```julia
julia> using StaticArrays, ArrayInterface

julia> A = @SMatrix rand(3,4);

julia> static_size(A)
(static(3), static(4))
```
"""
@inline function static_size(a::A) where {A}
    if is_forwarding_wrapper(A)
        return static_size(parent(a))
    else
        return _maybe_size(Base.IteratorSize(A), a)
    end
end
static_size(a::Base.Broadcast.Broadcasted) = map(static_length, static_axes(a))

_maybe_size(::Base.HasShape{N}, a::A) where {N,A} = map(static_length, static_axes(a))
_maybe_size(::Base.HasLength, a::A) where {A} = (static_length(a),)

@inline static_size(x::SubArray) = flatten_tuples(map(Base.Fix1(_sub_size, x), sub_axes_map(typeof(x))))
@inline _sub_size(::SubArray, ::SOneTo{S}) where {S} = StaticInt(S)
_sub_size(x::SubArray, ::StaticInt{index}) where {index} = static_size(getfield(x.indices, index))

@inline static_size(B::VecAdjTrans) = (One(), static_length(parent(B)))
@inline function static_size(x::Union{PermutedDimsArray,MatAdjTrans})
    map(GetIndex{false}(static_size(parent(x))), to_parent_dims(x))
end
function static_size(a::ReinterpretArray{T,N,S,A,IsReshaped}) where {T,N,S,A,IsReshaped}
    psize = static_size(parent(a))
    if IsReshaped
        if sizeof(S) === sizeof(T)
            return psize
        elseif sizeof(S) > sizeof(T)
            return flatten_tuples((static(div(sizeof(S), sizeof(T))), psize))
        else
            return tail(psize)
        end
    else
        return flatten_tuples((div(first(psize) * static(sizeof(S)), static(sizeof(T))), tail(psize)))
    end
end
static_size(A::ReshapedArray) = Base.size(A)
static_size(A::AbstractRange) = (static_length(A),)
static_size(x::Base.Generator) = static_size(getfield(x, :iter))
static_size(x::Iterators.Reverse) = static_size(getfield(x, :itr))
static_size(x::Iterators.Enumerate) = static_size(getfield(x, :itr))
static_size(x::Iterators.Accumulate) = static_size(getfield(x, :itr))
static_size(x::Iterators.Pairs) = static_size(getfield(x, :itr))
# TODO couldn't this just be map(length, getfield(x, :iterators))
@inline function static_size(x::Iterators.ProductIterator)
    eachop(_sub_size, ntuple(static, StaticInt(ndims(x))), getfield(x, :iterators))
end
_sub_size(x::Tuple, ::StaticInt{dim}) where {dim} = static_length(getfield(x, dim))

static_size(a, dim) = static_size(a, to_dims(a, dim))
static_size(a::Array, dim::IntType) = Base.arraysize(a, convert(Int, dim))
function static_size(a::A, dim::IntType) where {A}
    if is_forwarding_wrapper(A)
        return static_size(parent(a), dim)
    else
        len = known_size(A, dim)
        if len === nothing
            return Int(static_length(static_axes(a, dim)))
        else
            return StaticInt(len)
        end
    end
end
static_size(x::Iterators.Zip) = Static.reduce_tup(promote_shape, map(static_size, getfield(x, :is)))

"""
    known_size(::Type{T}) -> Tuple
    known_size(::Type{T}, dim) -> Union{Int,Nothing}

Returns the size of each dimension of `A` or along dimension `dim` of `A` that is known at
compile time. If a dimension does not have a known size along a dimension then `nothing` is
returned in its position.
"""
known_size(x) = known_size(typeof(x))
@inline known_size(@nospecialize T::Type{<:Number}) = ()
@inline known_size(@nospecialize T::Type{<:VecAdjTrans}) = (1, known_length(parent_type(T)))
@inline function known_size(@nospecialize T::Type{<:Union{PermutedDimsArray,MatAdjTrans}})
    map(GetIndex{false}(known_size(parent_type(T))), to_parent_dims(T))
end
function known_size(@nospecialize T::Type{<:Diagonal})
    s = known_length(parent_type(T))
    (s, s)
end
known_size(@nospecialize T::Type{<:Union{Symmetric,Hermitian}}) = known_size(parent_type(T))
@inline function known_size(::Type{<:Base.ReinterpretArray{T,N,S,A,IsReshaped}}) where {T,N,S,A,IsReshaped}
    psize = known_size(A)
    if IsReshaped
        if sizeof(S) > sizeof(T)
            return (div(sizeof(S), sizeof(T)), psize...)
        elseif sizeof(S) < sizeof(T)
            return Base.tail(psize)
        else
            return psize
        end
    else
        if Base.issingletontype(T) || first(psize) === nothing
            return psize
        else
            return (div(first(psize) * sizeof(S), sizeof(T)), Base.tail(psize)...)
        end
    end
end

@inline function known_size(::Type{T}) where {T}
    if is_forwarding_wrapper(T)
        return known_size(parent_type(T))
    else
        return _maybe_known_size(Base.IteratorSize(T), T)
    end
end
function _maybe_known_size(::Base.HasShape{N}, ::Type{T}) where {N,T}
    eachop(_known_size, ntuple(static, StaticInt(N)), axes_types(T))
end
_maybe_known_size(::Base.IteratorSize, ::Type{T}) where {T} = (known_length(T),)
known_size(::Type{<:Base.IdentityUnitRange{I}}) where {I} = known_size(I)
known_size(::Type{<:Base.Generator{I}}) where {I} = known_size(I)
known_size(::Type{<:Iterators.Reverse{I}}) where {I} = known_size(I)
known_size(::Type{<:Iterators.Enumerate{I}}) where {I} = known_size(I)
known_size(::Type{<:Iterators.Accumulate{<:Any,I}}) where {I} = known_size(I)
known_size(::Type{<:Iterators.Pairs{<:Any,<:Any,I}}) where {I} = known_size(I)
@inline function known_size(::Type{<:Iterators.ProductIterator{T}}) where {T}
    ntuple(i -> known_length(T.parameters[i]), Val(known_length(T)))
end
@inline function known_size(@nospecialize T::Type{<:AbstractRange})
    if is_forwarding_wrapper(T)
        return known_size(parent_type(T))
    else
        start = known_first(T)
        s = known_step(T)
        stop = known_last(T)
        if stop !== nothing && s !== nothing && start !== nothing
            if s > 0
                return (stop < start ? 0 : div(stop - start, s) + 1,)
            else
                return (stop > start ? 0 : div(start - stop, -s) + 1,)
            end
        else
            return (nothing,)
        end
    end
end

@inline function known_size(@nospecialize T::Type{<:Union{LinearIndices,CartesianIndices}})
    I = fieldtype(T, :indices)
    ntuple(i -> known_length(I.parameters[i]), Val(ndims(T)))
end

@inline function known_size(@nospecialize T::Type{<:SubArray})
    flatten_tuples(map(Base.Fix1(_known_sub_size, T), sub_axes_map(T)))
end
_known_sub_size(@nospecialize(T::Type{<:SubArray}), ::SOneTo{S}) where {S} = S
function _known_sub_size(@nospecialize(T::Type{<:SubArray}), ::StaticInt{index}) where {index}
    known_size(fieldtype(fieldtype(T, :indices), index))
end

# 1. `Zip` doesn't check that its collections are compatible (same size) at construction,
#   but we assume as much b/c otherwise it will error while iterating. So we promote to the
#   known size if matching a `Nothing` and `Int` size.
# 2. `promote_shape(::Tuple{Vararg{IntType}}, ::Tuple{Vararg{IntType}})` promotes
#   trailing dimensions (which must be of size 1), to `static(1)`. We want to stick to
#   `Nothing` and `Int` types, so we do one last pass to ensure everything is dynamic
@inline function known_size(::Type{<:Iterators.Zip{T}}) where {T}
    dynamic(reduce_tup(Static._promote_shape, eachop(_unzip_size, ntuple(static, StaticInt(known_length(T))), T)))
end
_unzip_size(::Type{T}, n::StaticInt{N}) where {T,N} = known_size(field_type(T, n))
_known_size(::Type{T}, dim::StaticInt) where {T} = known_length(field_type(T, dim))
@inline known_size(x, dim) = known_size(typeof(x), dim)
@inline known_size(::Type{T}, dim) where {T} = known_size(T, to_dims(T, dim))
known_size(T::Type, dim::IntType) = ndims(T) < dim ? 1 : known_size(T)[dim]

"""
    static_length(A) -> Union{Int,StaticInt}

Returns the length of `A`.  If the length is known at compile time, it is
returned as `Static` number.  Otherwise, `static_length(A)` is identical
to `Base.length(A)`.

```julia
julia> using StaticArrays, ArrayInterface

julia> A = @SMatrix rand(3,4);

julia> static_length(A)
static(12)
```
"""
@inline static_length(a::UnitRange{T}) where {T} = last(a) - first(a) + oneunit(T)
@inline static_length(x) = Static.maybe_static(known_length, Base.length, x)

"""
    known_length(::Type{T}) -> Union{Int,Nothing}

If `length` of an instance of type `T` is known at compile time, return it.
Otherwise, return `nothing`.
"""
known_length(x) = known_length(typeof(x))
known_length(::Type{<:NamedTuple{L}}) where {L} = static_length(L)
known_length(::Type{T}) where {T<:Slice} = known_length(parent_type(T))
known_length(::Type{<:Tuple{Vararg{Any,N}}}) where {N} = N
known_length(::Type{<:Number}) = 1
known_length(::Type{<:AbstractCartesianIndex{N}}) where {N} = N
known_length(::Type{T}) where {T} = _maybe_known_length(Base.IteratorSize(T), T)
function known_length(::Type{<:Iterators.Flatten{I}}) where {I}
  _prod_or_nothing((known_length(I),known_length(eltype(I))))
end

_prod_or_nothing(x::Tuple{Vararg{Int}}) = prod(x)
_prod_or_nothing(_) = nothing

_maybe_known_length(::Base.HasShape, ::Type{T}) where {T} = _prod_or_nothing(known_size(T))
_maybe_known_length(::Base.IteratorSize, ::Type) = nothing

@testset "insert/deleteat" begin
    @test @inferred(StaticArrayInterface.insert([1,2,3], 2, -2)) == [1, -2, 2, 3]
    @test @inferred(StaticArrayInterface.deleteat([1, 2, 3], 2)) == [1, 3]

    @test @inferred(StaticArrayInterface.deleteat([1, 2, 3], [1, 2])) == [3]
    @test @inferred(StaticArrayInterface.deleteat([1, 2, 3], [1, 3])) == [2]
    @test @inferred(StaticArrayInterface.deleteat([1, 2, 3], [2, 3])) == [1]

    @test @inferred(StaticArrayInterface.insert((2,3,4), 1, -2)) == (-2, 2, 3, 4)
    @test @inferred(StaticArrayInterface.insert((2,3,4), 2, -2)) == (2, -2, 3, 4)
    @test @inferred(StaticArrayInterface.insert((2,3,4), 3, -2)) == (2, 3, -2, 4)

    @test @inferred(StaticArrayInterface.deleteat((2, 3, 4), 1)) == (3, 4)
    @test @inferred(StaticArrayInterface.deleteat((2, 3, 4), 2)) == (2, 4)
    @test @inferred(StaticArrayInterface.deleteat((2, 3, 4), 3)) == (2, 3)
    @test StaticArrayInterface.deleteat((1, 2, 3), [1, 2]) == (3,)
end

# API

### Traits

```@docs
StaticArrayInterface.contiguous_axis
StaticArrayInterface.contiguous_axis_indicator
StaticArrayInterface.contiguous_batch_size
StaticArrayInterface.dimnames
StaticArrayInterface.has_dimnames
StaticArrayInterface.has_parent
StaticArrayInterface.is_column_major
StaticArrayInterface.is_lazy_conjugate
StaticArrayInterface.is_splat_index
StaticArrayInterface.known_dimnames
StaticArrayInterface.known_first
StaticArrayInterface.known_last
StaticArrayInterface.known_length
StaticArrayInterface.known_offset1
StaticArrayInterface.known_offsets
StaticArrayInterface.known_size
StaticArrayInterface.known_step
StaticArrayInterface.known_strides
```

### Functions

```@docs
StaticArrayInterface.static_axes
StaticArrayInterface.axes_types
StaticArrayInterface.broadcast_axis
StaticArrayInterface.deleteat
StaticArrayInterface.dense_dims
StaticArrayInterface.from_parent_dims
StaticArrayInterface.getindex
StaticArrayInterface.indices
StaticArrayInterface.insert
StaticArrayInterface.static_length
StaticArrayInterface.lazy_axes
StaticArrayInterface.offset1
StaticArrayInterface.offsets
StaticArrayInterface.setindex!
StaticArrayInterface.static_size
StaticArrayInterface.static_strides
StaticArrayInterface.to_axes
StaticArrayInterface.to_axis
StaticArrayInterface.to_dims
StaticArrayInterface.to_index
StaticArrayInterface.static_to_indices
StaticArrayInterface.to_parent_dims
StaticArrayInterface.unsafe_reconstruct
```

### Types

```@docs
StaticArrayInterface.BroadcastAxis
StaticArrayInterface.LazyAxis
StaticArrayInterface.OptionallyStaticStepRange
StaticArrayInterface.OptionallyStaticUnitRange
StaticArrayInterface.SOneTo
StaticArrayInterface.SUnitRange
StaticArrayInterface.StrideIndex
```

```@meta
CurrentModule = StaticArrayInterface
```

# StaticArrayInterface

Designs for new Base array interface primitives, used widely through scientific machine learning (SciML) and other organizations

## StaticArrayInterfaceCore

StaticArrayInterfaceCore is a smaller set of the StaticArrayInterface setup which defines the subset which has no compile time impact.
This for example includes simple functions like `StaticArrayInterfaceCore.zeromatrix` which have simple few dispatch definitions
and no dependency on other libraries such as Static.jl. Notably, Static.jl currently has issues with invalidations
(https://github.com/SciML/Static.jl/issues/52), and thus anything with static outputs are in the domain of StaticArrayInterface.jl
proprer.

## Extenion Packages

StaticArrayInterface.jl uses extension packages in order to add support for popular libraries to its interface functions. These packages are:

- StaticArrays.jl
- OffsetArrays.jl

## Inheriting Array Traits

Creating an array type with unique behavior in Julia is often accomplished by creating a lazy wrapper around previously defined array types 
(e.g. [composition by inheritance](https://en.wikipedia.org/wiki/Composition_over_inheritance)).
This allows the new array type to inherit functionality by redirecting methods to the parent array (e.g., `Base.size(x::Wrapper) = size(parent(x))`).
Generic design limits the need to define an excessive number of methods like this.
However, methods used to describe a type's traits often need to be explicitly defined for each trait method.
If the the underlying data and access to it are unchanged by it's wrapper the 
[`StaticArrayInterface.is_forwarding_wrapper`](@ref) trait can signal to other trait methods to access its parent data structure.
Supporting this for a new type only requires defines these methods:

```julia
StaticArrayInterface.is_forwarding_wrapper(::Type{<:NewType}) = true
StaticArrayInterface.parent_type(::Type{<:NewType}) = NewTypeParent
Base.parent(x::NewType) = x.parent
```

For those authoring new trait methods, this may change the default definition from `has_trait(::Type{T}) where {T} = false`, to:
```julia
function has_trait(::Type{T}) where {T}
    if is_forwarding_wrapper(T)
        return false
    else
        return has_trait(parent_type(T))
    end
end
```

Most traits in `StaticArrayInterface` are a variant on this pattern.
If the trait in question may be altered by a wrapper array, this pattern should be altered or may be inappropriate.

## Static Traits

The size along one or more dimensions of an array may be known at compile time.
`StaticArrayInterface.known_size` is useful for extracting this information from array types and `StaticArrayInterface.static_size` is useful for extracting this information from an instance of an array.
For example:

```julia
julia> a = ones(3)';

julia> StaticArrayInterface.static_size(a)
(static(1), 3)

julia> StaticArrayInterface.known_size(typeof(a))
(1, nothing)

```

This is useful for dispatching on known information about the size of an array:
```julia
fxn(x) = _fxn(StaticArrayInterface.static_size(x), x)
_fxn(sz::Tuple{StaticInt{S1},StaticInt{S2}}, x) where {S1,S2} = ...
_fxn(sz::Tuple{StaticInt{3},StaticInt{3}}, x) = ...
_fxn(sz::Tuple{Int,StaticInt{S2}}, x) where {S2} = ...
_fxn(sz::Tuple{StaticInt{S1},Int}, x) where {S1} = ...
_fxn(sz::Tuple{Int,Int}, x) = ...
```

Methods should avoid forcing conversion to static sizes when dynamic sizes could potentially be returned.
Fore example, `fxn(x) = _fxn(Static.static(StaticArrayInterface.static_size(x)), x)` would result in dynamic dispatch if `x` is an instance of `Matrix`.
Additionally, `StaticArrayInterface.static_size` should only be used outside of generated functions to avoid possible world age issues.

Generally, `StaticArrayInterface.static_size` uses the return of `known_size` to form a static value for those dimensions with known length and only queries dimensions corresponding to `nothing`.
For example, the previous example had a known size of `(1, nothing)`.
Therefore, `StaticArrayInterface.static_size` would have compile time information about the first dimension returned as `static(1)` and would only look up the size of the second dimension at run time.
This means the above example `StaticArrayInterface.static_size(a)` would lower to code similar to this at compile time: `Static.StaticInt(1), Base.arraysize(x, 1)`.
Generic support for `StaticArrayInterface.known_size` relies on calling `known_length` for each type returned from `axes_types`.
Therefore, the recommended approach for supporting static sizing in newly defined array types is defining a new `axes_types` method.

Static information related to subtypes of `AbstractRange` include `known_length`, `known_first`, `known_step`, and `known_last`.

## Dimensions

Methods such as `size(x, dim)` need to map `dim` to the dimensions of `x`.
Typically, `dim` is an `Int` with an invariant mapping to the dimensions of `x`.
Some methods accept `:` or a tuple of dimensions as an argument.
`StaticArrayInterface` also considers `StaticInt` a viable dimension argument.

[`StaticArrayInterface.to_dims`](@ref) helps ensure that `dim` is converted to a viable dimension mapping in a manner that helps with type stability.
For example, all `Integers` passed to `to_dims` are converted to `Int` (unless `dim` is a `StaticInt`).
This is also useful for arrays that uniquely label dimensions, in which case `to_dims` serves as a safe point of hooking into existing methods with dimension arguments.
`StaticArrayInterface` also defines native `Symbol` to `Int` and `StaticSymbol` to `StaticInt` mapping  for arrays defining [`StaticArrayInterface.dimnames`](@ref).

Methods requiring dimension specific arguments should use some variation of the following pattern.

```julia
f(x, dim) = f(x, StaticArrayInterface.to_dims(x, dim))
f(x, dim::Int) = ...
f(x, dim::StaticInt) = ...
```

If `x`'s first dimension is named `:dim_1` then calling `f(x, :dim_1)` would result in `f(x, 1)`.
If users knew they always wanted to call `f(x, 2)` then they could define `h(x) = f(x, static(2))`, ensuring `f` passes along that information while compiling.

New types defining dimension names can do something similar to:

```julia
using Static
using StaticArrayInterface

struct StaticDimnames{dnames} end  # where dnames::Tuple{Vararg{Symbol}}

StaticArrayInterface.known_dimnames(::Type{StaticDimnames{dnames}}) where {dnames} = dnames
StaticArrayInterface.dimnames(::StaticDimnames{dnames}) where {dnames} = static(dnames)

struct DynamicDimnames{N}
    dimnames::NTuple{N,Symbol}
end
StaticArrayInterface.known_dimnames(::Type{DynamicDimnames{N}}) where {N} = ntuple(_-> nothing, Val(N))
StaticArrayInterface.dimnames(x::DynamicDimnames) = getfield(x, :dimnames)

```

Notice that `DynamicDimnames` returns `nothing` instead of a symbol for each dimension.
This indicates dimension names are present for `DynamicDimnames` but that information is nothing at compile time.

Dimension names should be appropriately propagated between nested arrays using `StaticArrayInterface.to_parent_dims`. 
This allows types such as `SubArray` and `PermutedDimsArray` to work with named dimensions.
Similarly, other methods that return information corresponding to dimensions (e.g., `ArrayInterfce.size`, `StaticArrayInterface.static_axes`) use `to_parent_dims` to appropriately propagate parent information.

## Axes

Where Julia's currently documented [array interface]( https://docs.julialang.org/en/v1/manual/interfaces/#man-interface-array) requires defining `Base.size`, 
StaticArrayInterface instead requires defining [`StaticArrayInterface.static_axes`](@ref) and [`StaticArrayInterface.axes_types`](@ref).
`StaticArrayInterface.axes_types(::Type{T})` facilitates propagation of a number of traits known at compile time (e.g., `known_size`, `known_offsets`) 
and `StaticArrayInterface.static_axes(::AbstractArray)` replaces `Base.OneTo` with `StaticArrayInterface.OptionallyStaticUnitRange` in situations where static 
information would otherwise be lost.
`StaticArrayInterface.static_axes(::AbstractArray, dim)` utilizes `to_dims`, [as described elsewhere](#dimensions).

### Simple Wrappers

Let's say we have a new array type doesn't affect axes then this is as simple as:
```julia
Base.axes(x::SimpleWrapper) = StaticArrayInterface.static_axes(parent(x))
Base.axes(x::SimpleWrapper, dim) = StaticArrayInterface.static_axes(parent(x), dim)
StaticArrayInterface.axes_types(::Type{T}) where {T<:SimpleWrapper} = axes_types(parent_type(T))
```

To reiterate, `StaticArrayInterface.static_axes` improves on `Base.axes` for few Base array types but is otherwise identical.
Therefore, the first method simply ensures you don't have to define multiple parametric methods for your new type to preserve 
statically sized nested axes (e.g., `SimpleWrapper{T,N,<:Transpose{T,<:AbstractVector}}`).
This is otherwise identical to standard inheritance by composition.

### When to Discard Axis Information

Occasionally the parent array's axis information can't be preserved.
For example, we can't map axis information from the parent array of `Base.ReshapedArray`.
In this case we can simply build axes from the new size information.

```julia
StaticArrayInterface.axes_types(T::Type{<:ReshapedArray}) = NTuple{ndims(T),OneTo{Int}}
StaticArrayInterface.static_axes(A::ReshapedArray) = map(OneTo, size(A))
```

### New Axis Types

`OffsetArray` changes the first index for each axis.
It produces axes of type `IdOffsetRange`, which contains the value of the relative offset and the parent axis.

```julia
using StaticArrayInterface: axes_types, parent_type, to_dims
# Note that generating a `Tuple` type piecewise like may be type unstable and should be
# tested using `Test.@inferred`. It's often necessary to use generated function
# (`@generated`) or methods defined in Static.jl.
@generated function StaticArrayInterface.axes_types(::Type{A}) where {A<:OffsetArray}
    out = Expr(:curly, :Tuple)
    P = parent_type(A)
    for dim in 1:ndims(A)
        # offset relative to parent array
        O = relative_known_offsets(A, dim)
        if O === nothing  # offset is not known at compile time and is an `Int`
            push!(out.args, :(IdOffsetRange{Int, axes_types($P, $(static(dim)))}))
        else # offset is known, therefore it is a `StaticInt`
            push!(out.args, :(IdOffsetRange{StaticInt{$O}, axes_types($P, $(static(dim))}))
        end
    end
end
function Base.axes(A::OffsetArray)
    map(IdOffsetRange, StaticArrayInterface.static_axes(parent(A)), relative_offsets(A))
end
function Base.axes(A::OffsetArray, dim)
    d = to_dims(A, dim)
    IdOffsetRange(StaticArrayInterface.static_axes(parent(A), d), relative_offsets(A, d))
end
```

Defining these two methods ensures that other array types that wrap `OffsetArray` and appropriately define these methods 
propagate offsets independent of any dependency on `OffsetArray`.
It is entirely optional to define `StaticArrayInterface.static_size` for `OffsetArray` because the size can be 
derived from the axes.
However, in this particularly case we should also define
 `StaticArrayInterface.static_size(A::OffsetArray)  = StaticArrayInterface.static_size(parent(A))` because the relative offsets 
 attached to `OffsetArray` do not change the size but may hide static sizes if using a relative offset that is defined with an `Int`.

## Processing Indices (`static_to_indices`)

For most users, the only reason you should use `StaticArrayInterface.static_to_indices` over `Base.to_indices` is that it's 
faster and perhaps some of the more detailed benefits described in the [`to_indices`](@ref) doc string.
For those interested in how this is accomplished, the following steps (beginning with the `to_indices(A::AbstractArray, I::Tuple)`) 
are used to accomplish this:

1. The number of dimensions that each indexing argument in `I` corresponds to is determined using using the [`ndims_index`](@ref) and [`is_splat_index`](@ref) traits.
2. A non-allocating reference to each axis of `A` is created (`lazy_axes(A) -> axs`). These are aligned to each the index arguments using information from the first step. For example, if an index argument maps to a single dimension then it is paired with `axs[dim]`. In the case of multiple dimensions it is paired with `CartesianIndices(axs[dim_1], ... axs[dim_n])`. These pairs are further processed using `to_index(axis, I[n])`.
3. Tuples returned from `to_index` are flattened out so that there are no nested tuples returned from `to_indices`.

Entry points:

* `static_to_indices(::ArrayType, indices)` : dispatch on unique array type `ArrayType`
* `to_index(axis, ::IndexType)` : dispatch on a unique indexing type, `IndexType`. `StaticArrayInterface.ndims_index(::Type{IndexType})` should also be defined in this case.
* `to_index(S::IndexStyle, axis, index)` : The index style `S` that corresponds to `axis`. This is 
